#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <unistd.h>
#include <linux/unistd.h>       /* System calls */
#include <string.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <termios.h>
#include <signal.h>
#include <setjmp.h>
#include <fcntl.h>
#include <errno.h>
#include <ioctls.h>

/*****************************************************************************/
/*                                                                           */
/*  This c-source is only intended to be print a number of EUQATES           */
/*  in form that is palatable for the assembler ``as'' on the DEC            */
/*  Alpha Linux.                                                             */
/*                                                                           */
/*****************************************************************************/

/* Steal the information what value B has, leave it in A */
#define STEAL(A,B)   printf("%s   =   0x%x\n", A, B );

/* Have a A that has the same value than in C. */
#define STEALNAME(A)   STEAL( #A, A)

/* Have a A that has the number of system call B */
#define STEALSYS(A)   STEAL( #A, __NR_##A)

int main()
{
        STEALNAME(SEEK_SET)
        STEALNAME(TCGETS)
        STEALNAME(TCSETS)
        STEALNAME(ECHO)
        STEALNAME(EAGAIN)
        STEALNAME(EINTR)
        STEALNAME(EPIPE)
        STEALNAME(VMIN)
        STEALNAME(VTIME)
        STEALNAME(ICANON)
        STEALNAME(O_RDWR)
        STEALNAME(O_RDONLY)
        STEALNAME(O_WRONLY)
        STEALNAME(O_CREAT)
        STEALNAME(O_TRUNC)
        STEALNAME(O_NONBLOCK)
        STEAL("SIZE_TERMIO", sizeof(struct termios))
        STEAL("SIZE_TIMEVAL", sizeof(struct timeval))
        STEAL("C_CELLSIZE", sizeof(int))
        STEAL("TERMIO_VMIN", VMIN)
        STEALNAME(O_NONBLOCK)

printf("#{ Numbers of system calls. See \"Linux kernel Internals\" Appendix A. }\n");
printf("#{ By M.Beck, H. Boehme e.a. Addison Wesley.                         }\n");
printf("#{ The system calls themselves are extensively documented in chapter }\n");
printf("#{ 2 of the man pages, e.g. \"man 2 exit\"}\n");
       STEALSYS(exit)
       STEALSYS(open)
       STEALSYS(close)
/* creat is equivalent to open with flags equal to O_CREAT|O_WRONLY|O_TRUNC. */
/*     STEALSYS(creat)  is not present on Alpha                              */
       STEALSYS(unlink)
       STEALSYS(read)
       STEALSYS(select)
       STEALSYS(write)
       STEALSYS(ioctl)
       STEALSYS(lseek)
       STEALSYS(execve)
       STEALSYS(fork)
       STEALSYS(wait4)          /* waitpid is implemented via wait4. See unistd.h */
printf("#{ ------------------------------------------------------------      }\n");
printf("#{   End of constants stolen from C.                                 }\n");
printf("#{ ------------------------------------------------------------      }\n");
        exit(0);
}
