
#               aiforth : a DEC ALPHA ISO FORTH by HCC FIG
# $Id: ai86.gnr,v 1.50 2002/05/31 10:30:16 albert Exp $
# Copyright (2000): Albert van der Horst, HCC FIG Holland by GNU Public License
#
#HCC FIG Holland : Hobby Computer Club, Forth Interest Group  Holland
        .psize  66,106
 .title   aiforth $Revision: 1.50 $
#
# For the generic system (to generate aiforth in an other configuration than this one):
#     http://home.hccnet.nl/a.w.m.van.der.horst/ci86gnr.html
#
# If this is a configured assembly file, it should be accompanied with configured
# documentation (texinfo, ps, html.)
# WITHOUT THE DOCUMENTATION: GIVE UP! GET THE REAL THING!
# You have a configured system, if there are NO curly brackets on the next line.
#                          
#
# Configuration of this particular version:
# 3216-bits 
# running under Linux #  with native forth I/O 
# Normally aiforth doesn't observe ISO >IN.
# Contains :
#        Security words
#         Loadable words, i.e. all of ISO CORE, more than is needed
#           for a self contained kernel.
# number of blocks limited to 256
#
 #
# This is a NASM version of ciforth created by ``m4'' from the generic listing.
# It can be assembled using ``nasm'' obtainable via :
# Source: ftp://ftp.us.kernel.org/pub/software/devel/nasm/source/
# URL: http://www.cryogen.com/Nasm/

# This version can be assembled on a Linux system by
#   nasm forth.asm -felf -o forth.o
#   ld forth.o -o forth
#And to get the smallest possible executable(optional):
#   strip forth -s -R .bss -R .comment
 # For assembling on other systems where nasm is available see the
# documentation of nasm.

.if 0
        A version of ISO FORTH for DEC Alpha PC's by
                Albert van der Horst

                in cooperation with
                HCC Forth user group
                The Netherlands
                www.forth.hccnet.nl

              based on
              FIG-FORTH
   implemented by:  Charlie Krajewski
                    205 ( BIG ) Blue Rd.
                    Middletown, CT  06457

  The listing has been made possible by the
  prior work of:
               Thomas Newman, Hayward, Ca.

 : other_acknowledgements
         John_Cassidy
         Kim_Harris
         George_Flammer
         Robert_D._Villwock #

 : for tools
         Richard M. Stallman
         Linus Torvalds

No one who programs with FORTH can afford to be without:
  "Starting Forth  by Leo Brodie" and "Thinking Forth by Leo Brodie".
   Both out of print.

This Forth is a descendant in the 300+ (RCS)- generations from fig-Forth.

For nostalgic reasons the following comment has never been removed:
   Although there is much to be said for typing in your own
   listing and getting it running, there is much to be said
   not typing in your own listing.  If you feel that 100+
   pages of plinking is nutty, contact me for availability
   of a disc with source & executable files.  Obtainable at
   a bargain basement price, prepare yourself for bargain
   basement support.

All publications of the FORTH Interest Group are public domain.
They may be further distributed by the inclusion of this
credit notice:
               This publication has been made available by:

               FORTH Interest Group
               P.O. Box 1105
               San Carlos, Ca.  94070
[I feel obliged to keep this last one in (AH). Note that although it is
based on fig-Forth no stone is left unturned.]
.endif
        .eject
# ########################################################################################
#                       PREPARATION (no code)
# ########################################################################################
FIGREL  =     4       # FIG RELEASE #
FIGREV  =     0       # FIG REVISION #
USRVER  =     0      # USER VERSION NUMBER, a digit now
#
#      VERY ELEMENTARY .
CW      =     8    # Size of a cell in Forth, not in the bootcode.
ERRORSCREEN =     48    # Screen where the error messages start.
#
#      MEMORY LAYOUT.
# These values can be changed at this single place. 
NBUF    =     8      # NO. OF BUFFERS AKA SCREENS 
KBBUF   =     1024    #DATA BYTES PER DISK BUFFER
US      =     0x40*CW     # USER VARIABLE SPACE
EM      =     0x04000000    #Where the memory ends w.r.t. ORIG.

RTS     =  0x10000    # RETURN STACK & TERM BUFFER 
#
PMASK   =     0x0FF    # Allow to access only 256 blocks from OFFSET
#
#      ASCII CHARACTER EQUIVALENTS
#
ABL     =     ' '     # SPACE
ACR     =     0x0D     # CR
ASO     =     '['     # SQUARE BRACKET OPEN 
ASC     =     ']'     # SQUARE BRACKET CLOSE 
ADOT    =     '.'     # PERIOD
ALF      =     0x0A     # LINE FEED, USED INTERNALLY AS
                        # LINE ENDER
AFF      =     0x0C     # FORM FEED
BELL    =     0x07     # ^G
BSIN    =     0x08     # INPUT DELETE CHARACTER
BSOUT   =     0x08     # OUTPUT BACKSPACE ( ^H )
#
#      HEADER RELATED EQUATES
B_DUMMY   =     0x01     # dea is dummy, from vocabulary link
B_INVIS   =     0x02     # dea is invisible, "smudged".
B_IMMED   =     0x04     # dea is a immediate.
B_DENOT   =     0x08     # dea is a denotation.
C_HOFFSET =     0       # Offsets of code field in cells, w.r.t. dea
D_HOFFSET =     1       # Same for data field
F_HOFFSET =     2       # Same for flag field
L_HOFFSET =     3       # Same for link field
N_HOFFSET =     4       # Same for name field
PH_OFFSET =     5   # Past header field: Start of data area. 
BD_OFFSET =     5+1 # Start of BODY for CREATEd word.
#
 #


BPS     =     512             #Bytes/sector, common to all of MSDOS
SPB     =     KBBUF/BPS
#


SEEK_SET   =   0x0
TCGETS   =   0x402c7413
TCSETS   =   0x802c7414
ECHO   =   0x8
EAGAIN   =   0x23
EINTR   =   0x4
EPIPE   =   0x20
VMIN   =   0x10
VTIME   =   0x11
ICANON   =   0x100
O_RDWR   =   0x2
O_RDONLY   =   0x0
O_WRONLY   =   0x1
O_CREAT   =   0x200
O_TRUNC   =   0x400
O_NONBLOCK   =   0x4
SIZE_TERMIO   =   0x2c
SIZE_TIMEVAL   =   0x8
C_CELLSIZE   =   0x4
TERMIO_VMIN   =   0x10
O_NONBLOCK   =   0x4
# Numbers of system calls. See "Linux kernel Internals" Appendix A. 
# By M.Beck, H. Boehme e.a. Addison Wesley.                         
# The system calls themselves are extensively documented in chapter 
# 2 of the man pages, e.g. "man 2 exit"
exit   =   0x1
open   =   0x2d
close   =   0x6
unlink   =   0xa
read   =   0x3
select   =   0x5d
write   =   0x4
ioctl   =   0x36
lseek   =   0x13
execve   =   0x3b
fork   =   0x2
wait4   =   0x7
# ------------------------------------------------------------      
#   End of constants stolen from C.                                 
# ------------------------------------------------------------      

#SIZE_TERMIO     =     60      # sizeof(termio) also captured from c.
RAWIO           =     (ECHO | ICANON)
        .globl  _start, __start        # Entry point.         .globl  aiforth

        .section forth,"awx"

#

# ########################################################################################
#                      BOOTCODE    (optional, always real mode)
# ########################################################################################

# All bootcode must be relocatable and its memory references absolute.
# Not for the sake of booting, but to allow MSDOS to start the program too. 

ORG0:

NOBOOT:         # Skip till here if not booting.

ENDBOOT:

# ########################################################################################
#                       FILL GDT AND SWITCH TO PROTECTED MODE/32 BITS (optional)
# ########################################################################################


# ########################################################################################
#                       FORTH GLUE CODE (optional, except for the jump)
# ########################################################################################

#


aiforth:
_start:
__start:
 #
        BR      $0,LCLD
LCLD:  LDA     $29, CLD1-LCLD($0)
        LDA     $3, USINI-LCLD($0)
STQ     $30, (CW*(31))($3)#Remember ARGS.

SETUPST:
        LDQ     $30, (CW*(2))($3)    #PARAM. STACK
        LDQ     $27, (CW*(3))($3)    #RETURN STACK
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#
CLD1:   .quad      COLD    #  This is a piece of headerless high level code.
#
# ########################################################################################
#                       FORTH ITSELF (entry point : BOOTUP)
# ########################################################################################
#
.if 0
   FORTH REGISTERS
   The names under FORTH are used in the generic source.

   FORTH   8088     FORTH PRESERVATION RULES
   -----   ----     ----- ------------ -----
   HIP   $29      High level Interpreter Pointer.  Must be preserved
                    across FORTH words.

   WOR   $0      Working register.  When entering a word
                    via its code field the DEA is passed in WOR.

   SPO   $30      Parameter stack pointer.  Must be preserved
                    across FORTH words.

   RPO   $27      Return stack pointer.  Must be preserved across
                    FORTH words.

            AX      General register.  Used to pass data from
                    FORTH words, see label APUSH or macro _APUSH

            DX      General register.  Used to pass more data from
                    FORTH words, see label DPUSH or macro _DPUSH

            BX      General purpose register.

            CX      General purpose register.

            CS      Segment register. Must be preserved
                    across FORTH words.

            DS      ditto

            SS      ibid

            ES      Temporary segment register only used by
                    a few words. However it MUST remain equal to
                    DS, such that string primitives can be used
                    with impunity.

----------------------------------------------------------
.endif
        .eject
.if 0
---------------------------------------------

   COMMENT CONVENTIONS
   ------- -----------

   =       IS EQUAL TO
   <-      ASSIGNMENT

  NAME        =  Address of name
  (NAME)      =  Contents of name

  CFA         =  CODE FIELD: a pointer to executable code
  DFA         =  PARAMETER FIELD: a pointer into
  FFA         =  FLAG FIELD: contains flags
  LFA         =  LINK FIELD: a pointer
  NFA         =  NAME FIELD: a pointer to a variable number of chars
  PHA         =  POST HEADER ADDRESS

  S1          =  Parameter stack - 1st cell
  S2          =  Parameter stack - 2nd cell
  R1          =  Return stack    - 1st cell
  R2          =  Return stack    - 2nd cell

  LSB         =  Least significant bit
  MSB         =  Most  significant bit
  LB          =  Low byte
  HB          =  High byte
  LW          =  Low  cell

------------------------------------------------------------
.endif
#
        .eject
#
#
# In 32 bit versions there may be no jumps to NEXT at all 
# The label NEXT1 is rarely relevant (for _OLDDEBUG_) 
DPUSH:        SUBQ    $30, CW, $30
    STQ     $3, 0($30)      # Fall through.
APUSH:        SUBQ    $30, CW, $30
    STQ     $0, 0($30)
NEXT:
#
        LDQ     $0, 0($29)
        ADDQ      $29, CW, $29
NEXT1:    ADDQ  $0, 0, $0   # (WOR) <- (IP)
        JMP     $31, ($0)    # TO `CFA'
#
#       Dictionary starts here.

DP0:
# Vocabularies all end in a link to 0.
# Only the word FORTH links to the DENOTATION wordlist,
# that in turn links to 0.


#  *********
#  *   '   *
#  *********
#
    .align     3
N_TICK:   .quad      1
        .ascii      "'"
    .align     3
TICK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    0
        .quad    N_TICK
X_TICK:

        .quad      LPWORD, LDUP, TOR
        .quad      FOUND
        .quad      LDUP, ZEQU
        .quad      LIT, 11, QERR
        .quad      LDUP, TNFA, FETCH, FETCH #  Get precise length.
        .quad      FROMR, EQUAL, ZEQU
        .quad      LIT, 11, QERR #  to prevent match for denotation.
        .quad      LITER
        .quad      SEMIS
#

#  *********
#  *   &   *
#  *********
#
    .align     3
N_DCHAR:   .quad      1
        .ascii      "&"
    .align     3
DCHAR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    TICK-(CW*(C_HOFFSET))
        .quad    N_DCHAR
X_DCHAR:

        .quad      INBRS
        .quad      SWAP, DROP
        .quad      LDUP, QBL
        .quad      LIT, 10, QERR
        .quad      LITER
        .quad      QDELIM
        .quad      SEMIS
#

#  *********
#  *   ^   *
#  *********
#
    .align     3
N_DCTL:   .quad      1
        .ascii      "^"
    .align     3
DCTL:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    DCHAR-(CW*(C_HOFFSET))
        .quad    N_DCTL
X_DCTL:

        .quad      INBRS
        .quad      SWAP, DROP
        .quad      LDUP, QBL
        .quad      LIT, 10, QERR
        .quad      LIT, '@', LSUB
        .quad      LITER
        .quad      QDELIM
        .quad      SEMIS
#

#  *********
#  *   0   *
#  *********
#
    .align     3
N_DEN0:   .quad      1
        .ascii      "0"
    .align     3
DEN0:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DCTL-(CW*(C_HOFFSET))
        .quad    N_DEN0
X_DEN0:

#  *********
#  *   1   *
#  *********
#
    .align     3
N_DEN1:   .quad      1
        .ascii      "1"
    .align     3
DEN1:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN0-(CW*(C_HOFFSET))
        .quad    N_DEN1
X_DEN1:

#  *********
#  *   2   *
#  *********
#
    .align     3
N_DEN2:   .quad      1
        .ascii      "2"
    .align     3
DEN2:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN1-(CW*(C_HOFFSET))
        .quad    N_DEN2
X_DEN2:

#  *********
#  *   3   *
#  *********
#
    .align     3
N_DEN3:   .quad      1
        .ascii      "3"
    .align     3
DEN3:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN2-(CW*(C_HOFFSET))
        .quad    N_DEN3
X_DEN3:

#  *********
#  *   4   *
#  *********
#
    .align     3
N_DEN4:   .quad      1
        .ascii      "4"
    .align     3
DEN4:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN3-(CW*(C_HOFFSET))
        .quad    N_DEN4
X_DEN4:

#  *********
#  *   5   *
#  *********
#
    .align     3
N_DEN5:   .quad      1
        .ascii      "5"
    .align     3
DEN5:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN4-(CW*(C_HOFFSET))
        .quad    N_DEN5
X_DEN5:

#  *********
#  *   6   *
#  *********
#
    .align     3
N_DEN6:   .quad      1
        .ascii      "6"
    .align     3
DEN6:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN5-(CW*(C_HOFFSET))
        .quad    N_DEN6
X_DEN6:

#  *********
#  *   7   *
#  *********
#
    .align     3
N_DEN7:   .quad      1
        .ascii      "7"
    .align     3
DEN7:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN6-(CW*(C_HOFFSET))
        .quad    N_DEN7
X_DEN7:

#  *********
#  *   8   *
#  *********
#
    .align     3
N_DEN8:   .quad      1
        .ascii      "8"
    .align     3
DEN8:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN7-(CW*(C_HOFFSET))
        .quad    N_DEN8
X_DEN8:

#  *********
#  *   9   *
#  *********
#
    .align     3
N_DEN9:   .quad      1
        .ascii      "9"
    .align     3
DEN9:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN8-(CW*(C_HOFFSET))
        .quad    N_DEN9
X_DEN9:

#  *********
#  *   A   *
#  *********
#
    .align     3
N_DENA:   .quad      1
        .ascii      "A"
    .align     3
DENA:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEN9-(CW*(C_HOFFSET))
        .quad    N_DENA
X_DENA:

#  *********
#  *   B   *
#  *********
#
    .align     3
N_DENB:   .quad      1
        .ascii      "B"
    .align     3
DENB:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DENA-(CW*(C_HOFFSET))
        .quad    N_DENB
X_DENB:

#  *********
#  *   C   *
#  *********
#
    .align     3
N_DENC:   .quad      1
        .ascii      "C"
    .align     3
DENC:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DENB-(CW*(C_HOFFSET))
        .quad    N_DENC
X_DENC:

#  *********
#  *   D   *
#  *********
#
    .align     3
N_DEND:   .quad      1
        .ascii      "D"
    .align     3
DEND:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DENC-(CW*(C_HOFFSET))
        .quad    N_DEND
X_DEND:

#  *********
#  *   E   *
#  *********
#
    .align     3
N_DENE:   .quad      1
        .ascii      "E"
    .align     3
DENE:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DEND-(CW*(C_HOFFSET))
        .quad    N_DENE
X_DENE:

#  *********
#  *   F   *
#  *********
#
    .align     3
N_DENF:   .quad      1
        .ascii      "F"
    .align     3
DENF:        .quad    DOCOL
        .quad   LNUMB
        .quad    B_IMMED + B_DENOT
        .quad    DENE-(CW*(C_HOFFSET))
        .quad    N_DENF
X_DENF:

#

#  *********
#  *   -   *
#  *********
#
    .align     3
N_DENM:   .quad      1
        .ascii      "-"
    .align     3
DENM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    DENF-(CW*(C_HOFFSET))
        .quad    N_DENM
X_DENM:

        .quad      PNUMB, DNEGA, SDLITE
        .quad      SEMIS
#

#  *********
#  *   +   *
#  *********
#
    .align     3
N_DENP:   .quad      1
        .ascii      "+"
    .align     3
DENP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    DENM-(CW*(C_HOFFSET))
        .quad    N_DENP
X_DENP:

        .quad      PNUMB, SDLITE
        .quad      SEMIS
#

#  *********
#  *   "   *
#  *********
#
    .align     3
N_DENQ:   .quad      1
        .ascii      "\""
    .align     3
DENQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED + B_DENOT
        .quad    DENP-(CW*(C_HOFFSET))
        .quad    N_DENQ
X_DENQ:

        .quad      LIT, SKIP, COMMA        #  'SKIP , HERE >R 0 ,
        .quad      HERE, TOR, ZERO, COMMA
DENQ1:
        .quad      LIT, '"', PPARS         #           BEGIN &" (PARSE)
        .quad      INBRS, LDUP, LIT, '"', EQUAL #           IN[] DUP &" =
        .quad      ZBRAN
        .quad      DENQ2-.-CW                 #           WHILE
        .quad      TDROP, ONEP             #           2DROP 1+ R@ $+!
        .quad      LDUP, ALLOT, RR, SADD
        .quad      BRAN
        .quad      DENQ1-.-CW                  #           REPEAT
DENQ2:
        .quad      QBL, ZEQU
        .quad      LIT, 10, QERR           #           ?BLANK 0= 5 ?ERROR
        .quad      DROP                    #                DROP R@ $+!
        .quad      LDUP, ALLOT, RR, SADD
 .quad LALIGN
        .quad      FROMR, SFET, DLITE      #           R> $@ POSTPONE DLITERAL ;
        .quad      SEMIS
#

# The FORTH vocabulary is the only one not to link to zero.
# It links to the DENOTATION vocabulary.
#  *************
#  *   FORTH   *
#  *************
#
    .align     3
N_FORTH:   .quad      5
        .ascii      "FORTH"
    .align     3
FORTH:        .quad    DODOE
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DENOTBODY 
        .quad    N_FORTH
X_FORTH:

        .quad      DOVOC
        .quad      0       # END OF VOCABULARY LIST

    .align     3
        .quad    0
        .quad   0
        .quad    B_DUMMY
        .quad    TASK-(CW*(C_HOFFSET))
        .quad    0


#
#

#  ************
#  *   CORE   *
#  ************
#
    .align     3
N_CORE:   .quad      4
        .ascii      "CORE"
    .align     3
CORE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    0
        .quad    N_CORE
X_CORE:

        .quad      ZERO    # Not (fully) present.
        .quad      SEMIS
#

#  ***********
#  *   CPU   *
#  ***********
#
    .align     3
N_CPU:   .quad      3
        .ascii      "CPU"
    .align     3
CPU:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CORE-(CW*(C_HOFFSET))
        .quad    N_CPU
X_CPU:

       .quad      LIT, 17808958, ZERO        # 'ALPHA' 
       .quad      SEMIS
#

#  ***************
#  *   VERSION   *
#  ***************
#
    .align     3
N_LVERSION:   .quad      7
        .ascii      "VERSION"
    .align     3
LVERSION:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CPU-(CW*(C_HOFFSET))
        .quad    N_LVERSION
X_LVERSION:

.if 0
#       If this is there it is an official release
        .quad      SKIP
        .quad      22
IBMPC:  .byte      'IBM-PC ciforth'
        .byte      FIGREL+40H,ADOT,FIGREV+30H,ADOT,USRVER+30H
        .quad      LIT, IBMPC, LIT, 22
.endif
#       If M4_VERSION exists and contains a . it is an official release
        .quad      SKIP
         .quad      3
SB0: .ascii      "2.0"
       .align     3
        .quad      LIT, SB0
        .quad      LIT, 3
        .quad      SEMIS
#

#  ************
#  *   NAME   *
#  ************
#
    .align     3
N_LNAME:   .quad      4
        .ascii      "NAME"
    .align     3
LNAME:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LVERSION-(CW*(C_HOFFSET))
        .quad    N_LNAME
X_LNAME:

        .quad      SKIP
         .quad      7
SB1: .ascii      "ciforth"
       .align     3
        .quad      LIT, SB1
        .quad      LIT, 7
        .quad      SEMIS
#

#  ****************
#  *   SUPPLIER   *
#  ****************
#
    .align     3
N_SUPPLIER:   .quad      8
        .ascii      "SUPPLIER"
    .align     3
SUPPLIER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LNAME-(CW*(C_HOFFSET))
        .quad    N_SUPPLIER
X_SUPPLIER:

        .quad      SKIP
         .quad      20
SB2: .ascii      "Albert van der Horst"
       .align     3
        .quad      LIT, SB2
        .quad      LIT, 20
        .quad      SEMIS
#
#

#  ******************
#  *   DENOTATION   *
#  ******************
#
    .align     3
N_DENOT:   .quad      10
        .ascii      "DENOTATION"
    .align     3
DENOT:        .quad    DODOE
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    FORTH
        .quad    N_DENOT
X_DENOT:

        .quad      DOVOC
        .quad      FORTH-(CW*(C_HOFFSET))     # NEXT VOCABULARY 
DENOTBODY:

    .align     3
        .quad    0
        .quad   0
        .quad    B_DUMMY
        .quad    DENQ-(CW*(C_HOFFSET))
        .quad    0


#

#  *******************
#  *   ENVIRONMENT   *
#  *******************
#
    .align     3
N_ENV:   .quad      11
        .ascii      "ENVIRONMENT"
    .align     3
ENV:        .quad    DODOE
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DENOT-(CW*(C_HOFFSET))
        .quad    N_ENV
X_ENV:

        .quad      DOVOC
        .quad      DENOT-(CW*(C_HOFFSET))       # NEXT VOCABULARY 

    .align     3
        .quad    0
        .quad   0
        .quad    B_DUMMY
        .quad    SUPPLIER-(CW*(C_HOFFSET))
        .quad    0


#

#  ************
#  *   NOOP   *
#  ************
#
    .align     3
N_NOOP:   .quad      4
        .ascii      "NOOP"
    .align     3
NOOP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ENV-(CW*(C_HOFFSET))
        .quad    N_NOOP
X_NOOP:

       LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#
#
#

#  ***********
#  *   LIT   *
#  ***********
#
    .align     3
N_LIT:   .quad      3
        .ascii      "LIT"
    .align     3
LIT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    NOOP-(CW*(C_HOFFSET))
        .quad    N_LIT
X_LIT:

        LDQ     $0, 0($29)
        ADDQ      $29, CW, $29
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             # TO TOP OF STACK
#
#  *************
#  *   AMASK   *
#  *************
#
    .align     3
N_AMASK:   .quad      5
        .ascii      "AMASK"
    .align     3
AMASK:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LIT-(CW*(C_HOFFSET))
        .quad    N_AMASK
X_AMASK:

        SUBQ    $31, 1, $1
        AMASK     $1,$0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             # TO TOP OF STACK
#

#  ***************
#  *   EXECUTE   *
#  ***************
#
    .align     3
N_EXEC:   .quad      7
        .ascii      "EXECUTE"
    .align     3
EXEC:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    AMASK-(CW*(C_HOFFSET))
        .quad    N_EXEC
X_EXEC:

        LDQ     $0, 0($30)
        ADDQ      $30, CW, $30      # GET CFA
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0
#


#  ***************
#  *   RECURSE   *
#  ***************
#
    .align     3
N_RECURSE:   .quad      7
        .ascii      "RECURSE"
    .align     3
RECURSE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    EXEC-(CW*(C_HOFFSET))
        .quad    N_RECURSE
X_RECURSE:

        .quad      LATEST, COMMA
        .quad      SEMIS
#
#

#  **************
#  *   BRANCH   *
#  **************
#
    .align     3
N_BRAN:   .quad      6
        .ascii      "BRANCH"
    .align     3
BRAN:        .quad    (SKIP+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RECURSE-(CW*(C_HOFFSET))
        .quad    N_BRAN
X_BRAN:

#

#  ************
#  *   SKIP   *
#  ************
#
    .align     3
N_SKIP:   .quad      4
        .ascii      "SKIP"
    .align     3
SKIP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BRAN-(CW*(C_HOFFSET))
        .quad    N_SKIP
X_SKIP:

BRAN1:  LDQ     $0, 0($29)

        SUBQ     $0, 1, $0
        BIS      $0, (CW*(1))-1, $0
        ADDQ     $0, 1, $0
#
        ADDQ     $29, (CW*(1)), $29
        ADDQ     $29, $0, $29
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***************
#  *   0BRANCH   *
#  ***************
#
    .align     3
N_ZBRAN:   .quad      7
        .ascii      "0BRANCH"
    .align     3
ZBRAN:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SKIP-(CW*(C_HOFFSET))
        .quad    N_ZBRAN
X_ZBRAN:

        LDQ     $0, 0($30)
        ADDQ      $30, CW, $30      # GET STACK VALUE
        BEQ      $0, BRAN1   # YES, BRANCH
        ADDQ    $29, +(CW*(1)), $29
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   (LOOP)   *
#  **************
#
    .align     3
N_XLOOP:   .quad      6
        .ascii      "(LOOP)"
    .align     3
XLOOP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ZBRAN-(CW*(C_HOFFSET))
        .quad    N_XLOOP
X_XLOOP:

        BIS    $31, 1, $1    # INCREMENT
XLOO1:
        LDQ     $2, 0($27) # INDEX = INDEX + INCR
        LDQ     $0, (CW*(1))($27)
        ADDQ     $2, $1, $2 # INDEX = INDEX + INCR
        STQ     $2, 0($27) # INDEX = INDEX + INCR
        SUBQ     $2, $0, $0       # COMPARE WITH LIMIT
        XOR     $1, $0, $0
        BLT     $0, BRAN1   # KEEP LOOPING
#
#  END OF `DO' LOOP
        ADDQ    $27, +(CW*(3)), $27  # ADJ RETURN STACK
        ADDQ    $29, +(CW*(1)), $29       # BYPASS BRANCH OFFSET
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***************
#  *   (+LOOP)   *
#  ***************
#
    .align     3
N_XPLOO:   .quad      7
        .ascii      "(+LOOP)"
    .align     3
XPLOO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    XLOOP-(CW*(C_HOFFSET))
        .quad    N_XPLOO
X_XPLOO:

        LDQ     $1, 0($30)
        ADDQ      $30, CW, $30      # GET LOOP VALUE
        BR      $31, XLOO1
#

#  ************
#  *   (DO)   *
#  ************
#
    .align     3
N_XDO:   .quad      4
        .ascii      "(DO)"
    .align     3
XDO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    XPLOO-(CW*(C_HOFFSET))
        .quad    N_XDO
X_XDO:

        LDQ     $1, 0($29) # Get inline relative target.
        ADDQ    $29, (CW*(1)), $29
        ADDQ    $29 , $1, $1#Make absolute
        LDQ     $3, 0($30)
        ADDQ      $30, CW, $30      # INITIAL INDEX VALUE
        LDQ     $0, 0($30)
        ADDQ      $30, CW, $30      # LIMIT VALUE
        SUBQ    $27, (CW*(3)), $27
        STQ     $1, (CW*(2))($27)      # Target location.
        STQ     $0, (CW*(1))($27)
        STQ     $3, (CW*(0))($27)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   (?DO)   *
#  *************
#
    .align     3
N_XQDO:   .quad      5
        .ascii      "(?DO)"
    .align     3
XQDO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    XDO-(CW*(C_HOFFSET))
        .quad    N_XQDO
X_XQDO:

        LDQ     $1, 0($29) # Get inline relative target.
        ADDQ    $29 , (CW*(1)), $29
        ADDQ    $29 , $1, $1#Make absolute
        LDQ     $3, 0($30)
        ADDQ      $30, CW, $30      # INITIAL INDEX VALUE
        LDQ     $0, 0($30)
        ADDQ    $30, CW, $30      # LIMIT VALUE
        CMPEQ   $0, $3, $3
        BNE     $3, QXDO1
        SUBQ    $27, (CW*(3)), $27
        STQ     $1, (CW*(2))($27)      # Target location.
        STQ     $0, (CW*(1))($27)
        STQ     $3, (CW*(0))($27)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
QXDO1:   BIS    $31, $1, $29
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   I   *
#  *********
#
    .align     3
N_IDO:   .quad      1
        .ascii      "I"
    .align     3
IDO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    XQDO-(CW*(C_HOFFSET))
        .quad    N_IDO
X_IDO:

        LDQ     $0, 0($27) # GET INDEX VALUE
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             # TO PARAMETER STACK
#

#  *********
#  *   J   *
#  *********
#
    .align     3
N_JDO:   .quad      1
        .ascii      "J"
    .align     3
JDO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    IDO-(CW*(C_HOFFSET))
        .quad    N_JDO
X_JDO:

        LDQ     $0, (CW*(3))($27) # GET INDEX VALUE
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             # TO PARAMETER STACK
#

#  **************
#  *   UNLOOP   *
#  **************
#
    .align     3
N_UNLOOP:   .quad      6
        .ascii      "UNLOOP"
    .align     3
UNLOOP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    JDO-(CW*(C_HOFFSET))
        .quad    N_UNLOOP
X_UNLOOP:

        .quad      LIT, RDROP, COMMA
        .quad      LIT, RDROP, COMMA
        .quad      LIT, RDROP, COMMA
        .quad      SEMIS
#

#  ***************
#  *   +ORIGIN   *
#  ***************
#
    .align     3
N_PORIG:   .quad      7
        .ascii      "+ORIGIN"
    .align     3
PORIG:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    UNLOOP-(CW*(C_HOFFSET))
        .quad    N_PORIG
X_PORIG:

        .quad      LIT
        .quad      USINI
        .quad      PLUS
        .quad      SEMIS
#
#      Initialisation block for user variables through VOC-LINK
#       <<<<< must be in same order as user variables >>>>>
#
#        .quad      WARM_ENTRY FIXME
#        .quad      COLD_ENTRY
USINI:  .quad      STRUSA  # User area currently in use, cold value same as next.
        .quad      STRUSA  # INIT (U0) user area of the main task 1
        .quad      INITS0  # INIT (S0)         2
        .quad      INITR0  # INIT (R0)         3
        .quad      STRTIB  # INIT (TIB)        4
        .quad      BSIN    # RUBOUT: get rid of latest char 5
        .quad      0       # AVAILABLE         6
        .quad      1       # INIT (WARNING)     7
        .quad      INITDP  #      INIT (FENCE)  8
        .quad      INITDP  #      INIT (DP)     9
        .quad      ENV-(CW*(C_HOFFSET)) #       INIT (VOC-LINK) 10

        .quad      0       # INIT (OFFSET) 
#
#
        .quad      0, 0            # WHERE             12 13 
        .quad      0, STRTIB       #REMAINDER   14 15 
        .space    US-(. - USINI)        # All user can be initialised.
#
#      <<<<< end of data used by cold start >>>>>

#  *************
#  *   DIGIT   *
#  *************
#
    .align     3
N_DIGIT:   .quad      5
        .ascii      "DIGIT"
    .align     3
DIGIT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PORIG-(CW*(C_HOFFSET))
        .quad    N_DIGIT
X_DIGIT:

        LDQ     $0, (CW*(0))($30) #NUMBER BASE
        LDQ     $3, (CW*(1))($30)         #ASCII DIGIT
        ADDQ    $30, (CW*(2)), $30
        SUBQ     $3,'0', $3
        BLT      $3, DIGI2   #NUMBER ERROR
        CMPLT    $3, 10, $1
        BNE     $1, DIGI1   #NUMBER = 0 THRU 9
        SUBQ     $3,'A'-'9'-1, $3
        CMPLT    $3,10,$1   #NUMBER 'A' THRU 'Z'?
        BNE      $1, DIGI2   #NO
# Note: an unsigned compare in this context tests a range.
DIGI1:    CMPULT  $3, $0, $2 # Generate carry in $2
        BEQ     $2, DIGI2   #NUMBER ERROR
        SUBQ    $31, 1, $0    #TRUE FLAG
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             #ADD TO STACK
#   NUMBER ERROR
DIGI2:    BIS    $31, 0, $0
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   RESULT   *
#  **************
#
    .align     3
N_RESULT:   .quad      6
        .ascii      "RESULT"
    .align     3
RESULT:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DIGIT-(CW*(C_HOFFSET))
        .quad    N_RESULT
X_RESULT:

        .quad 0
#

#  **********************
#  *   MATCHING-WORDS   *
#  **********************
#
    .align     3
N_MATCHING:   .quad      14
        .ascii      "MATCHING-WORDS"
    .align     3
MATCHING:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RESULT-(CW*(C_HOFFSET))
        .quad    N_MATCHING
X_MATCHING:

        .quad      TOR
        .quad      RR, TFFA, FETCH
        .quad      LIT, B_INVIS | B_DUMMY, LAND #Get flags.
        .quad      ZEQU
        .quad      ZBRAN
        .quad      MATS2-.-CW
#       .quad      RR, IDDOT
        .quad      RR, TNFA, FETCH, FETCH
        .quad      OVER, LSUB
        .quad      RR, TFFA, FETCH, LIT, B_DENOT, LAND #Get flag.
        .quad      OVER, ZLESS, LAND  #Ignorable length difference.
        .quad      ZEQU, LAND
        .quad      ZEQU
        .quad      ZBRAN
        .quad      MATS2-.-CW
        .quad      OVER
        .quad      RR, TNFA, FETCH, SFET
        .quad      CORA, ZEQU  # Compare equals.
        .quad      ZBRAN
        .quad      MATS2-.-CW
        .quad      FROMR, FROMR
        .quad      RDROP, ZERO, TOR #FORCE END
        .quad      TOR, TOR
        .quad      RR, RESULT, STORE
MATS2:  .quad      RDROP
        .quad      SEMIS
#

#  **************
#  *   ?BLANK   *
#  **************
#
    .align     3
N_QBL:   .quad      6
        .ascii      "?BLANK"
    .align     3
QBL:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MATCHING-(CW*(C_HOFFSET))
        .quad    N_QBL
X_QBL:

        .quad      LBL, ONEP, LESS
        .quad      SEMIS
#

#  ************
#  *   IN[]   *
#  ************
#
    .align     3
N_INBRS:   .quad      4
        .ascii      "IN[]"
    .align     3
INBRS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QBL-(CW*(C_HOFFSET))
        .quad    N_INBRS
X_INBRS:

        .quad      SRC, CELLP, TFET
        .quad      OVER, EQUAL
        .quad      ZBRAN
        .quad      INBRS1-.-CW
        .quad      ZERO
        .quad      BRAN
        .quad      INBRS2-.-CW
INBRS1:
        .quad      LDUP
        
        .quad      CFET
        .quad      ONE, LIN, PSTORE
INBRS2:
        .quad      SEMIS
#

#  **************
#  *   (WORD)   *
#  **************
#
    .align     3
N_LPWORD:   .quad      6
        .ascii      "(WORD)"
    .align     3
LPWORD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    INBRS-(CW*(C_HOFFSET))
        .quad    N_LPWORD
X_LPWORD:

        .quad      X
PWORD0: .quad      DROP
        .quad      INBRS, QBL
        .quad      OVER, SRC, CELLP, FETCH, LSUB # At end?
        .quad      LAND, ZEQU
        .quad      ZBRAN
        .quad      PWORD0-.-CW

        .quad      X
PWORD1: .quad      DROP
        .quad      INBRS, QBL
        .quad      ZBRAN
        .quad      PWORD1-.-CW

        .quad OVER, LSUB
        
        .quad      SEMIS
#

#  ***************
#  *   (PARSE)   *
#  ***************
#
    .align     3
N_PPARS:   .quad      7
        .ascii      "(PARSE)"
    .align     3
PPARS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LPWORD-(CW*(C_HOFFSET))
        .quad    N_PPARS
X_PPARS:

        .quad      SRC, CELLP, TFET
        .quad      OVER, LSUB
        
        .quad      ROT, SSPLIT, TSWAP
        .quad      ZEQU
        .quad      ZBRAN
        .quad      PPARS8-.-CW
        .quad      DROP, SRC, CELLP, FETCH
PPARS8: 
        .quad      LIN, STORE
        .quad SEMIS
#

#  ***********
#  *   SRC   *
#  ***********
#
    .align     3
N_SRC:   .quad      3
        .ascii      "SRC"
    .align     3
SRC:        .quad    DOUSE
        .quad   (CW*(27))
        .quad    0
        .quad    PPARS-(CW*(C_HOFFSET))
        .quad    N_SRC
X_SRC:
      # And 28 and 29.
#


#  **************
#  *   SOURCE   *
#  **************
#
    .align     3
N_SOURCE:   .quad      6
        .ascii      "SOURCE"
    .align     3
SOURCE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SRC-(CW*(C_HOFFSET))
        .quad    N_SOURCE
X_SOURCE:

        .quad      SRC, FETCH
        .quad      SRC, CELLP, FETCH
        .quad      OVER, LSUB
        .quad      SEMIS
#

#  ***********
#  *   >IN   *
#  ***********
#
    .align     3
N_IIN:   .quad      3
        .ascii      ">IN"
    .align     3
IIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SOURCE-(CW*(C_HOFFSET))
        .quad    N_IIN
X_IIN:

        .quad      LIN, FETCH
.quad      SRC, FETCH, LSUB     
        .quad      PIIN, STORE
        .quad      PIIN
        .quad      SEMIS
#
#

#  **********
#  *   CR   *
#  **********
#
    .align     3
N_CR:   .quad      2
        .ascii      "CR"
    .align     3
CR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    IIN-(CW*(C_HOFFSET))
        .quad    N_CR
X_CR:

        .quad      LIT,ALF
        .quad      EMIT
        .quad      ZERO, LOUT, STORE
        .quad      SEMIS
#

#  *************
#  *   CMOVE   *
#  *************
#
    .align     3
N_LCMOVE:   .quad      5
        .ascii      "CMOVE"
    .align     3
LCMOVE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CR-(CW*(C_HOFFSET))
        .quad    N_LCMOVE
X_LCMOVE:

        LDQ     $2, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        LDQ     $1, (CW*(2))($30)
        ADDQ      $30, (CW*(3)), $30      #source
        BEQ     $2, CMOV1
CMOV2:
        SUBQ    $2, 1, $2
        LDBU    $3, 0($1)
        ADDQ    $1, 1, $1
        STB     $3, 0($0)
        ADDQ    $0, 1, $0
        BNE     $2, CMOV2
CMOV1:
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   MOVE   *
#  ************
#
    .align     3
N_LMOVE:   .quad      4
        .ascii      "MOVE"
    .align     3
LMOVE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LCMOVE-(CW*(C_HOFFSET))
        .quad    N_LMOVE
X_LMOVE:

        LDQ     $2, (CW*(0))($30)     #count
        LDQ     $0, (CW*(1))($30)     #dest
        LDQ     $1, (CW*(2))($30)     #source
        ADDQ      $30, (CW*(3)), $30
        CMPULT  $1,$0,$3  # GENERATE CARRY in $3
        BIS     $31, 1, $4  # +1. 
        BEQ     $3, MOV3
        SUBQ    $2, 1, $4  # From above. 
        ADDQ    $1, $4, $1
        ADDQ    $0, $4, $0
        SUBQ    $31, 1, $4  # -1. 
MOV3:
#
        BEQ     $2, MOV1
MOV2:
        SUBQ    $2, 1, $2
        LDBU    $3, 0($1)
        ADDQ    $1, $4, $1
        STB     $3, 0($0)
        ADDQ    $0, $4, $0
        BNE     $2, MOV2
MOV1:
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   UM*   *
#  ***********
#
    .align     3
N_USTAR:   .quad      3
        .ascii      "UM*"
    .align     3
USTAR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LMOVE-(CW*(C_HOFFSET))
        .quad    N_USTAR
X_USTAR:

        LDQ     $2, (CW*(0))($30)
        LDQ     $1, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
        MULQ     $1,$2,$3      #UNSIGNED
        UMULH     $1,$2,$0
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             #STORE DOUBLE CELL
#

#  **************
#  *   UM/MOD   *
#  **************
#
    .align     3
N_USLAS:   .quad      6
        .ascii      "UM/MOD"
    .align     3
USLAS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    USTAR-(CW*(C_HOFFSET))
        .quad    N_USLAS
X_USLAS:







# $1 is scratch
        LDQ     $4, (CW*(0))($30)        #LSW OF DIVISOR
        LDQ     $3, (CW*(1))($30)        #MSW OF DIVIDEND
        LDQ     $2, (CW*(2))($30)        #LSW OF DIVIDEND
        ADDQ    $30, (CW*(3)), $30

        BIS     $31,1,$5
        BIS     $31,0,$0
        SLL     $5, 63, $5
        CMPULT  $3, $4, $1
        BEQ     $1, DZERO      #Overflow.

UMSLAS3:
        CMPLT   $2, $31, $1
        CMPLT   $3, $31, $6
        SLL     $3, 1, $3
        SLL     $2, 1, $2
        ADDQ    $3, $1, $3
        CMPULE  $4,$3,$1
        BIS     $1, $6, $1

        BEQ     $1,UMSLAS2
        ADDQ    $0,$5,$0
        SUBQ    $3,$4,$3
UMSLAS2:

        SRL     $5,1,$5
        BNE     $5, UMSLAS3
UMSLAS9:

                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   








#  **********
#  *   U2   *
#  **********
#
    .align     3
N_UMSLAS:   .quad      2
        .ascii      "U2"
    .align     3
UMSLAS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    USLAS-(CW*(C_HOFFSET))
        .quad    N_UMSLAS
X_UMSLAS:







        LDQ     $1, (CW*(0))($30)        #LSW OF DIVISOR
        LDQ     $0, (CW*(1))($30)        #MSW OF DIVIDEND
        LDQ     $3, (CW*(2))($30)        #LSW OF DIVIDEND
        ADDQ      $30, (CW*(3)), $30
        BEQ     $1, DZERO                  /* div by zero */
        BIS     $31,1,$5

        /*  $1 left */
USLAS1:      CMPULT  $1,$3,$2
        BLT     $1, USLAS3
        ADDQ    $1,$1,$1
        ADDQ    $5,$5,$5
        BNE     $2,USLAS1

        /* ok, start to go right again.. */
USLAS2:      SRL     $1,1,$1
        BEQ     $5, USLAS9
        SRL     $5,1,$5
USLAS3:      CMPULE  $1,$3,$2
        BEQ     $2,USLAS2
        ADDQ    $0,$5,$0
        BEQ     $5,USLAS9
        SUBQ    $3,$1,$3
        BR      $31, USLAS2
USLAS9:
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   









#
#
#      DIVIDE BY ZERO ERROR - SHOW MAX NUMBERS
DZERO:  SUBQ    $31, 1, $0
    ADDQ  $0, 0, $3
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0             #STORE QUOT/REM
#
#########BIS     zero, 64, count
## Despite the ADDQ/SUBQ we need not initialise quot.
#
#FM1:
## Loop invariant: (mod<<(64-count)) + (quot<<(64-count))*div
#########BEQ     modh, FMENDIF
#########BLT     modh, FMELSE
#########ADDQ    quot, 1, quot
#########SUBQ    modh, div, modh
#########BR      FMENDIF
#FMELSE:
#########SUBQ    quot, 1, quot
#########ADDQ    modh, div, modh
#FMENDIF:
#########BEQ     count, FM2
#########CMPLT   modl, zero, $0 # Carry bit to $0
#########SLL     modh, 1, modh
#########SLL     modl, 1, modl
#########ADDQ    modh, $0, modh
#########SLL     quot, 1, quot
#########SUBQ    count, 1, count
#########BR      FM1
#FM2:
#########BLT    modh, FM1
#
#########SUBQ    zero, modh, $0
#########CMOVNE  signdiv, $0, modh
#
#########STQ     modh, (CW*(1))($30)        #Modulus
#########STQ     quot, (CW*(0))($30)        #Remainder


#  ***********
#  *   AND   *
#  ***********
#
    .align     3
N_LAND:   .quad      3
        .ascii      "AND"
    .align     3
LAND:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    UMSLAS-(CW*(C_HOFFSET))
        .quad    N_LAND
X_LAND:

        LDQ     $0, (CW*(0))($30)
        LDQ     $1, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
    AND  $1, $0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   OR   *
#  **********
#
    .align     3
N_LOR:   .quad      2
        .ascii      "OR"
    .align     3
LOR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LAND-(CW*(C_HOFFSET))
        .quad    N_LOR
X_LOR:

        LDQ     $0, (CW*(0))($30)
        LDQ     $1, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
    BIS  $1, $0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   XOR   *
#  ***********
#
    .align     3
N_LXOR:   .quad      3
        .ascii      "XOR"
    .align     3
LXOR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LOR-(CW*(C_HOFFSET))
        .quad    N_LXOR
X_LXOR:

        LDQ     $0, (CW*(0))($30)
        LDQ     $1, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30
        XOR     $1, $0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   INVERT   *
#  **************
#
    .align     3
N_INVERT:   .quad      6
        .ascii      "INVERT"
    .align     3
INVERT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LXOR-(CW*(C_HOFFSET))
        .quad    N_INVERT
X_INVERT:

        LDQ     $0, 0($30)
        ADDQ      $30, CW, $30      # (S1) <- (S1) XOR (S2)
        NOT     $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   DSP@   *
#  ************
#
    .align     3
N_SPFET:   .quad      4
        .ascii      "DSP@"
    .align     3
SPFET:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    INVERT-(CW*(C_HOFFSET))
        .quad    N_SPFET
X_SPFET:

    ADDQ  $30, 0, $0   # (S1) <- (SP)
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   DSP!   *
#  ************
#
    .align     3
N_SPSTO:   .quad      4
        .ascii      "DSP!"
    .align     3
SPSTO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SPFET-(CW*(C_HOFFSET))
        .quad    N_SPSTO
X_SPSTO:

        LDQ     $0, 0($30)
        ADDQ      $30, CW, $30
    ADDQ  $0, 0, $30        #RESET PARAM STACK POINTER
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#


#  *************
#  *   DEPTH   *
#  *************
#
    .align     3
N_DEPTH:   .quad      5
        .ascii      "DEPTH"
    .align     3
DEPTH:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SPSTO-(CW*(C_HOFFSET))
        .quad    N_DEPTH
X_DEPTH:

        .quad      SZERO, FETCH
        .quad      SPFET
        .quad      LSUB
        .quad      LIT, CW, SLASH
        .quad      ONEM
        .quad      SEMIS
#
#

#  ************
#  *   RSP@   *
#  ************
#
    .align     3
N_RPFET:   .quad      4
        .ascii      "RSP@"
    .align     3
RPFET:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DEPTH-(CW*(C_HOFFSET))
        .quad    N_RPFET
X_RPFET:
      #(S1) <- (RP)
        SUBQ    $30, CW, $30
    STQ     $27, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   RSP!   *
#  ************
#
    .align     3
N_RPSTO:   .quad      4
        .ascii      "RSP!"
    .align     3
RPSTO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RPFET-(CW*(C_HOFFSET))
        .quad    N_RPSTO
X_RPSTO:

        LDQ     $27, 0($30)
        ADDQ      $30, CW, $30
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   EXIT   *
#  ************
#
    .align     3
N_EXIT:   .quad      4
        .ascii      "EXIT"
    .align     3
EXIT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RPSTO-(CW*(C_HOFFSET))
        .quad    N_EXIT
X_EXIT:

        LDQ     $29,0($27) #(IP) <- (R1)
        ADDQ    $27, +(CW*(1)), $27
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   (;)   *
#  ***********
#
    .align     3
N_SEMIS:   .quad      3
        .ascii      "(;)"
    .align     3
SEMIS:        .quad    (EXIT+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    EXIT-(CW*(C_HOFFSET))
        .quad    N_SEMIS
X_SEMIS:

#

#  *************
#  *   LEAVE   *
#  *************
#
    .align     3
N_LLEAV:   .quad      5
        .ascii      "LEAVE"
    .align     3
LLEAV:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SEMIS-(CW*(C_HOFFSET))
        .quad    N_LLEAV
X_LLEAV:
  #LIMIT <- INDEX
        .quad      RDROP, RDROP, RDROP
        .quad      SEMIS
#

#  **********
#  *   >R   *
#  **********
#
    .align     3
N_TOR:   .quad      2
        .ascii      ">R"
    .align     3
TOR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LLEAV-(CW*(C_HOFFSET))
        .quad    N_TOR
X_TOR:
        # (R1) <- (S1)
        LDQ     $1, 0($30)
        ADDQ      $30, CW, $30      #GET STACK PARAMETER
        SUBQ    $27,  (CW*(1)), $27    #MOVE RETURN STACK DOWN
        STQ     $1, 0($27) #ADD TO RETURN STACK
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   R>   *
#  **********
#
    .align     3
N_FROMR:   .quad      2
        .ascii      "R>"
    .align     3
FROMR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TOR-(CW*(C_HOFFSET))
        .quad    N_FROMR
X_FROMR:
      #(S1) <- (R1)
        LDQ     $0,0($27) # GET RETURN STACK VALUE
        ADDQ    $27, (CW*(1)), $27
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   RDROP   *
#  *************
#
    .align     3
N_RDROP:   .quad      5
        .ascii      "RDROP"
    .align     3
RDROP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FROMR-(CW*(C_HOFFSET))
        .quad    N_RDROP
X_RDROP:
      #(S1) <- (R1)
        ADDQ    $27, (CW*(1)), $27
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   R@   *
#  **********
#
    .align     3
N_RR:   .quad      2
        .ascii      "R@"
    .align     3
RR:        .quad    (IDO+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RDROP-(CW*(C_HOFFSET))
        .quad    N_RR
X_RR:

#

#  **********
#  *   0=   *
#  **********
#
    .align     3
N_ZEQU:   .quad      2
        .ascii      "0="
    .align     3
ZEQU:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RR-(CW*(C_HOFFSET))
        .quad    N_ZEQU
X_ZEQU:

        LDQ     $1, 0($30)
        BIS     $31, 0, $0
        CMOVEQ  $1, 1, $0
        SUBQ    $31, $0, $0 # Negate. 
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   0<   *
#  **********
#
    .align     3
N_ZLESS:   .quad      2
        .ascii      "0<"
    .align     3
ZLESS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ZEQU-(CW*(C_HOFFSET))
        .quad    N_ZLESS
X_ZLESS:

        LDQ     $0, 0($30)
        CMPLT   $0, $31, $0
        SUBQ    $31, $0, $0 # Negate. 
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   +   *
#  *********
#
    .align     3
N_PLUS:   .quad      1
        .ascii      "+"
    .align     3
PLUS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ZLESS-(CW*(C_HOFFSET))
        .quad    N_PLUS
X_PLUS:

        LDQ     $0, (CW*(0))($30)
        LDQ     $1, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30
        ADDQ    $1, $0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   D+   *
#  **********
#
    .align     3
N_DPLUS:   .quad      2
        .ascii      "D+"
    .align     3
DPLUS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PLUS-(CW*(C_HOFFSET))
        .quad    N_DPLUS
X_DPLUS:

        LDQ     $0, (CW*(0))($30)    # YHW
        LDQ     $3, (CW*(1))($30)    # YLW
        LDQ     $1, (CW*(2))($30)    # XHW
        LDQ     $2, (CW*(3))($30)    # XLW
        ADDQ      $30, (CW*(4)), $30
        ADDQ  $2, $3, $4
        CMPULT  $4, $2, $5
        CMPULT  $4, $3, $6
        OR      $5, $6, $2
        ADDQ  $1, $0, $0
        ADDQ  $0, $2, $0
        BIS     $31, $4, $3
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   NEGATE   *
#  **************
#
    .align     3
N_NEGATE:   .quad      6
        .ascii      "NEGATE"
    .align     3
NEGATE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DPLUS-(CW*(C_HOFFSET))
        .quad    N_NEGATE
X_NEGATE:

        LDQ     $0, 0($30)
        SUBQ    $31, $0, $0
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***************
#  *   DNEGATE   *
#  ***************
#
    .align     3
N_DNEGA:   .quad      7
        .ascii      "DNEGATE"
    .align     3
DNEGA:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    NEGATE-(CW*(C_HOFFSET))
        .quad    N_DNEGA
X_DNEGA:

        LDQ     $1, (CW*(0))($30)
        LDQ     $2, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
        SUBQ    $31, $2, $3
        CMPULT  $31, $2, $0
        SUBQ    $31, $0, $0 # Turn carry into borrow.
        SUBQ    $0, $1, $0
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
# Better :
#       CMPULT  zero, modl, $0  # Borrow.
#       SUBQ    zero, modl, modl
#       SUBQ    zero, modh, modh
#       SUBQ    modh, $0, modh
        .eject
#

#  ************
#  *   OVER   *
#  ************
#
    .align     3
N_OVER:   .quad      4
        .ascii      "OVER"
    .align     3
OVER:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DNEGA-(CW*(C_HOFFSET))
        .quad    N_OVER
X_OVER:

        LDQ     $0, (CW*(1))($30)
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   DROP   *
#  ************
#
    .align     3
N_DROP:   .quad      4
        .ascii      "DROP"
    .align     3
DROP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    OVER-(CW*(C_HOFFSET))
        .quad    N_DROP
X_DROP:

        ADDQ      $30, (CW*(1)), $30
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   2DROP   *
#  *************
#
    .align     3
N_TDROP:   .quad      5
        .ascii      "2DROP"
    .align     3
TDROP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DROP-(CW*(C_HOFFSET))
        .quad    N_TDROP
X_TDROP:

        ADDQ      $30, (CW*(2)), $30
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   SWAP   *
#  ************
#
    .align     3
N_SWAP:   .quad      4
        .ascii      "SWAP"
    .align     3
SWAP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TDROP-(CW*(C_HOFFSET))
        .quad    N_SWAP
X_SWAP:

        LDQ     $3, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        STQ     $3, (CW*(1))($30)
        STQ     $0, (CW*(0))($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   DUP   *
#  ***********
#
    .align     3
N_LDUP:   .quad      3
        .ascii      "DUP"
    .align     3
LDUP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SWAP-(CW*(C_HOFFSET))
        .quad    N_LDUP
X_LDUP:

        LDQ     $0, (CW*(0))($30)
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   2DUP   *
#  ************
#
    .align     3
N_TDUP:   .quad      4
        .ascii      "2DUP"
    .align     3
TDUP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LDUP-(CW*(C_HOFFSET))
        .quad    N_TDUP
X_TDUP:

        LDQ     $0, (CW*(0))($30)
        LDQ     $3, (CW*(1))($30)
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   2SWAP   *
#  *************
#
    .align     3
N_TSWAP:   .quad      5
        .ascii      "2SWAP"
    .align     3
TSWAP:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TDUP-(CW*(C_HOFFSET))
        .quad    N_TSWAP
X_TSWAP:

        LDQ     $3, (CW*(0))($30)
        LDQ     $0, (CW*(2))($30)
        STQ     $3, (CW*(2))($30)
        STQ     $0, (CW*(0))($30)
        LDQ     $3, (CW*(1))($30)
        LDQ     $0, (CW*(3))($30)
        STQ     $3, (CW*(3))($30)
        STQ     $0, (CW*(1))($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   2OVER   *
#  *************
#
    .align     3
N_TOVER:   .quad      5
        .ascii      "2OVER"
    .align     3
TOVER:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TSWAP-(CW*(C_HOFFSET))
        .quad    N_TOVER
X_TOVER:

        LDQ     $0, (CW*(2))($30)
        LDQ     $3, (CW*(3))($30)
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   +!   *
#  **********
#
    .align     3
N_PSTORE:   .quad      2
        .ascii      "+!"
    .align     3
PSTORE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TOVER-(CW*(C_HOFFSET))
        .quad    N_PSTORE
X_PSTORE:

        LDQ     $1, (CW*(0))($30)  #ADDR
        LDQ     $0, (CW*(1))($30)  #CONTENT 
        ADDQ    $30, (CW*(2)), $30
        LDQ     $2, 0($1)
        ADDQ    $2,$0,$2
        STQ     $2, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   TOGGLE   *
#  **************
#
    .align     3
N_TOGGL:   .quad      6
        .ascii      "TOGGLE"
    .align     3
TOGGL:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PSTORE-(CW*(C_HOFFSET))
        .quad    N_TOGGL
X_TOGGL:

        LDQ     $0, (CW*(0))($30) #BIT PATTERN
        LDQ     $1, (CW*(1))($30) #ADDR
        ADDQ    $30, (CW*(2)), $30
        LDQ     $2, 0($1)
        XOR     $2,$0,$2
        STQ     $2, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   C@   *
#  **********
#
    .align     3
N_CFET:   .quad      2
        .ascii      "C@"
    .align     3
CFET:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TOGGL-(CW*(C_HOFFSET))
        .quad    N_CFET
X_CFET:

        LDQ     $1, 0($30)
        LDBU    $0, 0($1)
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   @16   *
#  ***********
#
    .align     3
N_FETCH16:   .quad      3
        .ascii      "@16"
    .align     3
FETCH16:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CFET-(CW*(C_HOFFSET))
        .quad    N_FETCH16
X_FETCH16:

        LDQ     $1, 0($30)
        LDWU    $0, 0($1)
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   @32   *
#  ***********
#
    .align     3
N_FETCH32:   .quad      3
        .ascii      "@32"
    .align     3
FETCH32:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FETCH16-(CW*(C_HOFFSET))
        .quad    N_FETCH32
X_FETCH32:

        LDQ     $1, 0($30)
        LDL     $0, 0($1)     #  Sign extended! 
        MSKQL   $0, 0xff, $0
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   @   *
#  *********
#
    .align     3
N_FETCH:   .quad      1
        .ascii      "@"
    .align     3
FETCH:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FETCH32-(CW*(C_HOFFSET))
        .quad    N_FETCH
X_FETCH:

        LDQ     $1, 0($30)
        LDQ     $0, 0($1)
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   2@   *
#  **********
#
    .align     3
N_TFET:   .quad      2
        .ascii      "2@"
    .align     3
TFET:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FETCH-(CW*(C_HOFFSET))
        .quad    N_TFET
X_TFET:

        LDQ     $1, (CW*(0))($30)      #ADDR
        ADDQ    $30, (CW*(1)), $30

        LDQ     $0, (CW*(0))($1)
        LDQ     $3, (CW*(1))($1)
                SUBQ    $30, 2*CW, $30
    STQ     $3, CW($30)
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   C!   *
#  **********
#
    .align     3
N_CSTOR:   .quad      2
        .ascii      "C!"
    .align     3
CSTOR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TFET-(CW*(C_HOFFSET))
        .quad    N_CSTOR
X_CSTOR:

        LDQ     $1, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30      #DATA
        STB     $0, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   !16   *
#  ***********
#
    .align     3
N_STORE16:   .quad      3
        .ascii      "!16"
    .align     3
STORE16:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CSTOR-(CW*(C_HOFFSET))
        .quad    N_STORE16
X_STORE16:

        LDQ     $1, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30      #DATA
        STW     $0, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   !32   *
#  ***********
#
    .align     3
N_STORE32:   .quad      3
        .ascii      "!32"
    .align     3
STORE32:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STORE16-(CW*(C_HOFFSET))
        .quad    N_STORE32
X_STORE32:

        LDQ     $1, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30      #DATA
        STL     $0, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   !   *
#  *********
#
    .align     3
N_STORE:   .quad      1
        .ascii      "!"
    .align     3
STORE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STORE32-(CW*(C_HOFFSET))
        .quad    N_STORE
X_STORE:

        LDQ     $1, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30      #DATA
        STQ     $0, 0($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   2!   *
#  **********
#
    .align     3
N_TSTOR:   .quad      2
        .ascii      "2!"
    .align     3
TSTOR:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STORE-(CW*(C_HOFFSET))
        .quad    N_TSTOR
X_TSTOR:

        LDQ     $1, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        LDQ     $3, (CW*(2))($30)
        ADDQ    $30, (CW*(3)), $30
        STQ     $0, (CW*(0))($1)
        STQ     $3, (CW*(1))($1)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   WITHIN   *
#  **************
#
    .align     3
N_WITHIN:   .quad      6
        .ascii      "WITHIN"
    .align     3
WITHIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TSTOR-(CW*(C_HOFFSET))
        .quad    N_WITHIN
X_WITHIN:

        .quad      OVER, LSUB, TOR
        .quad      LSUB, FROMR
        .quad      ULESS
        .quad      SEMIS
#

#  *********
#  *   :   *
#  *********
#
    .align     3
N_COLON:   .quad      1
        .ascii      ":"
    .align     3
COLON:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    WITHIN-(CW*(C_HOFFSET))
        .quad    N_COLON
X_COLON:

        .quad      SCSP
        .quad      LPWORD
        .quad      PCREAT
        .quad      LATEST, HIDDEN
        .quad      RBRAC
        .quad      PSCOD
DOCOL:  SUBQ    $27,  (CW*(1)), $27
        STQ     $29, 0($27) #R1 <- (IP)
        LDQ     $29, (CW*(D_HOFFSET - C_HOFFSET))($0)  #(IP) <- (PFA)
#        CALL    DISPLAYSI
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   ;   *
#  *********
#
    .align     3
N_SEMI:   .quad      1
        .ascii      ";"
    .align     3
SEMI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    COLON-(CW*(C_HOFFSET))
        .quad    N_SEMI
X_SEMI:

        .quad      QCSP
        .quad      LIT, SEMIS, COMMA
        .quad      LATEST, HIDDEN
        .quad      LBRAC
        .quad      SEMIS
#

#  ****************
#  *   CONSTANT   *
#  ****************
#
    .align     3
N_LCONST:   .quad      8
        .ascii      "CONSTANT"
    .align     3
LCONST:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SEMI-(CW*(C_HOFFSET))
        .quad    N_LCONST
X_LCONST:

        .quad      LPWORD
        .quad      PCREAT
        .quad      LATEST, TDFA, STORE
        .quad      PSCOD
DOCON:  LDQ     $0,+(CW*((D_HOFFSET-C_HOFFSET)))($0) #GET DATA FROM PFA
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ****************
#  *   VARIABLE   *
#  ****************
#
    .align     3
N_VAR:   .quad      8
        .ascii      "VARIABLE"
    .align     3
VAR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LCONST-(CW*(C_HOFFSET))
        .quad    N_VAR
X_VAR:

        .quad      LPWORD
        .quad      PCREAT
        .quad      ZERO, COMMA
        .quad      PSCOD
DOVAR:  LDQ     $0,+(CW*((D_HOFFSET-C_HOFFSET)))($0) #(SR0) <- PFA
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   USER   *
#  ************
#
    .align     3
N_USER:   .quad      4
        .ascii      "USER"
    .align     3
USER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    VAR-(CW*(C_HOFFSET))
        .quad    N_USER
X_USER:

        .quad      LCONST
        .quad      PSCOD
DOUSE:  LDQ     $0, (CW*((D_HOFFSET-C_HOFFSET)))($0) #DFA  
        BR      $3,DOU1
DOU1:   LDQ     $3, USINI-DOU1($3)
        ADDQ    $0, $3, $0      #ADDR OF VARIABLE
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#
#

#  *********
#  *   _   *
#  *********
#
    .align     3
N_X:   .quad      1
        .ascii      "_"
    .align     3
X:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    USER-(CW*(C_HOFFSET))
        .quad    N_X
X_X:

                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0    #Whatever happens to be in AX, i.e. the dea of ``_''.
#

#  *********
#  *   0   *
#  *********
#
    .align     3
N_ZERO:   .quad      1
        .ascii      "0"
    .align     3
ZERO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    X-(CW*(C_HOFFSET))
        .quad    N_ZERO
X_ZERO:

         BIS    $31, 0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   1   *
#  *********
#
    .align     3
N_ONE:   .quad      1
        .ascii      "1"
    .align     3
ONE:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ZERO-(CW*(C_HOFFSET))
        .quad    N_ONE
X_ONE:

        BIS    $31, 1, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   2   *
#  *********
#
    .align     3
N_TWO:   .quad      1
        .ascii      "2"
    .align     3
TWO:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ONE-(CW*(C_HOFFSET))
        .quad    N_TWO
X_TWO:

        BIS    $31, 2, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   BL   *
#  **********
#
    .align     3
N_LBL:   .quad      2
        .ascii      "BL"
    .align     3
LBL:        .quad    DOCON
        .quad   ABL
        .quad    0
        .quad    TWO-(CW*(C_HOFFSET))
        .quad    N_LBL
X_LBL:

#

#  **********
#  *   $@   *
#  **********
#
    .align     3
N_SFET:   .quad      2
        .ascii      "$@"
    .align     3
SFET:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LBL-(CW*(C_HOFFSET))
        .quad    N_SFET
X_SFET:

        .quad LDUP, CELLP, SWAP, FETCH
        .quad SEMIS
#

#  **********
#  *   $!   *
#  **********
#
    .align     3
N_SSTOR:   .quad      2
        .ascii      "$!"
    .align     3
SSTOR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SFET-(CW*(C_HOFFSET))
        .quad    N_SSTOR
X_SSTOR:

        .quad TDUP, STORE, CELLP, SWAP, LCMOVE
        .quad SEMIS
#

#  *************
#  *   $!-BD   *
#  *************
#
    .align     3
N_SSTORBD:   .quad      5
        .ascii      "$!-BD"
    .align     3
SSTORBD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SSTOR-(CW*(C_HOFFSET))
        .quad    N_SSTORBD
X_SSTORBD:

        .quad TDUP, CSTOR, ONEP, SWAP, LCMOVE
        .quad SEMIS
#

#  ***********
#  *   $+!   *
#  ***********
#
    .align     3
N_SADD:   .quad      3
        .ascii      "$+!"
    .align     3
SADD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SSTORBD-(CW*(C_HOFFSET))
        .quad    N_SADD
X_SADD:

        .quad   LDUP, FETCH, TOR # Remember old count.
        .quad   TDUP, PSTORE
        .quad   CELLP, FROMR, PLUS, SWAP, LCMOVE
        .quad SEMIS
#

#  ***********
#  *   $C+   *
#  ***********
#
    .align     3
N_CHAPP:   .quad      3
        .ascii      "$C+"
    .align     3
CHAPP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SADD-(CW*(C_HOFFSET))
        .quad    N_CHAPP
X_CHAPP:

        .quad   LDUP, TOR
        .quad   LDUP, FETCH, PLUS, CELLP, CSTOR
        .quad   ONE, FROMR, PSTORE
        .quad SEMIS
#

#  **********
#  *   $,   *
#  **********
#
    .align     3
N_SCOMMA:   .quad      2
        .ascii      "$,"
    .align     3
SCOMMA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CHAPP-(CW*(C_HOFFSET))
        .quad    N_SCOMMA
X_SCOMMA:

        .quad HERE, TOR
        .quad LDUP, CELLP, ALLOT
        .quad RR, SSTOR, FROMR
 .quad LALIGN
        .quad SEMIS
#

#  ***********
#  *   C/L   *
#  ***********
#
    .align     3
N_CSLL:   .quad      3
        .ascii      "C/L"
    .align     3
CSLL:        .quad    DOCON
        .quad   64
        .quad    0
        .quad    SCOMMA-(CW*(C_HOFFSET))
        .quad    N_CSLL
X_CSLL:

#


#  *************
#  *   FIRST   *
#  *************
#
    .align     3
N_FIRST:   .quad      5
        .ascii      "FIRST"
    .align     3
FIRST:        .quad    DOCON
        .quad   BUF1
        .quad    0
        .quad    CSLL-(CW*(C_HOFFSET))
        .quad    N_FIRST
X_FIRST:

 #
#
#
#

#  *************
#  *   LIMIT   *
#  *************
#
    .align     3
N_LIMIT:   .quad      5
        .ascii      "LIMIT"
    .align     3
LIMIT:        .quad    DOCON
        .quad   BUF1+(KBBUF+2*CW)*NBUF
        .quad    0
        .quad    FIRST-(CW*(C_HOFFSET))
        .quad    N_LIMIT
X_LIMIT:

# THE END  OF THE MEMORY 

#  **********
#  *   EM   *
#  **********
#
    .align     3
N_LEM:   .quad      2
        .ascii      "EM"
    .align     3
LEM:        .quad    DOCON
        .quad   ACTUAL_EM
        .quad    0
        .quad    LIMIT-(CW*(C_HOFFSET))
        .quad    N_LEM
X_LEM:

#

#  **********
#  *   BM   *
#  **********
#
    .align     3
N_LBM:   .quad      2
        .ascii      "BM"
    .align     3
LBM:        .quad    DOCON
        .quad   ORG0
        .quad    0
        .quad    LEM-(CW*(C_HOFFSET))
        .quad    N_LBM
X_LBM:

#

#  *************
#  *   B/BUF   *
#  *************
#
    .align     3
N_BBUF:   .quad      5
        .ascii      "B/BUF"
    .align     3
BBUF:        .quad    DOCON
        .quad   KBBUF
        .quad    0
        .quad    LBM-(CW*(C_HOFFSET))
        .quad    N_BBUF
X_BBUF:

#
# All user variables are initialised 
# with the values from USINI.
# The implementation relies on the initialisation of 
# those with numbers (1..11), so change in concord with USINI.

#  **********
#  *   U0   *
#  **********
#
    .align     3
N_UZERO:   .quad      2
        .ascii      "U0"
    .align     3
UZERO:        .quad    DOUSE
        .quad   (CW*(1))
        .quad    0
        .quad    BBUF-(CW*(C_HOFFSET))
        .quad    N_UZERO
X_UZERO:

#

#  **********
#  *   S0   *
#  **********
#
    .align     3
N_SZERO:   .quad      2
        .ascii      "S0"
    .align     3
SZERO:        .quad    DOUSE
        .quad   (CW*(2))
        .quad    0
        .quad    UZERO-(CW*(C_HOFFSET))
        .quad    N_SZERO
X_SZERO:

#

#  **********
#  *   R0   *
#  **********
#
    .align     3
N_RZERO:   .quad      2
        .ascii      "R0"
    .align     3
RZERO:        .quad    DOUSE
        .quad   (CW*(3))
        .quad    0
        .quad    SZERO-(CW*(C_HOFFSET))
        .quad    N_RZERO
X_RZERO:

#

#  ***********
#  *   TIB   *
#  ***********
#
    .align     3
N_TIB:   .quad      3
        .ascii      "TIB"
    .align     3
TIB:        .quad    DOUSE
        .quad   (CW*(4))
        .quad    0
        .quad    RZERO-(CW*(C_HOFFSET))
        .quad    N_TIB
X_TIB:

#

#  **************
#  *   RUBOUT   *
#  **************
#
    .align     3
N_RUBOUT:   .quad      6
        .ascii      "RUBOUT"
    .align     3
RUBOUT:        .quad    DOUSE
        .quad   (CW*(5))
        .quad    0
        .quad    TIB-(CW*(C_HOFFSET))
        .quad    N_RUBOUT
X_RUBOUT:

#

#  ***************
#  *   WARNING   *
#  ***************
#
    .align     3
N_LWARN:   .quad      7
        .ascii      "WARNING"
    .align     3
LWARN:        .quad    DOUSE
        .quad   (CW*(7))
        .quad    0
        .quad    RUBOUT-(CW*(C_HOFFSET))
        .quad    N_LWARN
X_LWARN:

#

#  *************
#  *   FENCE   *
#  *************
#
    .align     3
N_FENCE:   .quad      5
        .ascii      "FENCE"
    .align     3
FENCE:        .quad    DOUSE
        .quad   (CW*(8))
        .quad    0
        .quad    LWARN-(CW*(C_HOFFSET))
        .quad    N_FENCE
X_FENCE:

#

#  **********
#  *   DP   *
#  **********
#
    .align     3
N_LDP:   .quad      2
        .ascii      "DP"
    .align     3
LDP:        .quad    DOUSE
        .quad   (CW*(9))
        .quad    0
        .quad    FENCE-(CW*(C_HOFFSET))
        .quad    N_LDP
X_LDP:

#

#  ****************
#  *   VOC-LINK   *
#  ****************
#
    .align     3
N_VOCL:   .quad      8
        .ascii      "VOC-LINK"
    .align     3
VOCL:        .quad    DOUSE
        .quad   (CW*(10))
        .quad    0
        .quad    LDP-(CW*(C_HOFFSET))
        .quad    N_VOCL
X_VOCL:

#

#  **************
#  *   OFFSET   *
#  **************
#
    .align     3
N_LOFFSET:   .quad      6
        .ascii      "OFFSET"
    .align     3
LOFFSET:        .quad    DOUSE
        .quad   (CW*(11))
        .quad    0
        .quad    VOCL-(CW*(C_HOFFSET))
        .quad    N_LOFFSET
X_LOFFSET:

#
# End of user variables with fixed place.
#
#

#  *************
#  *   WHERE   *
#  *************
#
    .align     3
N_LWHERE:   .quad      5
        .ascii      "WHERE"
    .align     3
LWHERE:        .quad    DOUSE
        .quad   (CW*(12))
        .quad    0
        .quad    LOFFSET-(CW*(C_HOFFSET))
        .quad    N_LWHERE
X_LWHERE:
    #  Occupies two CELLS! 
#

#  ***********
#  *   SCR   *
#  ***********
#
    .align     3
N_SCR:   .quad      3
        .ascii      "SCR"
    .align     3
SCR:        .quad    DOUSE
        .quad   (CW*(33))
        .quad    0
        .quad    LWHERE-(CW*(C_HOFFSET))
        .quad    N_SCR
X_SCR:

#

#  *************
#  *   STATE   *
#  *************
#
    .align     3
N_STATE:   .quad      5
        .ascii      "STATE"
    .align     3
STATE:        .quad    DOUSE
        .quad   (CW*(18))
        .quad    0
        .quad    SCR-(CW*(C_HOFFSET))
        .quad    N_STATE
X_STATE:

#

#  ************
#  *   BASE   *
#  ************
#
    .align     3
N_BASE:   .quad      4
        .ascii      "BASE"
    .align     3
BASE:        .quad    DOUSE
        .quad   (CW*(19))
        .quad    0
        .quad    STATE-(CW*(C_HOFFSET))
        .quad    N_BASE
X_BASE:

#

#  ***********
#  *   DPL   *
#  ***********
#
    .align     3
N_DPL:   .quad      3
        .ascii      "DPL"
    .align     3
DPL:        .quad    DOUSE
        .quad   (CW*(20))
        .quad    0
        .quad    BASE-(CW*(C_HOFFSET))
        .quad    N_DPL
X_DPL:

#

#  ***********
#  *   FLD   *
#  ***********
#
    .align     3
N_LFLD:   .quad      3
        .ascii      "FLD"
    .align     3
LFLD:        .quad    DOUSE
        .quad   (CW*(21))
        .quad    0
        .quad    DPL-(CW*(C_HOFFSET))
        .quad    N_LFLD
X_LFLD:

#


#  ***********
#  *   CSP   *
#  ***********
#
    .align     3
N_LCSP:   .quad      3
        .ascii      "CSP"
    .align     3
LCSP:        .quad    DOUSE
        .quad   (CW*(22))
        .quad    0
        .quad    LFLD-(CW*(C_HOFFSET))
        .quad    N_LCSP
X_LCSP:

#
#

#  **********
#  *   R#   *
#  **********
#
    .align     3
N_RNUM:   .quad      2
        .ascii      "R#"
    .align     3
RNUM:        .quad    DOUSE
        .quad   (CW*(23))
        .quad    0
        .quad    LCSP-(CW*(C_HOFFSET))
        .quad    N_RNUM
X_RNUM:

#

#  ***********
#  *   HLD   *
#  ***********
#
    .align     3
N_HLD:   .quad      3
        .ascii      "HLD"
    .align     3
HLD:        .quad    DOUSE
        .quad   (CW*(24))
        .quad    0
        .quad    RNUM-(CW*(C_HOFFSET))
        .quad    N_HLD
X_HLD:

#

#  ***********
#  *   OUT   *
#  ***********
#
    .align     3
N_LOUT:   .quad      3
        .ascii      "OUT"
    .align     3
LOUT:        .quad    DOUSE
        .quad   (CW*(25))
        .quad    0
        .quad    HLD-(CW*(C_HOFFSET))
        .quad    N_LOUT
X_LOUT:

#

#  *************
#  *   (BLK)   *
#  *************
#
    .align     3
N_PBLK:   .quad      5
        .ascii      "(BLK)"
    .align     3
PBLK:        .quad    DOUSE
        .quad   (CW*(26))
        .quad    0
        .quad    LOUT-(CW*(C_HOFFSET))
        .quad    N_PBLK
X_PBLK:

#

#  **********
#  *   IN   *
#  **********
#
    .align     3
N_LIN:   .quad      2
        .ascii      "IN"
    .align     3
LIN:        .quad    DOUSE
        .quad   (CW*(29))
        .quad    0
        .quad    PBLK-(CW*(C_HOFFSET))
        .quad    N_LIN
X_LIN:

#


#  *************
#  *   (>IN)   *
#  *************
#
    .align     3
N_PIIN:   .quad      5
        .ascii      "(>IN)"
    .align     3
PIIN:        .quad    DOUSE
        .quad   (CW*(30))
        .quad    0
        .quad    LIN-(CW*(C_HOFFSET))
        .quad    N_PIIN
X_PIIN:

#
#

#  ************
#  *   ARGS   *
#  ************
#
    .align     3
N_ARGS:   .quad      4
        .ascii      "ARGS"
    .align     3
ARGS:        .quad    DOUSE
        .quad   (CW*(31))
        .quad    0
        .quad    PIIN-(CW*(C_HOFFSET))
        .quad    N_ARGS
X_ARGS:

#

#  ***************
#  *   HANDLER   *
#  ***************
#
    .align     3
N_HANDLER:   .quad      7
        .ascii      "HANDLER"
    .align     3
HANDLER:        .quad    DOUSE
        .quad   (CW*(32))
        .quad    0
        .quad    ARGS-(CW*(C_HOFFSET))
        .quad    N_HANDLER
X_HANDLER:

#

#  ***************
#  *   CURRENT   *
#  ***************
#
    .align     3
N_CURR:   .quad      7
        .ascii      "CURRENT"
    .align     3
CURR:        .quad    DOUSE
        .quad   (CW*(34))
        .quad    0
        .quad    HANDLER-(CW*(C_HOFFSET))
        .quad    N_CURR
X_CURR:

#

#  *****************
#  *   REMAINDER   *
#  *****************
#
    .align     3
N_REMAIND:   .quad      9
        .ascii      "REMAINDER"
    .align     3
REMAIND:        .quad    DOUSE
        .quad   (CW*(14))
        .quad    0
        .quad    CURR-(CW*(C_HOFFSET))
        .quad    N_REMAIND
X_REMAIND:

#      IMPORTANT
# REQUIRES ONE MORE CELL!
#

#  ********************
#  *   SEARCH-ORDER   *
#  ********************
#
    .align     3
N_SEARCH:   .quad      12
        .ascii      "SEARCH-ORDER"
    .align     3
SEARCH:        .quad    DOUSE
        .quad   (CW*(37))
        .quad    0
        .quad    REMAIND-(CW*(C_HOFFSET))
        .quad    N_SEARCH
X_SEARCH:
 # Up to  37+8
#      IMPORTANT
#     8 USER SPACE CELLS MUST BE KEPT FREE
#     IN ADDITION TO THE ONE FOR SEARCH
#
#========== END USER VARIABLES =============#
#

#  **********
#  *   1+   *
#  **********
#
    .align     3
N_ONEP:   .quad      2
        .ascii      "1+"
    .align     3
ONEP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SEARCH-(CW*(C_HOFFSET))
        .quad    N_ONEP
X_ONEP:

        .quad      ONE
        .quad      PLUS
        .quad      SEMIS
#

#  *************
#  *   CELL+   *
#  *************
#
    .align     3
N_CELLP:   .quad      5
        .ascii      "CELL+"
    .align     3
CELLP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ONEP-(CW*(C_HOFFSET))
        .quad    N_CELLP
X_CELLP:

        .quad      LIT, CW
        .quad      PLUS
        .quad      SEMIS
#

#
#  *************
#  *   CELLS   *
#  *************
#
    .align     3
N_LCELLS:   .quad      5
        .ascii      "CELLS"
    .align     3
LCELLS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CELLP-(CW*(C_HOFFSET))
        .quad    N_LCELLS
X_LCELLS:

        .quad      LIT, 3
        .quad      LSHIFT
        .quad      SEMIS
#

#  *************
#  *   CHAR+   *
#  *************
#
    .align     3
N_CHARP:   .quad      5
        .ascii      "CHAR+"
    .align     3
CHARP:        .quad    DOCOL
        .quad   (ONEP+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad    0
        .quad    LCELLS-(CW*(C_HOFFSET))
        .quad    N_CHARP
X_CHARP:

#

#  *************
#  *   CHARS   *
#  *************
#
    .align     3
N_CHARS:   .quad      5
        .ascii      "CHARS"
    .align     3
CHARS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    CHARP-(CW*(C_HOFFSET))
        .quad    N_CHARS
X_CHARS:

        .quad      SEMIS
#

#  *************
#  *   ALIGN   *
#  *************
#
    .align     3
N_LALIGN:   .quad      5
        .ascii      "ALIGN"
    .align     3
LALIGN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    CHARS-(CW*(C_HOFFSET))
        .quad    N_LALIGN
X_LALIGN:


        .quad      LDP, FETCH
        .quad      ALIGNED
        .quad      LDP, STORE
#
        .quad      SEMIS
#

#  ***************
#  *   ALIGNED   *
#  ***************
#
    .align     3
N_ALIGNED:   .quad      7
        .ascii      "ALIGNED"
    .align     3
ALIGNED:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LALIGN-(CW*(C_HOFFSET))
        .quad    N_ALIGNED
X_ALIGNED:


        LDQ     $0, 0($30)
        SUBQ    $0, 1, $0
        BIS     $0, (CW*(1))-1, $0
        ADDQ    $0, 1, $0
        STQ     $0, 0($30)
#
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   HERE   *
#  ************
#
    .align     3
N_HERE:   .quad      4
        .ascii      "HERE"
    .align     3
HERE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ALIGNED-(CW*(C_HOFFSET))
        .quad    N_HERE
X_HERE:

        .quad      LDP
        .quad      FETCH
        .quad      SEMIS
#

#  *************
#  *   ALLOT   *
#  *************
#
    .align     3
N_ALLOT:   .quad      5
        .ascii      "ALLOT"
    .align     3
ALLOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    HERE-(CW*(C_HOFFSET))
        .quad    N_ALLOT
X_ALLOT:

        .quad      LDP
        .quad      PSTORE
        .quad      SEMIS
#

#  *********
#  *   ,   *
#  *********
#
    .align     3
N_COMMA:   .quad      1
        .ascii      ","
    .align     3
COMMA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ALLOT-(CW*(C_HOFFSET))
        .quad    N_COMMA
X_COMMA:

        .quad      HERE
        .quad      STORE
        .quad      LIT, CW
        .quad      ALLOT
        .quad      SEMIS
#

#  **********
#  *   C,   *
#  **********
#
    .align     3
N_CCOMM:   .quad      2
        .ascii      "C,"
    .align     3
CCOMM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    COMMA-(CW*(C_HOFFSET))
        .quad    N_CCOMM
X_CCOMM:

        .quad      HERE
        .quad      CSTOR
        .quad      ONE
        .quad      ALLOT
        .quad      SEMIS
#

#  *********
#  *   -   *
#  *********
#
    .align     3
N_LSUB:   .quad      1
        .ascii      "-"
    .align     3
LSUB:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CCOMM-(CW*(C_HOFFSET))
        .quad    N_LSUB
X_LSUB:

        LDQ     $3, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ    $30, (CW*(2)), $30
        SUBQ  $0, $3, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0      #S1 = S2 - S1
#

#  *********
#  *   =   *
#  *********
#
    .align     3
N_EQUAL:   .quad      1
        .ascii      "="
    .align     3
EQUAL:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LSUB-(CW*(C_HOFFSET))
        .quad    N_EQUAL
X_EQUAL:

        .quad      LSUB
        .quad      ZEQU
        .quad      SEMIS
#

#  *********
#  *   <   *
#  *********
#
    .align     3
N_LESS:   .quad      1
        .ascii      "<"
    .align     3
LESS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    EQUAL-(CW*(C_HOFFSET))
        .quad    N_LESS
X_LESS:

        LDQ     $1, (CW*(0))($30)
        LDQ     $3, (CW*(1))($30)
        ADDQ    $30, (CW*(1)), $30
        CMPLT   $3, $1, $0
        SUBQ    $31, $0, $0 # Negate. 
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   U<   *
#  **********
#
    .align     3
N_ULESS:   .quad      2
        .ascii      "U<"
    .align     3
ULESS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LESS-(CW*(C_HOFFSET))
        .quad    N_ULESS
X_ULESS:

        LDQ     $1, (CW*(0))($30)
        LDQ     $3, (CW*(1))($30)
        ADDQ    $30, (CW*(1)), $30
        CMPULT  $3, $1, $0
        SUBQ    $31, $0, $0 # Negate. 
        STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *********
#  *   >   *
#  *********
#
    .align     3
N_GREAT:   .quad      1
        .ascii      ">"
    .align     3
GREAT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ULESS-(CW*(C_HOFFSET))
        .quad    N_GREAT
X_GREAT:

        .quad      SWAP
        .quad      LESS
        .quad      SEMIS
#

#  **********
#  *   <>   *
#  **********
#
    .align     3
N_UNEQ:   .quad      2
        .ascii      "<>"
    .align     3
UNEQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    GREAT-(CW*(C_HOFFSET))
        .quad    N_UNEQ
X_UNEQ:

        .quad      LSUB
        .quad      ZEQU
        .quad      ZEQU
        .quad      SEMIS
#

#  ***********
#  *   ROT   *
#  ***********
#
    .align     3
N_ROT:   .quad      3
        .ascii      "ROT"
    .align     3
ROT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    UNEQ-(CW*(C_HOFFSET))
        .quad    N_ROT
X_ROT:

        LDQ     $0, (CW*(0))($30) #n3
        LDQ     $1, (CW*(1))($30) #n2
        LDQ     $2, (CW*(2))($30) #n1

        STQ     $1, (CW*(2))($30)
        STQ     $0, (CW*(1))($30)
        STQ     $2, (CW*(0))($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   SPACE   *
#  *************
#
    .align     3
N_SPACE:   .quad      5
        .ascii      "SPACE"
    .align     3
SPACE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ROT-(CW*(C_HOFFSET))
        .quad    N_SPACE
X_SPACE:

        .quad      LBL
        .quad      EMIT
        .quad      SEMIS
#

#  ************
#  *   ?DUP   *
#  ************
#
    .align     3
N_QDUP:   .quad      4
        .ascii      "?DUP"
    .align     3
QDUP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SPACE-(CW*(C_HOFFSET))
        .quad    N_QDUP
X_QDUP:

        .quad      LDUP
        .quad      ZBRAN
        .quad      QDUP1-.-CW # IF
        .quad      LDUP    #THEN
QDUP1:  .quad      SEMIS
#

#  **************
#  *   LATEST   *
#  **************
#
    .align     3
N_LATEST:   .quad      6
        .ascii      "LATEST"
    .align     3
LATEST:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QDUP-(CW*(C_HOFFSET))
        .quad    N_LATEST
X_LATEST:

        .quad      CURR
        .quad      FETCH
        .quad      TLFA
        .quad      FETCH
        .quad      SEMIS
#

#  ************
#  *   >CFA   *
#  ************
#
    .align     3
N_TCFA:   .quad      4
        .ascii      ">CFA"
    .align     3
TCFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LATEST-(CW*(C_HOFFSET))
        .quad    N_TCFA
X_TCFA:

        .quad      LIT, (CW*(C_HOFFSET))
        .quad      PLUS
        .quad      SEMIS
#

#  ************
#  *   >DFA   *
#  ************
#
    .align     3
N_TDFA:   .quad      4
        .ascii      ">DFA"
    .align     3
TDFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TCFA-(CW*(C_HOFFSET))
        .quad    N_TDFA
X_TDFA:

        .quad      LIT, (CW*(D_HOFFSET))
        .quad      PLUS
        .quad      SEMIS
#

#  ************
#  *   >FFA   *
#  ************
#
    .align     3
N_TFFA:   .quad      4
        .ascii      ">FFA"
    .align     3
TFFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TDFA-(CW*(C_HOFFSET))
        .quad    N_TFFA
X_TFFA:

        .quad      LIT, (CW*(F_HOFFSET))
        .quad      PLUS
        .quad      SEMIS
#

#  ************
#  *   >LFA   *
#  ************
#
    .align     3
N_TLFA:   .quad      4
        .ascii      ">LFA"
    .align     3
TLFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TFFA-(CW*(C_HOFFSET))
        .quad    N_TLFA
X_TLFA:

        .quad      LIT, (CW*(L_HOFFSET))
        .quad      PLUS
        .quad      SEMIS
#

#  ************
#  *   >NFA   *
#  ************
#
    .align     3
N_TNFA:   .quad      4
        .ascii      ">NFA"
    .align     3
TNFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TLFA-(CW*(C_HOFFSET))
        .quad    N_TNFA
X_TNFA:

        .quad      LIT,(CW*(N_HOFFSET))
        .quad      PLUS
        .quad      SEMIS
#
#

#  ************
#  *   >PHA   *
#  ************
#
    .align     3
N_TPHA:   .quad      4
        .ascii      ">PHA"
    .align     3
TPHA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TNFA-(CW*(C_HOFFSET))
        .quad    N_TPHA
X_TPHA:

        .quad      LIT,(CW*(PH_OFFSET))
        .quad      PLUS
        .quad      SEMIS
#

#  *************
#  *   >BODY   *
#  *************
#
    .align     3
N_TOBODY:   .quad      5
        .ascii      ">BODY"
    .align     3
TOBODY:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TPHA-(CW*(C_HOFFSET))
        .quad    N_TOBODY
X_TOBODY:

        .quad      CTOD
        .quad      TDFA, FETCH
        .quad      CELLP           # Skip DOES> pointer.
        .quad      SEMIS
#

#  *************
#  *   BODY>   *
#  *************
#
    .align     3
N_BODYF:   .quad      5
        .ascii      "BODY>"
    .align     3
BODYF:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TOBODY-(CW*(C_HOFFSET))
        .quad    N_BODYF
X_BODYF:

        .quad      LIT,(CW*(BD_OFFSET))
        .quad      LSUB
        .quad      SEMIS
#

#  ************
#  *   CFA>   *
#  ************
#
    .align     3
N_CTOD:   .quad      4
        .ascii      "CFA>"
    .align     3
CTOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BODYF-(CW*(C_HOFFSET))
        .quad    N_CTOD
X_CTOD:

        .quad      LIT,(CW*(C_HOFFSET))
        .quad      LSUB
        .quad      SEMIS
#

#  ************
#  *   >WID   *
#  ************
#
    .align     3
N_TWID:   .quad      4
        .ascii      ">WID"
    .align     3
TWID:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CTOD-(CW*(C_HOFFSET))
        .quad    N_TWID
X_TWID:

        .quad      TOBODY
        .quad      CELLP # Skip vfa link.
        .quad      SEMIS
#

#  ************
#  *   >VFA   *
#  ************
#
    .align     3
N_TVFA:   .quad      4
        .ascii      ">VFA"
    .align     3
TVFA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TWID-(CW*(C_HOFFSET))
        .quad    N_TVFA
X_TVFA:

        .quad      TOBODY
        .quad      SEMIS
#


#  ************
#  *   !CSP   *
#  ************
#
    .align     3
N_SCSP:   .quad      4
        .ascii      "!CSP"
    .align     3
SCSP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TVFA-(CW*(C_HOFFSET))
        .quad    N_SCSP
X_SCSP:

        .quad      SPFET
        .quad      LCSP
        .quad      STORE
        .quad      SEMIS
#
#

#  **************
#  *   ?ERROR   *
#  **************
#
    .align     3
N_QERR:   .quad      6
        .ascii      "?ERROR"
    .align     3
QERR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SCSP-(CW*(C_HOFFSET))
        .quad    N_QERR
X_QERR:

        .quad      SWAP
        .quad      ZBRAN
        .quad      QERR1-.-CW #IF
        .quad      LIN, FETCH
        .quad      SRC, FETCH
        .quad      LWHERE, TSTOR
        .quad      THROW
        .quad      BRAN
        .quad      QERR2-.-CW  #ELSE
QERR1:  .quad      DROP    #THEN
QERR2:  .quad      SEMIS
#

#  **************
#  *   ?ERRUR   *
#  **************
#
    .align     3
N_QERRUR:   .quad      6
        .ascii      "?ERRUR"
    .align     3
QERRUR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QERR-(CW*(C_HOFFSET))
        .quad    N_QERRUR
X_QERRUR:

        .quad      ZERO, MIN, LDUP, QERR
        .quad      SEMIS
#


#  **************
#  *   ?DELIM   *
#  **************
#
    .align     3
N_QDELIM:   .quad      6
        .ascii      "?DELIM"
    .align     3
QDELIM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QERRUR-(CW*(C_HOFFSET))
        .quad    N_QDELIM
X_QDELIM:

        .quad      INBRS
        .quad      QBL
        .quad      ZEQU
        .quad      LIT, 10, QERR
        .quad      DROP
        .quad      SEMIS
#

#  ************
#  *   ?CSP   *
#  ************
#
    .align     3
N_QCSP:   .quad      4
        .ascii      "?CSP"
    .align     3
QCSP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QDELIM-(CW*(C_HOFFSET))
        .quad    N_QCSP
X_QCSP:

        .quad      SPFET
        .quad      LCSP
        .quad      FETCH
        .quad      LSUB
        .quad      LIT, 20, QERR
        .quad      SEMIS
#

#  *************
#  *   ?COMP   *
#  *************
#
    .align     3
N_QCOMP:   .quad      5
        .ascii      "?COMP"
    .align     3
QCOMP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QCSP-(CW*(C_HOFFSET))
        .quad    N_QCOMP
X_QCOMP:

        .quad      STATE
        .quad      FETCH
        .quad      ZEQU
        .quad      LIT, 17, QERR
        .quad      SEMIS
#

#  *************
#  *   ?EXEC   *
#  *************
#
    .align     3
N_QEXEC:   .quad      5
        .ascii      "?EXEC"
    .align     3
QEXEC:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QCOMP-(CW*(C_HOFFSET))
        .quad    N_QEXEC
X_QEXEC:

        .quad      STATE
        .quad      FETCH
        .quad      LIT, 18, QERR
        .quad      SEMIS
#

#  **************
#  *   ?PAIRS   *
#  **************
#
    .align     3
N_QPAIR:   .quad      6
        .ascii      "?PAIRS"
    .align     3
QPAIR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QEXEC-(CW*(C_HOFFSET))
        .quad    N_QPAIR
X_QPAIR:

        .quad      LSUB
        .quad      LIT, 19, QERR
        .quad      SEMIS
#


#  ****************
#  *   ?LOADING   *
#  ****************
#
    .align     3
N_QLOAD:   .quad      8
        .ascii      "?LOADING"
    .align     3
QLOAD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QPAIR-(CW*(C_HOFFSET))
        .quad    N_QLOAD
X_QLOAD:

        .quad      BLK
        .quad      FETCH
        .quad      ZEQU
        .quad      LIT, 22, QERR
        .quad      SEMIS
#
#
#
#

#  *********
#  *   [   *
#  *********
#
    .align     3
N_LBRAC:   .quad      1
        .ascii      "["
    .align     3
LBRAC:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    QLOAD-(CW*(C_HOFFSET))
        .quad    N_LBRAC
X_LBRAC:

        .quad      ZERO
        .quad      STATE
        .quad      STORE
        .quad      SEMIS
#

#  *********
#  *   ]   *
#  *********
#
    .align     3
N_RBRAC:   .quad      1
        .ascii      "]"
    .align     3
RBRAC:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LBRAC-(CW*(C_HOFFSET))
        .quad    N_RBRAC
X_RBRAC:

        .quad      ONE
        .quad      STATE
        .quad      STORE
        .quad      SEMIS
#

#  **************
#  *   HIDDEN   *
#  **************
#
    .align     3
N_HIDDEN:   .quad      6
        .ascii      "HIDDEN"
    .align     3
HIDDEN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RBRAC-(CW*(C_HOFFSET))
        .quad    N_HIDDEN
X_HIDDEN:

        .quad      TFFA
        .quad      LIT,B_INVIS
        .quad      TOGGL
        .quad      SEMIS
#

#  ***********
#  *   HEX   *
#  ***********
#
    .align     3
N_HEX:   .quad      3
        .ascii      "HEX"
    .align     3
HEX:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    HIDDEN-(CW*(C_HOFFSET))
        .quad    N_HEX
X_HEX:

        .quad      LIT,16
        .quad      BASE
        .quad      STORE
        .quad      SEMIS
#

#  ***************
#  *   DECIMAL   *
#  ***************
#
    .align     3
N_DECA:   .quad      7
        .ascii      "DECIMAL"
    .align     3
DECA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    HEX-(CW*(C_HOFFSET))
        .quad    N_DECA
X_DECA:

        .quad      LIT,10
        .quad      BASE
        .quad      STORE
        .quad      SEMIS
#

#  ***************
#  *   (;CODE)   *
#  ***************
#
    .align     3
N_PSCOD:   .quad      7
        .ascii      "(;CODE)"
    .align     3
PSCOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DECA-(CW*(C_HOFFSET))
        .quad    N_PSCOD
X_PSCOD:

        .quad      FROMR
        .quad      LATEST
        .quad      TCFA
        .quad      STORE
        .quad      SEMIS
#

#

#  **************
#  *   CREATE   *
#  **************
#
    .align     3
N_CREATE:   .quad      6
        .ascii      "CREATE"
    .align     3
CREATE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PSCOD-(CW*(C_HOFFSET))
        .quad    N_CREATE
X_CREATE:

        .quad      LPWORD
        .quad      PCREAT
        .quad      LIT, HLNOOP, COMMA
        .quad      PSCOD
DODOE:  SUBQ    $27,  (CW*(1)), $27 #Pop HIP.
        STQ     $29,0($27)
        LDQ     $29,+(CW*((D_HOFFSET-C_HOFFSET)))($0) #NEW IP 
        ADDQ    $29, +(CW*(1)), $0
        LDQ     $29,0($29)
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
HLNOOP: .quad      SEMIS
#

#  *************
#  *   DOES>   *
#  *************
#
    .align     3
N_DOES:   .quad      5
        .ascii      "DOES>"
    .align     3
DOES:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CREATE-(CW*(C_HOFFSET))
        .quad    N_DOES
X_DOES:

        .quad      FROMR
        .quad      LATEST
        .quad      TDFA
        .quad      FETCH
        .quad      STORE
        .quad      SEMIS
#

#  *************
#  *   COUNT   *
#  *************
#
    .align     3
N_COUNT:   .quad      5
        .ascii      "COUNT"
    .align     3
COUNT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DOES-(CW*(C_HOFFSET))
        .quad    N_COUNT
X_COUNT:

        .quad      LDUP
        .quad      ONEP
        .quad      SWAP
        .quad      CFET
        .quad      SEMIS
#

#  *****************
#  *   -TRAILING   *
#  *****************
#
    .align     3
N_DTRAI:   .quad      9
        .ascii      "-TRAILING"
    .align     3
DTRAI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    COUNT-(CW*(C_HOFFSET))
        .quad    N_DTRAI
X_DTRAI:

        .quad      LDUP
        .quad      ZERO
        .quad     XDO
        .quad      DTRA4-.-CW
DTRA1:  .quad      OVER
        .quad      OVER
        .quad      PLUS
        .quad      ONE
        .quad      LSUB
        .quad      CFET
        .quad      QBL
        .quad      ZEQU
        .quad      ZBRAN
        .quad      DTRA2-.-CW #IF
        .quad      LLEAV
DTRA2:  .quad      ONE
        .quad      LSUB    # THEN
        .quad     XLOOP
        .quad      DTRA1-.-CW    # LOOP
DTRA4:
        .quad      SEMIS
#


#  **********
#  *   S"   *
#  **********
#
    .align     3
N_SQUOT:   .quad      2
        .ascii      "S\""
    .align     3
SQUOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DTRAI-(CW*(C_HOFFSET))
        .quad    N_SQUOT
X_SQUOT:

        .quad      DENQ
        .quad      SEMIS
#
#

#  **********
#  *   ."   *
#  **********
#
    .align     3
N_DOTQ:   .quad      2
        .ascii      ".\""
    .align     3
DOTQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    SQUOT-(CW*(C_HOFFSET))
        .quad    N_DOTQ
X_DOTQ:

        .quad      DENQ
        .quad      STATE
        .quad      FETCH
        .quad      ZBRAN
        .quad      DOTQ1-.-CW # IF
        .quad      LIT, LTYPE, COMMA
        .quad      BRAN
        .quad      DOTQ2-.-CW
DOTQ1:
        .quad      LTYPE
DOTQ2:
        .quad      SEMIS   # THEN
#

#  **********
#  *   .(   *
#  **********
#
    .align     3
N_DOTP:   .quad      2
        .ascii      ".("
    .align     3
DOTP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DOTQ-(CW*(C_HOFFSET))
        .quad    N_DOTP
X_DOTP:

        .quad      LIT, ')'
        .quad      PPARS
        .quad      LTYPE
        .quad      SEMIS
#

#  ***************
#  *   SET-SRC   *
#  ***************
#
    .align     3
N_SETSRC:   .quad      7
        .ascii      "SET-SRC"
    .align     3
SETSRC:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DOTP-(CW*(C_HOFFSET))
        .quad    N_SETSRC
X_SETSRC:

        .quad      OVER, PLUS
        .quad      SWAP, SRC, TSTOR
        .quad      SRC, FETCH
        .quad      LIN, STORE #  IN

#       .quad      DOTS
        .quad      SEMIS
#

#  ****************
#  *   EVALUATE   *
#  ****************
#
    .align     3
N_EVALUATE:   .quad      8
        .ascii      "EVALUATE"
    .align     3
EVALUATE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SETSRC-(CW*(C_HOFFSET))
        .quad    N_EVALUATE
X_EVALUATE:

        .quad      SAVE
        .quad      SETSRC
        .quad      LIT, INTER, CATCH
        .quad      RESTO
        .quad      THROW
        .quad      SEMIS
#

#  ************
#  *   FILL   *
#  ************
#
    .align     3
N_FILL:   .quad      4
        .ascii      "FILL"
    .align     3
FILL:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    EVALUATE-(CW*(C_HOFFSET))
        .quad    N_FILL
X_FILL:

        LDQ     $0, (CW*(0))($30) # FILL CHAR
        LDQ     $2, (CW*(1))($30) # FILL COUNT
        LDQ     $1, (CW*(2))($30) # BEGIN ADDR
        ADDQ      $30, (CW*(3)), $30      #source
        BEQ     $2, FIL1
FIL2:
        SUBQ    $2, 1, $2
        STB     $0, 0($1)
        ADDQ    $1, 1, $1
        BNE     $2, FIL2
FIL1:
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ************
#  *   CORA   *
#  ************
#
    .align     3
N_CORA:   .quad      4
        .ascii      "CORA"
    .align     3
CORA:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FILL-(CW*(C_HOFFSET))
        .quad    N_CORA
X_CORA:

        LDQ     $2, (CW*(0))($30) # count
        LDQ     $3, (CW*(1))($30) #addr2
        LDQ     $1, (CW*(2))($30) #addr1
        ADDQ      $30, (CW*(3)), $30      #source

        BIS     $31, 0, $0     # Default result for zero count
        BEQ     $2, CORA1
CORA2:
        SUBQ    $2, 1, $2
        LDBU    $0, 0($1)
        ADDQ    $1, 1, $1
        LDBU    $4, 0($3)
        ADDQ    $3, 1, $3
        SUBQ    $0, $4, $0
        BNE     $0, CORA1
        BNE     $2, CORA2
CORA1:
# At this point $0 is negative, zero, positive.
        SUBQ    $31, 1, $1     # -1 Constant.
        CMOVGT  $0, 1, $0
        CMOVLT  $0, $1, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   $I   *
#  **********
#
    .align     3
N_SINDEX:   .quad      2
        .ascii      "$I"
    .align     3
SINDEX:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CORA-(CW*(C_HOFFSET))
        .quad    N_SINDEX
X_SINDEX:

        LDQ     $1, (CW*(0))($30) # char
        LDQ     $2, (CW*(1))($30) #count
        LDQ     $0, (CW*(2))($30) #addr1
        ADDQ      $30, (CW*(3)), $30      #source

        BIS     $31, 0, $3     # Default result for zero count
        BEQ     $2, SIND1
SIND2:
        SUBQ    $2, 1, $2
        LDBU    $3, 0($0)
        CMPEQ   $1, $3, $3
        BNE     $3, SIND1
        ADDQ    $0, 1, $0
        BNE     $2, SIND2
SIND1:
#At this point SR3 means found, SR0 is possible pointer.
        CMOVEQ  $3, 0, $0  #0 if not found.
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   $S   *
#  **********
#
    .align     3
N_SSPLIT:   .quad      2
        .ascii      "$S"
    .align     3
SSPLIT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SINDEX-(CW*(C_HOFFSET))
        .quad    N_SSPLIT
X_SSPLIT:

        LDQ     $1, (CW*(0))($30) # char
        LDQ     $2, (CW*(1))($30) #count
        LDQ     $0, (CW*(2))($30) #addr1
        SUBQ    $30, (CW*(1)), $30  #The balance is: one more cell.

        ADDQ    $2, 0, $5
        BIS     $31, 0, $3     # Default result for zero count
        STQ     $0, (CW*(1))($30)   # Start of first string.
        BEQ     $2, SPLI3
SPLI2:
        SUBQ    $2, 1, $2
        LDBU    $3, 0($0)
        ADDQ    $0, 1, $0
        CMPEQ   $1, $3, $3
        BNE     $3, SPLI1
        BNE     $2, SPLI2
#After this point SR3 means found, SR0 is possible pointer.
# Not present.
SPLI3:
        STQ     $31, (CW*(3))($30)   # Nill pointer.
        BR      $31, SSPLIT2
SPLI1:
        STQ     $0, (CW*(3))($30)   #Start of remaining string.
        SUBQ    $5, $2, $5 # First part length.
        SUBQ    $5,  1, $5  #Delimiter is not part of first string.
SSPLIT2:
        STQ     $2, (CW*(2))($30)   #Remaining length
        STQ     $5,  (CW*(0))($30)   #Skipped length.
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  *************
#  *   ERASE   *
#  *************
#
    .align     3
N_LERASE:   .quad      5
        .ascii      "ERASE"
    .align     3
LERASE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SSPLIT-(CW*(C_HOFFSET))
        .quad    N_LERASE
X_LERASE:

        .quad      ZERO
        .quad      FILL
        .quad      SEMIS
#


#  *************
#  *   BLANK   *
#  *************
#
    .align     3
N_BLANK:   .quad      5
        .ascii      "BLANK"
    .align     3
BLANK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LERASE-(CW*(C_HOFFSET))
        .quad    N_BLANK
X_BLANK:

        .quad      LBL
        .quad      FILL
        .quad      SEMIS
#
#

#  ************
#  *   HOLD   *
#  ************
#
    .align     3
N_HOLD:   .quad      4
        .ascii      "HOLD"
    .align     3
HOLD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BLANK-(CW*(C_HOFFSET))
        .quad    N_HOLD
X_HOLD:

        .quad      LIT,-1
        .quad      HLD
        .quad      PSTORE
        .quad      HLD
        .quad      FETCH
        .quad      CSTOR
        .quad      SEMIS
#

#  ***********
#  *   PAD   *
#  ***********
#
    .align     3
N_PAD:   .quad      3
        .ascii      "PAD"
    .align     3
PAD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    HOLD-(CW*(C_HOFFSET))
        .quad    N_PAD
X_PAD:

        .quad      HERE
# Allow for a one line name, a double binary number and some hold char's
        .quad      LIT,84+128+64
        .quad      PLUS
        .quad      SEMIS
#


#  ************
#  *   WORD   *
#  ************
#
    .align     3
N_IWORD:   .quad      4
        .ascii      "WORD"
    .align     3
IWORD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PAD-(CW*(C_HOFFSET))
        .quad    N_IWORD
X_IWORD:

        .quad      LDUP, LBL, EQUAL
        .quad      ZBRAN
        .quad      IWORD1-.-CW
         .quad      DROP
         .quad      LPWORD
        .quad      BRAN
        .quad      IWORD2-.-CW
IWORD1: .quad      TOR
IWORD3:  .quad      INBRS, RR, EQUAL
        .quad      ZBRAN
        .quad      IWORD4-.-CW
        .quad      DROP
        .quad      BRAN
        .quad      IWORD3-.-CW
IWORD4:
        .quad      DROP
        .quad      LIT, -1, LIN, PSTORE # Backtrace to first non-delimiter.
        .quad      FROMR, PPARS
#        .quad      DOTS
IWORD2:
        .quad      HERE
        .quad      LIT,0x22
        .quad      BLANK
        .quad      HERE
        .quad      SSTORBD     # FIXME
        .quad      HERE
#        .quad      DOTS
        .quad      SEMIS
#
#

#  ************
#  *   CHAR   *
#  ************
#
    .align     3
N_LCHAR:   .quad      4
        .ascii      "CHAR"
    .align     3
LCHAR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    IWORD-(CW*(C_HOFFSET))
        .quad    N_LCHAR
X_LCHAR:

        .quad      LPWORD, DROP, CFET, LITER
        .quad      SEMIS
#

#  **************
#  *   [CHAR]   *
#  **************
#
    .align     3
N_BCHAR:   .quad      6
        .ascii      "[CHAR]"
    .align     3
BCHAR:        .quad    DOCOL
        .quad   (LCHAR+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad    B_IMMED
        .quad    LCHAR-(CW*(C_HOFFSET))
        .quad    N_BCHAR
X_BCHAR:

#

#  ****************
#  *   (NUMBER)   *
#  ****************
#
    .align     3
N_PNUMB:   .quad      8
        .ascii      "(NUMBER)"
    .align     3
PNUMB:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BCHAR-(CW*(C_HOFFSET))
        .quad    N_PNUMB
X_PNUMB:

        .quad      ZERO, ZERO
        .quad      ZERO, DPL, STORE
NPNUM1:  .quad      INBRS   # BEGIN
        .quad      LDUP, LIT, ADOT, EQUAL
        .quad      ZBRAN
        .quad      NPNUM2A-.-CW # IF
        .quad      DROP, DPL, STORE, ZERO
        .quad      BRAN
        .quad      NPNUM3-.-CW # ELSE
NPNUM2A:
        .quad      LDUP, LIT, ',', EQUAL
        .quad      ZBRAN
        .quad      NPNUM2-.-CW # IF
        .quad      TDROP, ZERO
        .quad      BRAN
        .quad      NPNUM3-.-CW # ELSE
NPNUM2:
        .quad      LDUP, QBL
        .quad      ZBRAN
        .quad      NPNUM4-.-CW # IF
        .quad      DROP, DROP, ONE
        .quad      BRAN
        .quad      NPNUM3-.-CW # ELSE
NPNUM4:
        .quad      SWAP, DROP
        .quad      BASE, FETCH, DIGIT
        .quad      ZEQU
        .quad      LIT, 10, QERR

        .quad      SWAP
        .quad      BASE
        .quad      FETCH
        .quad      USTAR
        .quad      DROP
        .quad      ROT
        .quad      BASE
        .quad      FETCH
        .quad      USTAR
        .quad      DPLUS
        .quad      ZERO
NPNUM3:                 # THEN THEN
        .quad      ZBRAN
        .quad      NPNUM1-.-CW
        .quad      SEMIS
#

#  **************
#  *   NUMBER   *
#  **************
#
    .align     3
N_NUMB:   .quad      6
        .ascii      "NUMBER"
    .align     3
NUMB:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PNUMB-(CW*(C_HOFFSET))
        .quad    N_NUMB
X_NUMB:

LNUMB:
        .quad      LIT, -1, LIN, PSTORE
        .quad      PNUMB, SDLITE
        .quad      SEMIS
#


#  ***************
#  *   >NUMBER   *
#  ***************
#
    .align     3
N_TONUMB:   .quad      7
        .ascii      ">NUMBER"
    .align     3
TONUMB:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    NUMB-(CW*(C_HOFFSET))
        .quad    N_TONUMB
X_TONUMB:

        .quad      TDUP, PLUS, TOR     # End available on return stack.
        .quad      ZERO
        .quad     XQDO
        .quad      TONUM9-.-CW
TONUM1:
        .quad      LDUP, CFET, BASE, FETCH, DIGIT
        .quad      ZEQU
        .quad      ZBRAN
        .quad      TONUM4-.-CW # IF
        .quad      DROP, LLEAV
TONUM4:
        .quad      SWAP, TOR # Address out of the way.
        .quad      SWAP
        .quad      BASE
        .quad      FETCH
        .quad      USTAR
        .quad      DROP
        .quad      ROT
        .quad      BASE
        .quad      FETCH
        .quad      USTAR
        .quad      DPLUS
        .quad      FROMR, ONEP     # Address back.
        .quad     XLOOP
        .quad      TONUM1-.-CW
TONUM9:
        .quad      FROMR
        .quad      OVER, LSUB
        .quad      SEMIS
#
#

#  *************
#  *   FOUND   *
#  *************
#
    .align     3
N_FOUND:   .quad      5
        .ascii      "FOUND"
    .align     3
FOUND:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TONUMB-(CW*(C_HOFFSET))
        .quad    N_FOUND
X_FOUND:

        .quad      SEARCH, TOR
FOUND1: .quad      RR, FETCH
#        .quad      DOTS
        .quad      PFIND, LDUP, ZEQU
        .quad      ZBRAN
        .quad      FOUND3-.-CW
        .quad      DROP
        .quad      RR, FETCH, LIT, FORTH, LSUB #Was this ONLY?
        .quad      ZBRAN
        .quad      FOUND2-.-CW
        .quad      FROMR, CELLP, TOR
        .quad      BRAN
        .quad      FOUND1-.-CW
FOUND2: .quad      ZERO
FOUND3: .quad      RDROP
        .quad      SWAP,DROP,SWAP,DROP
        .quad      SEMIS
#

#  ************
#  *   FIND   *
#  ************
#
    .align     3
N_FIND:   .quad      4
        .ascii      "FIND"
    .align     3
FIND:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FOUND-(CW*(C_HOFFSET))
        .quad    N_FIND
X_FIND:

        .quad      LDUP, COUNT, FOUND
        .quad      LDUP
        .quad      ZBRAN
        .quad      FIND1-.-CW #IF
        .quad      SWAP, DROP # The address.
        # Fine point, get xt by TCFA. Even if a nop.
        .quad      LDUP, TCFA, SWAP
        .quad      TFFA, FETCH
        .quad      LIT, B_IMMED, LAND
        .quad      LIT, -1, SWAP
        .quad      ZBRAN
        .quad      FIND1-.-CW #IF
        .quad      NEGATE
FIND1:               #THEN THEN
        .quad      SEMIS
#

#  **************
#  *   (FIND)   *
#  **************
#
    .align     3
N_PFIND:   .quad      6
        .ascii      "(FIND)"
    .align     3
PFIND:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FIND-(CW*(C_HOFFSET))
        .quad    N_PFIND
X_PFIND:

        .quad      ZERO, RESULT, STORE
        .quad      LIT, MATCHING, SWAP, FORW
        .quad      RESULT,FETCH
        .quad      SEMIS
#

#  *************
#  *   ERROR   *
#  *************
#
    .align     3
N_ERROR:   .quad      5
        .ascii      "ERROR"
    .align     3
ERROR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PFIND-(CW*(C_HOFFSET))
        .quad    N_ERROR
X_ERROR:

        .quad      LWHERE, TFET
        .quad      OVER, LIT, 20, LSUB
        .quad      MAX
        .quad      SWAP,OVER, LSUB
        .quad      ETYPE
        .quad      SKIP
         .quad      18
SB3: .ascii      "? ciforth ERROR # "
       .align     3
        .quad      LIT, SB3
        .quad      LIT, 18
        .quad      ETYPE
        .quad      BASE, FETCH
        .quad      DECA
        .quad      OVER
        .quad      STOD, ZERO, PDDOTR      #This is about (.) 
        .quad      ETYPE
        .quad      BASE, STORE
        .quad      MESS
        .quad      SEMIS
#

#  *************
#  *   CATCH   *
#  *************
#
    .align     3
N_CATCH:   .quad      5
        .ascii      "CATCH"
    .align     3
CATCH:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ERROR-(CW*(C_HOFFSET))
        .quad    N_CATCH
X_CATCH:

        .quad      SPFET, CELLP, TOR
        .quad      HANDLER, FETCH, TOR
        .quad      RPFET, HANDLER, STORE
        .quad      EXEC
        .quad      FROMR, HANDLER, STORE
        .quad      RDROP, ZERO
        .quad      SEMIS
#

#  *************
#  *   THROW   *
#  *************
#
    .align     3
N_THROW:   .quad      5
        .ascii      "THROW"
    .align     3
THROW:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CATCH-(CW*(C_HOFFSET))
        .quad    N_THROW
X_THROW:

        .quad      LDUP
        .quad      ZBRAN
        .quad      THROW1-.-CW
        .quad      HANDLER, FETCH, ZEQU
        .quad      ZBRAN
        .quad      THROW2-.-CW
        .quad      ERROR
        .quad      MTBUF  # A (too) crude way to remove locks
        .quad      SZERO, FETCH, SPSTO
        .quad      QUIT
THROW2:
        .quad      HANDLER, FETCH, RPSTO
        .quad      FROMR, HANDLER, STORE
        .quad      FROMR, SWAP, TOR
        .quad      SPSTO
        .quad      FROMR
        .quad      X
THROW1:
        .quad      DROP
        .quad      SEMIS
#


#  ****************
#  *   (ABORT")   *
#  ****************
#
    .align     3
N_PABORTQ:   .quad      8
        .ascii      "(ABORT\")"
    .align     3
PABORTQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    THROW-(CW*(C_HOFFSET))
        .quad    N_PABORTQ
X_PABORTQ:

        .quad      ROT
        .quad      ZBRAN
        .quad      PABQ1-.-CW #IF
        .quad      ETYPE
        .quad      SIGNON, ABORT
        .quad      BRAN
        .quad      PABQ2-.-CW #ELSE
PABQ1:  .quad       TDROP
PABQ2:   .quad      SEMIS
#

#  **************
#  *   ABORT"   *
#  **************
#
    .align     3
N_ABORTQ:   .quad      6
        .ascii      "ABORT\""
    .align     3
ABORTQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    PABORTQ-(CW*(C_HOFFSET))
        .quad    N_ABORTQ
X_ABORTQ:

        .quad      QCOMP
        .quad      DENQ
        .quad      LIT, PABORTQ, COMMA
        .quad      SEMIS
#
#

#  ***********
#  *   ID.   *
#  ***********
#
    .align     3
N_IDDOT:   .quad      3
        .ascii      "ID."
    .align     3
IDDOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ABORTQ-(CW*(C_HOFFSET))
        .quad    N_IDDOT
X_IDDOT:

        .quad      LDUP, TFFA
        .quad      FETCH, LIT, B_DUMMY, LXOR
        .quad      ZBRAN
        .quad      IDDOT1-.-CW
        .quad      TNFA
        .quad      FETCH
        .quad      SFET
        .quad      LTYPE
        .quad      SPACE
        .quad      SPACE
        .quad      SPACE
        .quad      BRAN
        .quad      IDDOT2-.-CW
IDDOT1:
        .quad      DROP
IDDOT2:
        .quad      SEMIS
#

#  ****************
#  *   (CREATE)   *
#  ****************
#
    .align     3
N_PCREAT:   .quad      8
        .ascii      "(CREATE)"
    .align     3
PCREAT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    IDDOT-(CW*(C_HOFFSET))
        .quad    N_PCREAT
X_PCREAT:

        .quad      LDUP
        .quad      ZEQU
        .quad      LIT, 5, QERR
        .quad      TDUP
        .quad      FOUND
        .quad      LDUP
        .quad      ZBRAN
        .quad      CREA1-.-CW #IF
        .quad      LDUP, TFFA, FETCH
        .quad      LIT, B_DENOT, LAND, ZEQU
        .quad      ZBRAN
        .quad      CREA1-.-CW #IF
        .quad      IDDOT
        .quad      LIT,4
        .quad      MESS
        .quad      SPACE   #THEN
        .quad      ZERO
CREA1:  .quad      DROP
 .quad      LALIGN
        .quad      SCOMMA
 .quad      LALIGN
        .quad      HERE,TOR

        .quad      RR, TPHA, COMMA         # Code field.

        .quad      RR, TPHA, COMMA         # Data field.

        .quad      ZERO, COMMA # Flag field.

        .quad      CURR, FETCH, TLFA
        .quad      LDUP, FETCH, COMMA   # Link field.
        .quad      RR, SWAP, STORE

        .quad      COMMA   # Name field.

        .quad      RDROP
        .quad      SEMIS
#

#  *****************
#  *   [COMPILE]   *
#  *****************
#
    .align     3
N_BCOMP:   .quad      9
        .ascii      "[COMPILE]"
    .align     3
BCOMP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    PCREAT-(CW*(C_HOFFSET))
        .quad    N_BCOMP
X_BCOMP:

        .quad      LPWORD
        .quad      FOUND
        .quad      LDUP
        .quad      ZEQU
        .quad      ZERO, QERR
        .quad      TCFA
        .quad      COMMA
        .quad      SEMIS
#

#  ****************
#  *   POSTPONE   *
#  ****************
#
    .align     3
N_POSTP:   .quad      8
        .ascii      "POSTPONE"
    .align     3
POSTP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    BCOMP-(CW*(C_HOFFSET))
        .quad    N_POSTP
X_POSTP:

        .quad      LPWORD
        .quad      FOUND
        .quad      LDUP
        .quad      ZEQU
        .quad      ZERO, QERR
        .quad      LDUP, TFFA, FETCH
        .quad      LIT, B_IMMED, LAND, ZEQU
        .quad      ZBRAN
        .quad      POSTP1-.-CW
         .quad      LIT, LIT, COMMA
         .quad      COMMA
         .quad      LIT, COMMA, COMMA
        .quad      BRAN
        .quad      POSTP2-.-CW
POSTP1:
         .quad      COMMA
POSTP2:
        .quad      SEMIS
#

#  ***************
#  *   LITERAL   *
#  ***************
#
    .align     3
N_LITER:   .quad      7
        .ascii      "LITERAL"
    .align     3
LITER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    POSTP-(CW*(C_HOFFSET))
        .quad    N_LITER
X_LITER:

        .quad      STATE
        .quad      FETCH
        .quad      ZBRAN
        .quad      LITE1-.-CW #IF
        .quad      LIT, LIT, COMMA
        .quad      COMMA   #THEN
LITE1:  .quad      SEMIS
#

#  ****************
#  *   DLITERAL   *
#  ****************
#
    .align     3
N_DLITE:   .quad      8
        .ascii      "DLITERAL"
    .align     3
DLITE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    LITER-(CW*(C_HOFFSET))
        .quad    N_DLITE
X_DLITE:

        .quad      STATE
        .quad      FETCH
        .quad      ZBRAN
        .quad      DLIT1-.-CW # IF
        .quad      SWAP
        .quad      LITER
        .quad      LITER   # THEN
DLIT1:  .quad      SEMIS
#
#

#  *****************
#  *   SDLITERAL   *
#  *****************
#
    .align     3
N_SDLITE:   .quad      9
        .ascii      "SDLITERAL"
    .align     3
SDLITE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DLITE-(CW*(C_HOFFSET))
        .quad    N_SDLITE
X_SDLITE:

        .quad      DPL
        .quad      FETCH
        .quad      ZBRAN
        .quad      SDLIT1-.-CW # IF
        .quad      DLITE
        .quad      BRAN
        .quad      SDLIT2-.-CW # IF
SDLIT1:
        .quad      DROP, LITER
SDLIT2:
        .quad      SEMIS
#


#  **************
#  *   ?STACK   *
#  **************
#
    .align     3
N_QSTAC:   .quad      6
        .ascii      "?STACK"
    .align     3
QSTAC:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SDLITE-(CW*(C_HOFFSET))
        .quad    N_QSTAC
X_QSTAC:

        .quad      SPFET
        .quad      SZERO
        .quad      FETCH
        .quad      SWAP
        .quad      ULESS
        .quad      ONE, QERR
        .quad      SPFET
        .quad      HERE
        .quad      LIT,0x80
        .quad      PLUS
        .quad      ULESS
        .quad      LIT, 7, QERR
        .quad      SEMIS
        .eject
#
#

#  *****************
#  *   INTERPRET   *
#  *****************
#
    .align     3
N_INTER:   .quad      9
        .ascii      "INTERPRET"
    .align     3
INTER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QSTAC-(CW*(C_HOFFSET))
        .quad    N_INTER
X_INTER:

INTE1:
        .quad      LPWORD
        .quad      LDUP      # Zero length.
        .quad      ZBRAN
        .quad      INTE8-.-CW #WHILE
#       .quad      DOTS
#       .quad      TDUP, LTYPE
        .quad      OVER, TOR       # Save old parse pointer.
        .quad      FOUND
        .quad      LDUP, ZEQU
        .quad      LIT, 12, QERR
        .quad      LDUP, TFFA, FETCH
        .quad      LDUP, LIT, B_DENOT, LAND #Retain copy of flags.
        .quad      ZBRAN
        .quad      INTE3B-.-CW #IF
        .quad      OVER, TNFA, FETCH, FETCH
        .quad      RR, PLUS, LIN, STORE  #Skip over prefix.
INTE3B:                  #THEN 
        .quad      RDROP           # Drop old parse pointer.
        .quad      LIT, B_IMMED, LAND
        .quad      STATE, FETCH, ZEQU, LOR
        .quad      ZBRAN
        .quad      INTE3-.-CW #IF
        .quad      EXEC
        .quad      BRAN
        .quad      INTE4-.-CW #IF
INTE3:
        .quad      COMMA
                        #THEN
INTE4:
        .quad      QSTAC
        .quad      BRAN
        .quad      INTE1-.-CW  #AGAIN
INTE8:  .quad      DROP, DROP
        .quad      SEMIS
#

#  *****************
#  *   IMMEDIATE   *
#  *****************
#
    .align     3
N_IMMED:   .quad      9
        .ascii      "IMMEDIATE"
    .align     3
IMMED:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    INTER-(CW*(C_HOFFSET))
        .quad    N_IMMED
X_IMMED:

        .quad      LATEST
        .quad      TFFA
        .quad      LIT, B_IMMED
        .quad      TOGGL
        .quad      SEMIS
#

#  ******************
#  *   VOCABULARY   *
#  ******************
#
    .align     3
N_VOCAB:   .quad      10
        .ascii      "VOCABULARY"
    .align     3
VOCAB:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    IMMED-(CW*(C_HOFFSET))
        .quad    N_VOCAB
X_VOCAB:

        .quad      CREATE
        .quad      LATEST   # Link this DEA into VOC-LINK chain.
        .quad      VOCL
        .quad      FETCH
        .quad      COMMA
        .quad      VOCL
        .quad      STORE
        .quad      ZERO, COMMA   # Dummy code field
        .quad      ZERO, COMMA   # Dummy data field
        .quad      LIT, B_DUMMY, COMMA # Dummy flag field
        .quad      ZERO, COMMA #End of links 

        .quad      DOES
DOVOC:
        .quad      ALSO
        .quad      CELLP   # Make it a WID. 
        .quad      SEARCH
        .quad      STORE
        .quad      SEMIS
        .eject
#
#   The link to task is a cold start value only.
#   It is updated each time a definition is
#   appended to the 'FORTH' vocabulary.
#

#

#  *******************
#  *   DEFINITIONS   *
#  *******************
#
    .align     3
N_DEFIN:   .quad      11
        .ascii      "DEFINITIONS"
    .align     3
DEFIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    VOCAB-(CW*(C_HOFFSET))
        .quad    N_DEFIN
X_DEFIN:

        .quad      SEARCH
        .quad      FETCH
        .quad      CURR
        .quad      STORE
        .quad      SEMIS
#

#  ************
#  *   ALSO   *
#  ************
#
    .align     3
N_ALSO:   .quad      4
        .ascii      "ALSO"
    .align     3
ALSO:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DEFIN-(CW*(C_HOFFSET))
        .quad    N_ALSO
X_ALSO:

        .quad      SEARCH, LDUP, CELLP
        .quad      LIT, (CW*(8-1))
        .quad      LMOVE
        .quad      LIT, FORTH  #End sentinel for array of word lists.
        .quad      SEARCH, LIT, (CW*(8)), PLUS
        .quad      STORE #Trim sets of wordset.
        .quad      SEMIS
#

#  ****************
#  *   PREVIOUS   *
#  ****************
#
    .align     3
N_PREVI:   .quad      8
        .ascii      "PREVIOUS"
    .align     3
PREVI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ALSO-(CW*(C_HOFFSET))
        .quad    N_PREVI
X_PREVI:

        .quad      SEARCH, LDUP, CELLP, SWAP
        .quad      LIT, (CW*(8))
        .quad      LMOVE
        .quad      SEMIS
#

#  ************
#  *   ONLY   *
#  ************
#
    .align     3
N_ONLY:   .quad      4
        .ascii      "ONLY"
    .align     3
ONLY:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PREVI-(CW*(C_HOFFSET))
        .quad    N_ONLY
X_ONLY:

        .quad      LIT, FORTH, SEARCH, STORE
        .quad      SEARCH, LDUP, CELLP
        .quad      LIT, (CW*(8-1))
        .quad      LCMOVE
        .quad      SEMIS
#

#  *********
#  *   (   *
#  *********
#
    .align     3
N_PAREN:   .quad      1
        .ascii      "("
    .align     3
PAREN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    ONLY-(CW*(C_HOFFSET))
        .quad    N_PAREN
X_PAREN:

        .quad      LIT,')'
        .quad      PPARS
        .quad      TDROP
        .quad      SEMIS
#
#

#  *********
#  *   \   *
#  *********
#
    .align     3
N_BACKS:   .quad      1
        .ascii      "\\"
    .align     3
BACKS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    PAREN-(CW*(C_HOFFSET))
        .quad    N_BACKS
X_BACKS:

        .quad      LIT,ALF
        .quad      PPARS
        .quad      TDROP
        .quad      SEMIS
#

#  ************
#  *   QUIT   *
#  ************
#
    .align     3
N_QUIT:   .quad      4
        .ascii      "QUIT"
    .align     3
QUIT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BACKS-(CW*(C_HOFFSET))
        .quad    N_QUIT
X_QUIT:

        .quad      LBRAC
QUIT1:                  #BEGIN
        .quad      RZERO
        .quad      FETCH
        .quad      RPSTO
        .quad      LIT 
        .quad      PACCEP

        .quad      CATCH
        .quad      ZBRAN
        .quad      OKAY-.-CW
        .quad      BYE     # Nothing else can be done!
OKAY:
 #
        .quad       SETSRC
        .quad      INTER
        .quad      OK
        .quad      BRAN
        .quad      QUIT1-.-CW  #AGAIN
        .quad      SEMIS   #Unnecessary, but helpful for decompilation.
#

#  **********
#  *   OK   *
#  **********
#
    .align     3
N_OK:   .quad      2
        .ascii      "OK"
    .align     3
OK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QUIT-(CW*(C_HOFFSET))
        .quad    N_OK
X_OK:

        .quad      STATE
        .quad      FETCH
        .quad      ZEQU
        .quad      ZBRAN
        .quad      OK2-.-CW #IF
        .quad      SKIP
         .quad      3
SB4: .ascii      " OK"
       .align     3
        .quad      LIT, SB4
        .quad      LIT, 3
        .quad      LTYPE
        .quad      CR
OK2:
        .quad      SEMIS
#

#  *************
#  *   ABORT   *
#  *************
#
    .align     3
N_ABORT:   .quad      5
        .ascii      "ABORT"
    .align     3
ABORT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    OK-(CW*(C_HOFFSET))
        .quad    N_ABORT
X_ABORT:

        .quad      SZERO, FETCH, SPSTO
        .quad      ZERO, HANDLER, STORE
        .quad      DECA
        .quad      ONLY
        .quad      FORTH
        .quad      DEFIN
        .quad      QUIT
        .quad      SEMIS   #Unnecessary, but helpful for decompilation.
#
#      WARM START VECTOR COMES HERE
#      For booting code we enter here, real mode and using the switchsegment.
#      BY control BREAK.
WRM:
        BR      $0,LWRM1
LWRM1:   LDA     $29, WRM1-LWRM1($0)
        BR      $31, SETUPST         #Use cold stacks. Till ABORT .
#
WRM1:   .quad      WARM
#

#  ************
#  *   WARM   *
#  ************
#
    .align     3
N_WARM:   .quad      4
        .ascii      "WARM"
    .align     3
WARM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ABORT-(CW*(C_HOFFSET))
        .quad    N_WARM
X_WARM:

        .quad      MTBUF
        .quad      SIGNON
        .quad      ABORT
        .quad      SEMIS   #Unnecessary, but helpful for decompilation.
#


#  ***************
#  *   OPTIONS   *
#  ***************
#
    .align     3
N_OPTIONS:   .quad      7
        .ascii      "OPTIONS"
    .align     3
OPTIONS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    WARM-(CW*(C_HOFFSET))
        .quad    N_OPTIONS
X_OPTIONS:

#       Execute option.
        .quad      ARGS, FETCH, CELLP, CELLP, FETCH, LDUP
        .quad      ZBRAN
        .quad      OPT4-.-CW # No options  
        .quad      FETCH
        .quad      LDUP
        .quad      LIT, 0xff , LAND
        .quad      LIT, '-', UNEQ
        .quad      ZBRAN
        .quad      OPT3-.-CW
        .quad      LIT, 3, LDUP, ERROR
        .quad      XCODE, STORE, BYE
OPT3:
        .quad      LIT, 8, RSHIFT
        .quad      LIT, 0x1f, LAND
        .quad      LOAD
        .quad      ZERO, SWAP # Sign on suppressed.
OPT4:
        .quad      DROP
        .quad      SEMIS   #Unnecessary, but helpful for decompilation.
#


#  ************
#  *   COLD   *
#  ************
#
    .align     3
N_COLD:   .quad      4
        .ascii      "COLD"
    .align     3
COLD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    OPTIONS-(CW*(C_HOFFSET))
        .quad    N_COLD
X_COLD:

        .quad      ZERO, HANDLER, STORE
        .quad      MTBUF
        .quad      FIRST
        .quad      STALEST,STORE
        .quad      FIRST
        .quad      PREV,STORE
# Fill user area for single task.
        .quad      LIT, USINI
        .quad      LIT, USINI+(CW*(1)), FETCH
        .quad      LIT, US
        .quad      LCMOVE

        .quad      LIT, 0, BLINI  #Default, don't write in the library file!
#
        .quad      DECA    # FIXME has to go done by ABORT anyway.
        .quad      ONLY    # FIXME has to go done by ABORT anyway.
        .quad      FORTH   # FIXME has to go done by ABORT anyway.
        .quad      DEFIN   # FIXME has to go done by ABORT anyway.
        .quad      ONE            # Sign on wanted.

        .quad      ZERO, LIT, TCGETS, TERMIO
        .quad      LIT, ioctl, LINOS, ZLESS
        .quad      ZBRAN
        .quad      COLD1-.-CW
        # Not a terminal. Cannot set the terminal, get rid of "OK".
        .quad      DROP, ZERO      # Sign on suppressed.
        .quad      LIT,NOOP  # Suppress OK for pipes.
        .quad      LIT,OK
        .quad      LIT, (CW*(3)), LCMOVE
COLD1:
 #
        .quad      OPTIONS
        .quad      ZBRAN
        .quad      COLD5-.-CW
        .quad      SIGNON    # Suppressed for scripting! Or any options.
COLD5:
        .quad      ABORT
        .quad      BYE     # In case of turnkey programs.
        .quad      SEMIS   # Unnecessary, but helpful for decompilation.
#

#  ***********
#  *   S>D   *
#  ***********
#
    .align     3
N_STOD:   .quad      3
        .ascii      "S>D"
    .align     3
STOD:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    COLD-(CW*(C_HOFFSET))
        .quad    N_STOD
X_STOD:

        LDQ     $3, 0($30)
        BIS     $31, 0, $0
        CMOVLT  $3, 1, $0
        SUBQ    $31, $0, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  ***********
#  *   ABS   *
#  ***********
#
    .align     3
N_LABS:   .quad      3
        .ascii      "ABS"
    .align     3
LABS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STOD-(CW*(C_HOFFSET))
        .quad    N_LABS
X_LABS:

        .quad      LDUP
        .quad      ZLESS
        .quad      ZBRAN
        .quad      PM1-.-CW   #IF
        .quad      NEGATE   #THEN
PM1:
        .quad      SEMIS
#

#  ************
#  *   DABS   *
#  ************
#
    .align     3
N_DABS:   .quad      4
        .ascii      "DABS"
    .align     3
DABS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LABS-(CW*(C_HOFFSET))
        .quad    N_DABS
X_DABS:

        .quad      LDUP
        .quad      ZLESS
        .quad      ZBRAN
        .quad      DPM1-.-CW  #IF
        .quad      DNEGA   #THEN
DPM1:
        .quad      SEMIS
#

#  ***********
#  *   MIN   *
#  ***********
#
    .align     3
N_MIN:   .quad      3
        .ascii      "MIN"
    .align     3
MIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DABS-(CW*(C_HOFFSET))
        .quad    N_MIN
X_MIN:

        .quad      TDUP
        .quad      GREAT
        .quad      ZBRAN
        .quad      MIN1-.-CW  #IF
        .quad      SWAP    #THEN
MIN1:   .quad      DROP
        .quad      SEMIS
#

#  ***********
#  *   MAX   *
#  ***********
#
    .align     3
N_MAX:   .quad      3
        .ascii      "MAX"
    .align     3
MAX:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MIN-(CW*(C_HOFFSET))
        .quad    N_MAX
X_MAX:

        .quad      TDUP
        .quad      LESS
        .quad      ZBRAN
        .quad      MAX1-.-CW  #IF
        .quad      SWAP    #THEN
MAX1:   .quad      DROP
        .quad      SEMIS
#

#  **************
#  *   LSHIFT   *
#  **************
#
    .align     3
N_LSHIFT:   .quad      6
        .ascii      "LSHIFT"
    .align     3
LSHIFT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MAX-(CW*(C_HOFFSET))
        .quad    N_LSHIFT
X_LSHIFT:

        LDQ     $2, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
        SLL     $0, $2, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **************
#  *   RSHIFT   *
#  **************
#
    .align     3
N_RSHIFT:   .quad      6
        .ascii      "RSHIFT"
    .align     3
RSHIFT:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LSHIFT-(CW*(C_HOFFSET))
        .quad    N_RSHIFT
X_RSHIFT:

        LDQ     $2, (CW*(0))($30)
        LDQ     $0, (CW*(1))($30)
        ADDQ      $30, (CW*(2)), $30
        SRL     $0, $2, $0
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#

#  **********
#  *   M*   *
#  **********
#
    .align     3
N_MSTAR:   .quad      2
        .ascii      "M*"
    .align     3
MSTAR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RSHIFT-(CW*(C_HOFFSET))
        .quad    N_MSTAR
X_MSTAR:

        .quad      TDUP
        .quad      LXOR
        .quad      TOR
        .quad      LABS
        .quad      SWAP
        .quad      LABS
        .quad      USTAR
        .quad      FROMR
        .quad      ZLESS
        .quad      ZBRAN
        .quad      DPM2-.-CW  #IF
        .quad      DNEGA   #THEN
DPM2:
        .quad      SEMIS
#

#  **************
#  *   SM/REM   *
#  **************
#
    .align     3
N_MSLAS:   .quad      6
        .ascii      "SM/REM"
    .align     3
MSLAS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MSTAR-(CW*(C_HOFFSET))
        .quad    N_MSLAS
X_MSLAS:

        .quad      OVER
        .quad      TOR
        .quad      TOR
        .quad      DABS
        .quad      RR
        .quad      LABS
        .quad      USLAS
        .quad      FROMR
        .quad      RR
        .quad      LXOR
        .quad      ZLESS
        .quad      ZBRAN
        .quad      PM2-.-CW   #IF
        .quad      NEGATE   #ENDIF
PM2:
        .quad      SWAP
        .quad      FROMR
        .quad      ZLESS
        .quad      ZBRAN
        .quad      PM3-.-CW   #IF
        .quad      NEGATE   #ENDIF
PM3:
        .quad      SWAP
        .quad      SEMIS

#


#  **********
#  *   2/   *
#  **********
#
    .align     3
N_TWOSL:   .quad      2
        .ascii      "2/"
    .align     3
TWOSL:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MSLAS-(CW*(C_HOFFSET))
        .quad    N_TWOSL
X_TWOSL:

        .quad      STOD, TWO, FMSLAS
        .quad      SWAP, DROP
        .quad      SEMIS
#

#  **********
#  *   2*   *
#  **********
#
    .align     3
N_TWOST:   .quad      2
        .ascii      "2*"
    .align     3
TWOST:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TWOSL-(CW*(C_HOFFSET))
        .quad    N_TWOST
X_TWOST:

        .quad      TWO, STAR
        .quad      SEMIS
#

#  **********
#  *   1-   *
#  **********
#
    .align     3
N_ONEM:   .quad      2
        .ascii      "1-"
    .align     3
ONEM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TWOST-(CW*(C_HOFFSET))
        .quad    N_ONEM
X_ONEM:

        .quad      ONE, LSUB
        .quad      SEMIS
#
#

#  **************
#  *   FM/MOD   *
#  **************
#
    .align     3
N_FMSLAS:   .quad      6
        .ascii      "FM/MOD"
    .align     3
FMSLAS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ONEM-(CW*(C_HOFFSET))
        .quad    N_FMSLAS
X_FMSLAS:

        .quad      LDUP, TOR
        .quad      TDUP, LXOR, TOR
        .quad      MSLAS
        .quad      FROMR, ZLESS
        .quad      ZBRAN
        .quad      FMMOD1-.-CW
        .quad      OVER
        .quad      ZBRAN
        .quad      FMMOD1-.-CW
        .quad      ONE, LSUB
        .quad      SWAP, FROMR, PLUS, SWAP
        .quad      BRAN
        .quad      FMMOD2-.-CW
FMMOD1:
        .quad      RDROP
FMMOD2:
        .quad      SEMIS

#
.if 0
## The following is interesting, but doesn't work
## right at the borders of the domain.
##  **************
#  *   FM/MOD   *
#  **************
#
    .align     3
N_FMSLAS:   .quad      6
        .ascii      "FM/MOD"
    .align     3
FMSLAS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FMSLAS-(CW*(C_HOFFSET))
        .quad    N_FMSLAS
X_FMSLAS:

## div: divisor (may change sign)
#
## quot: quotient in building, initially 0
#
## mod: starts as dividend
#
#
## count: # bits remaining to 
#
#
## Alpha boolean:"divisor is negative"
#
## $0 .. $3 : scratch
#
#
#
#
#
#########LDQ     $4, (CW*(0))($30)        #LSW OF DIVISOR
#########LDQ     $2, (CW*(1))($30)        #MSW OF DIVIDEND
#########LDQ     $1, (CW*(2))($30)        #LSW OF DIVIDEND
#########ADDQ    $30, (CW*(1)), $30   # Results occupy one less cells
#########
#########CMPLT   $4, $31, $9
#########BEQ     $9, ENDFM1
#########SUBQ    $31, $4, $4
#########CMPULT  $31, $1, $0  # Borrow.
#########SUBQ    $31, $1, $1
#########SUBQ    $31, $2, $2
#########SUBQ    $2, $0, $2
#ENDFM1:
#########BIS     $31, 64, $8
## Despite the ADDQ/SUBQ we need not initialise $3.
#
#FM1:
## Loop invariant: (mod<<(64-$8)) + ($3<<(64-$8))*$4
#########BEQ     $2, FMENDIF
#########BLT     $2, FMELSE
#########ADDQ    $3, 1, $3
#########SUBQ    $2, $4, $2
#########BR      FMENDIF
#FMELSE:
#########SUBQ    $3, 1, $3
#########ADDQ    $2, $4, $2
#FMENDIF:
#########BEQ     $8, FM2
#########CMPLT   $1, $31, $0 # Carry bit to $0
#########SLL     $2, 1, $2
#########SLL     $1, 1, $1
#########ADDQ    $2, $0, $2
#########SLL     $3, 1, $3
#########SUBQ    $8, 1, $8
#########BR      FM1
#FM2:
#########BLT    $2, FM1
#
#########SUBQ    $31, $2, $0
#########CMOVNE  $9, $0, $2
#
#########STQ     $2, (CW*(1))($30)        #Modulus
#########STQ     $3, (CW*(0))($30)        #Remainder
#########LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0   
#
#
#
#
#
#
.endif
#

#  *********
#  *   *   *
#  *********
#
    .align     3
N_STAR:   .quad      1
        .ascii      "*"
    .align     3
STAR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FMSLAS-(CW*(C_HOFFSET))
        .quad    N_STAR
X_STAR:

        .quad      MSTAR
        .quad      DROP
        .quad      SEMIS
#

#  ************
#  *   /MOD   *
#  ************
#
    .align     3
N_SLMOD:   .quad      4
        .ascii      "/MOD"
    .align     3
SLMOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STAR-(CW*(C_HOFFSET))
        .quad    N_SLMOD
X_SLMOD:

        .quad      TOR
        .quad      STOD
        .quad      FROMR
        .quad      MSLAS
        .quad      SEMIS
#

#  *********
#  *   /   *
#  *********
#
    .align     3
N_SLASH:   .quad      1
        .ascii      "/"
    .align     3
SLASH:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SLMOD-(CW*(C_HOFFSET))
        .quad    N_SLASH
X_SLASH:

        .quad      SLMOD
        .quad      SWAP
        .quad      DROP
        .quad      SEMIS
#

#  ***********
#  *   MOD   *
#  ***********
#
    .align     3
N_LMOD:   .quad      3
        .ascii      "MOD"
    .align     3
LMOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SLASH-(CW*(C_HOFFSET))
        .quad    N_LMOD
X_LMOD:

        .quad      SLMOD
        .quad      DROP
        .quad      SEMIS
#

#  *************
#  *   */MOD   *
#  *************
#
    .align     3
N_SSMOD:   .quad      5
        .ascii      "*/MOD"
    .align     3
SSMOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LMOD-(CW*(C_HOFFSET))
        .quad    N_SSMOD
X_SSMOD:

        .quad      TOR
        .quad      MSTAR
        .quad      FROMR
        .quad      MSLAS
        .quad      SEMIS
#

#  **********
#  *   */   *
#  **********
#
    .align     3
N_SSLA:   .quad      2
        .ascii      "*/"
    .align     3
SSLA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SSMOD-(CW*(C_HOFFSET))
        .quad    N_SSLA
X_SSLA:

        .quad      SSMOD
        .quad      SWAP
        .quad      DROP
        .quad      SEMIS
#

#  *************
#  *   M/MOD   *
#  *************
#
    .align     3
N_MSMOD:   .quad      5
        .ascii      "M/MOD"
    .align     3
MSMOD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SSLA-(CW*(C_HOFFSET))
        .quad    N_MSMOD
X_MSMOD:

        .quad      TOR
        .quad      ZERO
        .quad      RR
        .quad      USLAS
        .quad      FROMR
        .quad      SWAP
        .quad      TOR
        .quad      USLAS
        .quad      FROMR
        .quad      SEMIS
#

#  **************
#  *   (LINE)   *
#  **************
#
    .align     3
N_PLINE:   .quad      6
        .ascii      "(LINE)"
    .align     3
PLINE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MSMOD-(CW*(C_HOFFSET))
        .quad    N_PLINE
X_PLINE:

        .quad      TOR
        .quad      LIT,64
        .quad      MSTAR
        .quad      BBUF
        .quad      FMSLAS
        .quad      FROMR # This blocks, so is screens.
        .quad      PLUS
        .quad      BLOCK
        .quad      PLUS
        .quad      LIT,63  # Leave off the '\n'.
        .quad      SEMIS
#

#  **************
#  *   ERRSCR   *
#  **************
#
    .align     3
N_ERRSCR:   .quad      6
        .ascii      "ERRSCR"
    .align     3
ERRSCR:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PLINE-(CW*(C_HOFFSET))
        .quad    N_ERRSCR
X_ERRSCR:

        .quad ERRORSCREEN
#

#  ***************
#  *   MESSAGE   *
#  ***************
#
    .align     3
N_MESS:   .quad      7
        .ascii      "MESSAGE"
    .align     3
MESS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ERRSCR-(CW*(C_HOFFSET))
        .quad    N_MESS
X_MESS:

        .quad      LWARN
        .quad      FETCH
        .quad      ZBRAN
        .quad      MESS1-.-CW #IF
        .quad      ERRSCR, FETCH
        .quad      PLINE, ONEP     # Also print the '\n' !
        .quad      ETYPE
        .quad      X
MESS1:                  #THEN
        .quad      DROP
        .quad      CR
        .quad      SEMIS
#

#  ***************
#  *   STALEST   *
#  ***************
#
    .align     3
N_STALEST:   .quad      7
        .ascii      "STALEST"
    .align     3
STALEST:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MESS-(CW*(C_HOFFSET))
        .quad    N_STALEST
X_STALEST:

        .quad BUF1
#

#  ************
#  *   PREV   *
#  ************
#
    .align     3
N_PREV:   .quad      4
        .ascii      "PREV"
    .align     3
PREV:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STALEST-(CW*(C_HOFFSET))
        .quad    N_PREV
X_PREV:

        .quad      BUF1
#

#  *************
#  *   #BUFF   *
#  *************
#
    .align     3
N_NOBUF:   .quad      5
        .ascii      "#BUFF"
    .align     3
NOBUF:        .quad    DOCON
        .quad   NBUF
        .quad    0
        .quad    PREV-(CW*(C_HOFFSET))
        .quad    N_NOBUF
X_NOBUF:

#

#  ************
#  *   +BUF   *
#  ************
#
    .align     3
N_PBUF:   .quad      4
        .ascii      "+BUF"
    .align     3
PBUF:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    NOBUF-(CW*(C_HOFFSET))
        .quad    N_PBUF
X_PBUF:

        .quad      LIT,(KBBUF+2*CW)
        .quad      PLUS,LDUP
        .quad      LIMIT,EQUAL
        .quad      ZBRAN
        .quad      PBUF1-.-CW
        .quad      DROP,FIRST
PBUF1:  .quad      LDUP, PREV, FETCH, LSUB
        .quad      SEMIS
#

#  **************
#  *   UPDATE   *
#  **************
#
    .align     3
N_UPDAT:   .quad      6
        .ascii      "UPDATE"
    .align     3
UPDAT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PBUF-(CW*(C_HOFFSET))
        .quad    N_UPDAT
X_UPDAT:

        .quad      PREV, FETCH
        .quad      LDUP, CELLP,CELLP
        .quad      SWAP, FETCH
        .quad      LOFFSET,  FETCH, PLUS
        .quad      ZERO
        .quad      RSLW
        .quad      SEMIS
#

#  *********************
#  *   EMPTY-BUFFERS   *
#  *********************
#
    .align     3
N_MTBUF:   .quad      13
        .ascii      "EMPTY-BUFFERS"
    .align     3
MTBUF:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    UPDAT-(CW*(C_HOFFSET))
        .quad    N_MTBUF
X_MTBUF:

        .quad      FIRST
        .quad      LIMIT,OVER
        .quad      LSUB,LERASE
        .quad      SEMIS
        .eject
#

#  ****************
#  *   (BUFFER)   *
#  ****************
#
    .align     3
N_BUFFER:   .quad      8
        .ascii      "(BUFFER)"
    .align     3
BUFFER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MTBUF-(CW*(C_HOFFSET))
        .quad    N_BUFFER
X_BUFFER:

# Find the buffer, if it is already here.
    .quad      PREV, FETCH
BUFFER1:
    .quad          TOR, RR, FETCH, OVER, EQUAL
    .quad      ZBRAN
        .quad      BUFFER3-.-CW
    .quad        DROP, FROMR, EXIT
BUFFER3:
    .quad          FROMR
    .quad      PBUF, ZEQU
    .quad      ZBRAN
        .quad      BUFFER1-.-CW
    .quad       DROP
# Just allocate the stalest buffer.
    .quad       STALEST,   FETCH, TOR
# Remember the next stalest buffer. 
    .quad       RR
BUFFER2:
    .quad       PBUF, OVER, CELLP, FETCH
    .quad       LIT, -1, GREAT, LAND
    .quad      ZBRAN
        .quad      BUFFER2-.-CW
    .quad       STALEST, STORE
# Fill in the house keeping.
    .quad       RR, STORE
    .quad       ZERO, RR, CELLP, STORE
    .quad       RR, PREV, STORE
        .quad      FROMR
        .quad      SEMIS
#

#  *************
#  *   BLOCK   *
#  *************
#
    .align     3
N_BLOCK:   .quad      5
        .ascii      "BLOCK"
    .align     3
BLOCK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BUFFER-(CW*(C_HOFFSET))
        .quad    N_BLOCK
X_BLOCK:

        .quad      LIT, PMASK, LAND
        .quad      BUFFER
        .quad      LDUP, CELLP, FETCH, ZEQU
        .quad      ZBRAN
        .quad      BLOCK1-.-CW
        .quad      LDUP, CELLP, CELLP
        .quad      OVER, FETCH
        .quad      LOFFSET,  FETCH, PLUS
        .quad      ONE
        .quad      RSLW
        .quad      ONE, OVER, CELLP, STORE
BLOCK1:
        .quad      LDUP, PREV, STORE
        .quad      CELLP, CELLP
        .quad      SEMIS
#

#  *************
#  *   FLUSH   *
#  *************
#
    .align     3
N_FLUSH:   .quad      5
        .ascii      "FLUSH"
    .align     3
FLUSH:        .quad    DOCOL
        .quad   (MTBUF+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad    0
        .quad    BLOCK-(CW*(C_HOFFSET))
        .quad    N_FLUSH
X_FLUSH:


# Unlock all buffers
        .quad      LIMIT
        .quad      FIRST, CELLP
        .quad     XDO
        .quad      FLUS2-.-CW
FLUS1:  .quad      ZERO, IDO, STORE
        .quad      LIT,(KBBUF+2*CW)
        .quad     PLOOP
        .quad      FLUS1-.-CW
FLUS2:
        .quad      SEMIS
#

#  ************
#  *   SAVE   *
#  ************
#
    .align     3
N_SAVE:   .quad      4
        .ascii      "SAVE"
    .align     3
SAVE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FLUSH-(CW*(C_HOFFSET))
        .quad    N_SAVE
X_SAVE:

        .quad      FROMR
        .quad      SRC, TFET
        .quad      LIN, FETCH
        .quad      TOR, TOR, TOR
        .quad      TOR
        .quad SEMIS
#

#  ***************
#  *   RESTORE   *
#  ***************
#
    .align     3
N_RESTO:   .quad      7
        .ascii      "RESTORE"
    .align     3
RESTO:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SAVE-(CW*(C_HOFFSET))
        .quad    N_RESTO
X_RESTO:

        .quad      FROMR
        .quad      FROMR, FROMR, FROMR
        .quad      LIN, STORE
        .quad      SRC, TSTOR
        .quad      TOR
        .quad SEMIS
#


#  ******************
#  *   SAVE-INPUT   *
#  ******************
#
    .align     3
N_SAVEI:   .quad      10
        .ascii      "SAVE-INPUT"
    .align     3
SAVEI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RESTO-(CW*(C_HOFFSET))
        .quad    N_SAVEI
X_SAVEI:

        .quad      SRC, TFET
        .quad      LIN, FETCH
        .quad      LIT, 3
        .quad SEMIS
#

#  *********************
#  *   RESTORE-INPUT   *
#  *********************
#
    .align     3
N_RESTOI:   .quad      13
        .ascii      "RESTORE-INPUT"
    .align     3
RESTOI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SAVEI-(CW*(C_HOFFSET))
        .quad    N_RESTOI
X_RESTOI:

        .quad      DROP
        .quad      LIN, STORE
        .quad      SRC, TSTOR
        .quad SEMIS
#
#

#  ************
#  *   LOCK   *
#  ************
#
    .align     3
N_LLOCK:   .quad      4
        .ascii      "LOCK"
    .align     3
LLOCK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RESTOI-(CW*(C_HOFFSET))
        .quad    N_LLOCK
X_LLOCK:

        .quad      BLOCK
        .quad      LIT, CW, LSUB
        .quad      LIT, -2, SWAP, PSTORE
        .quad      SEMIS
#

#  **************
#  *   UNLOCK   *
#  **************
#
    .align     3
N_LUNLOCK:   .quad      6
        .ascii      "UNLOCK"
    .align     3
LUNLOCK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LLOCK-(CW*(C_HOFFSET))
        .quad    N_LUNLOCK
X_LUNLOCK:

        .quad      BLOCK
        .quad      LIT, CW, LSUB
        .quad      TWO, SWAP, PSTORE
        .quad      SEMIS
#

#  ************
#  *   LOAD   *
#  ************
#
    .align     3
N_LOAD:   .quad      4
        .ascii      "LOAD"
    .align     3
LOAD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LUNLOCK-(CW*(C_HOFFSET))
        .quad    N_LOAD
X_LOAD:

        .quad      LDUP, THRU
        .quad      SEMIS
#

#  ************
#  *   THRU   *
#  ************
#
    .align     3
N_THRU:   .quad      4
        .ascii      "THRU"
    .align     3
THRU:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LOAD-(CW*(C_HOFFSET))
        .quad    N_THRU
X_THRU:

        .quad      SAVE
        .quad      ONEP, SWAP
        .quad     XDO
        .quad      THRU2-.-CW
THRU1:
        .quad      IDO, LLOCK
        .quad      IDO, BLOCK
        .quad      LIT, KBBUF
        .quad      SETSRC
        .quad      LIT, INTER, CATCH
        .quad      IDO, LUNLOCK
        .quad      QDUP
        .quad      ZBRAN
        .quad      THRU3-.-CW
        .quad      RDROP, RDROP, RDROP# UNLOOP.
        .quad      RESTO
        .quad      THROW
THRU3:
        .quad     XLOOP
        .quad      THRU1-.-CW
THRU2:
        .quad      RESTO
        .quad      SEMIS
#

#

#  ***********
#  *   BLK   *
#  ***********
#
    .align     3
N_BLK:   .quad      3
        .ascii      "BLK"
    .align     3
BLK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    THRU-(CW*(C_HOFFSET))
        .quad    N_BLK
X_BLK:

        .quad      LIN, FETCH
        .quad      FIRST, LIMIT, WITHIN
        .quad      SRC, TFET, LSUB
        .quad      LIT, 1024, EQUAL, LAND
        .quad      ZBRAN
        .quad      BLK1-.-CW
        .quad      SRC, FETCH, TWO, LCELLS, LSUB, FETCH
        .quad      BRAN
        .quad      BLK2-.-CW
BLK1:
        .quad      ZERO
BLK2:
        .quad      PBLK, STORE
        .quad      PBLK
        .quad      SEMIS
#

#  ***********
#  *   -->   *
#  ***********
#
    .align     3
N_ARROW:   .quad      3
        .ascii      "-->"
    .align     3
ARROW:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    BLK-(CW*(C_HOFFSET))
        .quad    N_ARROW
X_ARROW:

        .quad      QLOAD
        .quad      BLK, FETCH
        .quad      LDUP, LUNLOCK
        .quad      ONEP
        .quad      LDUP, LLOCK
        .quad      LDUP, BLK, STORE
        .quad      BLOCK
        .quad      LIT, KBBUF
        .quad      SETSRC
        .quad      SEMIS
        .eject
#
#


#  *************
#  *   LINOS   *
#  *************
#
    .align     3
N_LINOS:   .quad      5
        .ascii      "LINOS"
    .align     3
LINOS:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ARROW-(CW*(C_HOFFSET))
        .quad    N_LINOS
X_LINOS:

        LDQ     $0, (CW*(0))($30) # Function number
        LDQ     $18, (CW*(1))($30) # Third parameter, if any
        LDQ     $17, (CW*(2))($30) # Second parameter, if any
        LDQ     $16, (CW*(3))($30) # First parameter.
        ADDQ    $30, (CW*(4)), $30
        CALLSYS             # Generic call on LINUX 
        SUBQ    $31,$0, $1    #Negated: the error number.
        CMOVNE  $19, $1, $0   #If $19 set: error.
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0        # Positive means okay. Negative means -errno. 
#

#  **************
#  *   LINOS5   *
#  **************
#
    .align     3
N_LINOS5:   .quad      6
        .ascii      "LINOS5"
    .align     3
LINOS5:        .quad    .+(CW*(PH_OFFSET-C_HOFFSET))
        .quad   .+(CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LINOS-(CW*(C_HOFFSET))
        .quad    N_LINOS5
X_LINOS5:

        LDQ     $0, (CW*(0))($30) # Function number
        LDQ     $20, (CW*(1))($30) # Fifth parameter, if any
        LDQ     $19, (CW*(2))($30) # Fourth parameter, if any
        LDQ     $18, (CW*(3))($30) # Third parameter, if any
        LDQ     $17, (CW*(4))($30) # Second parameter, if any
        LDQ     $16, (CW*(5))($30) # First parameter.
        ADDQ    $30, (CW*(6)), $30
        CALLSYS             # Generic call on LINUX 
        SUBQ    $31,$0, $1    #Negated: the error number.
        CMOVNE  $19, $1, $0   #If $19 set: error.
                SUBQ    $30, CW, $30
    STQ     $0, 0($30)
        LDQ    $0, 0($29)
        ADDQ    $29, CW, $29
        LDQ     $1, 0($0)
        JMP     $31, ($1), 0        # Positive means okay. Negative means -errno. 
#

#  **********
#  *   MS   *
#  **********
#
    .align     3
N_MS:   .quad      2
        .ascii      "MS"
    .align     3
MS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LINOS5-(CW*(C_HOFFSET))
        .quad    N_MS
X_MS:

        .quad      LIT, 1000, LIT, 1000000, SSMOD # (msec -- usec sec) 
        .quad      SWAP, LIT, 32, LSHIFT, LOR # Compose 
        .quad      LIT, TV, STORE
        .quad      ZERO, ZERO
        .quad      ZERO, ZERO
        .quad      LIT, TV
        .quad      LIT, select, LINOS5
        .quad      QERRUR
        .quad      SEMIS
        .align    
TV:     .space    SIZE_TIMEVAL    #  Two 32 bit values! 
#
#
        .eject

#------------------------------------
#       SYSTEM DEPENDANT FILE I/O    
#------------------------------------



#  *************
#  *   RWBUF   *
#  *************
#
    .align     3
N_RWBUF:   .quad      5
        .ascii      "RWBUF"
    .align     3
RWBUF:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    MS-(CW*(C_HOFFSET))
        .quad    N_RWBUF
X_RWBUF:

        .space    0x200
 #
#


#  ***********
#  *   ZEN   *
#  ***********
#
    .align     3
N_ZEN:   .quad      3
        .ascii      "ZEN"
    .align     3
ZEN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RWBUF-(CW*(C_HOFFSET))
        .quad    N_ZEN
X_ZEN:

        .quad      RWBUF, SSTOR
        .quad      ZERO, RWBUF, CHAPP
        .quad      RWBUF, CELLP
         
        .quad      SEMIS
 #
#


#  *****************
#  *   OPEN-FILE   *
#  *****************
#
    .align     3
N_OFILE:   .quad      9
        .ascii      "OPEN-FILE"
    .align     3
OFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ZEN-(CW*(C_HOFFSET))
        .quad    N_OFILE
X_OFILE:

        .quad      TOR, ZEN, FROMR, X
        .quad      LIT, open, LINOS
        .quad      LDUP, ZERO, MIN
        .quad      SEMIS
 #
#


#  ******************
#  *   CLOSE-FILE   *
#  ******************
#
    .align     3
N_CFILE:   .quad      10
        .ascii      "CLOSE-FILE"
    .align     3
CFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    OFILE-(CW*(C_HOFFSET))
        .quad    N_CFILE
X_CFILE:

        .quad      X, X
        .quad      LIT, close, LINOS
        .quad      SEMIS
 #
#


#  *******************
#  *   CREATE-FILE   *
#  *******************
#
    .align     3
N_CREATEF:   .quad      11
        .ascii      "CREATE-FILE"
    .align     3
CREATEF:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CFILE-(CW*(C_HOFFSET))
        .quad    N_CREATEF
X_CREATEF:

        .quad      TOR, ZEN, LIT, O_CREAT|O_WRONLY|O_TRUNC, FROMR
        .quad      LIT, open, LINOS
        .quad      LDUP, ZERO, MIN
        .quad      SEMIS
 #
#


#  *******************
#  *   DELETE-FILE   *
#  *******************
#
    .align     3
N_DFILE:   .quad      11
        .ascii      "DELETE-FILE"
    .align     3
DFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    CREATEF-(CW*(C_HOFFSET))
        .quad    N_DFILE
X_DFILE:

        .quad      ZEN, X, X
        .quad      LIT, unlink, LINOS
        .quad      SEMIS
 #
#


#  *****************
#  *   READ-FILE   *
#  *****************
#
    .align     3
N_RFILE:   .quad      9
        .ascii      "READ-FILE"
    .align     3
RFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DFILE-(CW*(C_HOFFSET))
        .quad    N_RFILE
X_RFILE:

        .quad      ROT, ROT
        .quad      LIT, read, LINOS
        .quad      LDUP, ZERO, MAX, SWAP, ZERO, MIN
        .quad      SEMIS
 #
#


#  ***********************
#  *   REPOSITION-FILE   *
#  ***********************
#
    .align     3
N_PFILE:   .quad      15
        .ascii      "REPOSITION-FILE"
    .align     3
PFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RFILE-(CW*(C_HOFFSET))
        .quad    N_PFILE
X_PFILE:

        .quad      TOR, DROP, FROMR   #Convert to single precision.
        .quad      SWAP
        .quad      LIT, SEEK_SET
        .quad      LIT, lseek, LINOS
        .quad      ZERO, MIN
        .quad      SEMIS
 #
#


#  ******************
#  *   WRITE-FILE   *
#  ******************
#
    .align     3
N_WFILE:   .quad      10
        .ascii      "WRITE-FILE"
    .align     3
WFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PFILE-(CW*(C_HOFFSET))
        .quad    N_WFILE
X_WFILE:

        .quad      ROT, ROT
        .quad      LIT, write, LINOS
        .quad      ZERO, MIN
        .quad      SEMIS
 #
#

#  ****************
#  *   GET-FILE   *
#  ****************
#
    .align     3
N_GETFILE:   .quad      8
        .ascii      "GET-FILE"
    .align     3
GETFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    WFILE-(CW*(C_HOFFSET))
        .quad    N_GETFILE
X_GETFILE:

        .quad      TDUP, SCOMMA, DROP
        .quad      LIT, 'F'+(0x100*('i'+0x100*('L'+0x100*'e'))), COMMA #Magic number.
        .quad      ZERO, OFILE, THROW, TOR
        .quad      HERE, LDUP
        .quad      LEM, OVER, LSUB, LIT, 6, SLASH, LDUP, ALLOT
        .quad      LIT, 1000, LSUB
        .quad      RR, RFILE, THROW
        .quad      FROMR, CFILE, THROW
        .quad      TDUP, PLUS, LDP, STORE        # No allocation if it fails.
        .quad      SEMIS
#

#  ****************
#  *   PUT-FILE   *
#  ****************
#
    .align     3
N_PUTFILE:   .quad      8
        .ascii      "PUT-FILE"
    .align     3
PUTFILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    GETFILE-(CW*(C_HOFFSET))
        .quad    N_PUTFILE
X_PUTFILE:

        .quad      LIT, 0x1ed   #  Octal 755 
        .quad      CREATEF, THROW
        .quad      LDUP, TOR
        .quad      WFILE, THROW
        .quad      FROMR, CFILE, THROW
        .quad      SEMIS
#

#  ****************
#  *   INCLUDED   *
#  ****************
#
    .align     3
N_INCLUD:   .quad      8
        .ascii      "INCLUDED"
    .align     3
INCLUD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PUTFILE-(CW*(C_HOFFSET))
        .quad    N_INCLUD
X_INCLUD:

        .quad      HERE, TOR
        .quad      LIT, GETFILE, CATCH
        .quad      LDUP
        .quad      ZBRAN
        .quad      INCLUD1-.-CW
        .quad      FROMR, LDP, STORE
        .quad      THROW
        .quad      BRAN
        .quad      INCLUD2-.-CW
INCLUD1:
        .quad      RDROP, DROP
INCLUD2:
        .quad      EVALUATE
        .quad      SEMIS
#

#  ******************
#  *   REFILL-TIB   *
#  ******************
#
    .align     3
N_REFTIB:   .quad      10
        .ascii      "REFILL-TIB"
    .align     3
REFTIB:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    INCLUD-(CW*(C_HOFFSET))
        .quad    N_REFTIB
X_REFTIB:

        .quad      REMAIND, FETCH, TOR
        .quad      TIB, FETCH, RR, PLUS
        .quad      LIT, RTS/2, RR, LSUB
        .quad      ZERO, RFILE
        .quad      QERRUR
        .quad      LDUP, ZEQU, LIT, -EPIPE, LAND # Presumably end of pipe.
        .quad      QERRUR
        .quad      TIB, FETCH, SWAP, FROMR, PLUS
        .quad      REMAIND, TSTOR
        .quad      SEMIS
#
#

#------------------------------------
#       SYSTEM DEPENDANT CHAR I/O
#------------------------------------

#

# All I/O goes through the modern device (Unix-standard)
# device I/O. Code fields are filled in during bootup. 
# Lower case labels starting with "c_.." are c-supplied facilities.

#  **************
#  *   ACCEPT   *
#  **************
#
    .align     3
N_ACCEP:   .quad      6
        .ascii      "ACCEPT"
    .align     3
ACCEP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    REFTIB-(CW*(C_HOFFSET))
        .quad    N_ACCEP
X_ACCEP:

        .quad      PACCEP
        .quad      TSWAP, ROT, MIN
        .quad      LDUP, TOR, LMOVE, FROMR
        .quad      SEMIS
#

#  ****************
#  *   (ACCEPT)   *
#  ****************
#
    .align     3
N_PACCEP:   .quad      8
        .ascii      "(ACCEPT)"
    .align     3
PACCEP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ACCEP-(CW*(C_HOFFSET))
        .quad    N_PACCEP
X_PACCEP:

PACCEP2:
#        .quad      NOLF
#        .quad       LIT, 'a', EMIT
        .quad      REMAIND
        .quad      TFET
        .quad      LIT, ALF, SINDEX
        .quad      ZEQU
        .quad      ZBRAN
        .quad      PACCEP1-.-CW
#        .quad      RETOBO
        .quad      REMAIND, TFET
        .quad      TIB, FETCH
        .quad      SWAP, LMOVE
        .quad      TIB, FETCH
        .quad      REMAIND, CELLP, STORE
       .quad      REFTIB
        .quad      BRAN
        .quad      PACCEP2-.-CW
PACCEP1:
#        .quad      SPLOFF
       .quad      REMAIND, TFET
        .quad      LIT, ALF, SSPLIT
        .quad      TSWAP, REMAIND, TSTOR
        .quad      SEMIS


#  ***********
#  *   KEY   *
#  ***********
#
    .align     3
N_KEY:   .quad      3
        .ascii      "KEY"
    .align     3
KEY:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PACCEP-(CW*(C_HOFFSET))
        .quad    N_KEY
X_KEY:

        .quad      ONE, LIT, RAWIO, STTERM # Do not wait for CR
        .quad      ZERO, SPFET     # Expect single key on stack
        .quad      ZERO            # Standard input
        .quad      SWAP, ONE       # Buffer and length
        .quad      LIT, read, LINOS
        .quad      LDUP, QERRUR
        .quad      ZEQU, LIT, -EPIPE, LAND, QERRUR # Presumably end of pipe.
        .quad      ONE, LIT, RAWIO, STTERM       # Toggle back
        .quad      SEMIS
#

#  ************
#  *   KEY?   *
#  ************
#
    .align     3
N_KEYQ:   .quad      4
        .ascii      "KEY?"
    .align     3
KEYQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    KEY-(CW*(C_HOFFSET))
        .quad    N_KEYQ
X_KEYQ:

        .quad      ZERO, LIT, RAWIO, STTERM
        .quad      ONE     # # of highest channel to watch.
        .quad      LIT, RFDS   # Waiting for input 
        .quad      ONE, OVER, STORE # Waiting for standard in.
        .quad      ZERO, ZERO  # Not output, not events.
        .quad      ZERO, ZERO
        .quad      LIT, TV, TSTOR # Time out of zero. See MS.
        .quad      LIT, TV
        .quad      LIT, select, LINOS5
        .quad      LDUP,  QERRUR
        .quad      NEGATE        # 1 -> flag.
        .quad      ZERO, LIT, RAWIO, STTERM
        .quad      SEMIS
        .align      4
RFDS:   .space    128     #32 channels maximum.
#

#  ************
#  *   TYPE   *
#  ************
#
    .align     3
N_LTYPE:   .quad      4
        .ascii      "TYPE"
    .align     3
LTYPE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    KEYQ-(CW*(C_HOFFSET))
        .quad    N_LTYPE
X_LTYPE:

        .quad      LDUP, LOUT, PSTORE
        .quad      ONE, WFILE, DROP
        .quad      SEMIS
#

#  *************
#  *   ETYPE   *
#  *************
#
    .align     3
N_ETYPE:   .quad      5
        .ascii      "ETYPE"
    .align     3
ETYPE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LTYPE-(CW*(C_HOFFSET))
        .quad    N_ETYPE
X_ETYPE:

        .quad      LDUP, LOUT, PSTORE
        .quad      TWO, WFILE, DROP
        .quad      SEMIS
#

#  **************
#  *   TERMIO   *
#  **************
#
    .align     3
N_TERMIO:   .quad      6
        .ascii      "TERMIO"
    .align     3
TERMIO:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ETYPE-(CW*(C_HOFFSET))
        .quad    N_TERMIO
X_TERMIO:

        .space    SIZE_TERMIO    # Filled induring cold boot.
#

#  ****************
#  *   SET-TERM   *
#  ****************
#
    .align     3
N_STTERM:   .quad      8
        .ascii      "SET-TERM"
    .align     3
STTERM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TERMIO-(CW*(C_HOFFSET))
        .quad    N_STTERM
X_STTERM:

        .quad      LIT, (TERMIO+(CW*(PH_OFFSET-C_HOFFSET))) + C_CELLSIZE*3
        .quad      SWAP, TOGGL
        .quad      LIT, (TERMIO+(CW*(PH_OFFSET-C_HOFFSET))) + C_CELLSIZE*4 + TERMIO_VMIN
        .quad      CSTOR
        .quad      ZERO, LIT, TCSETS, TERMIO
        .quad      LIT, ioctl, LINOS, QERRUR
        .quad      SEMIS
#
 #


#  ************
#  *   EMIT   *
#  ************
#
    .align     3
N_EMIT:   .quad      4
        .ascii      "EMIT"
    .align     3
EMIT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    STTERM-(CW*(C_HOFFSET))
        .quad    N_EMIT
X_EMIT:

        .quad      SPFET, ONE, LTYPE
        .quad      DROP
        .quad      SEMIS
#
#
#
#

        .eject
#------------------------------------
#       SYSTEM DEPENDANT DISK I/O
#------------------------------------


#  ******************
#  *   DISK-ERROR   *
#  ******************
#
    .align     3
N_DERR:   .quad      10
        .ascii      "DISK-ERROR"
    .align     3
DERR:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    EMIT-(CW*(C_HOFFSET))
        .quad    N_DERR
X_DERR:

        .quad      -1
#


#  ******************
#  *   BLOCK-FILE   *
#  ******************
#
    .align     3
N_BLFL:   .quad      10
        .ascii      "BLOCK-FILE"
    .align     3
BLFL:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DERR-(CW*(C_HOFFSET))
        .quad    N_BLFL
X_BLFL:

        .quad      9
        .ascii      "forth.lab"
        .space    30254-9               # Allow for some path
#

#  ********************
#  *   BLOCK-HANDLE   *
#  ********************
#
    .align     3
N_BHAN:   .quad      12
        .ascii      "BLOCK-HANDLE"
    .align     3
BHAN:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BLFL-(CW*(C_HOFFSET))
        .quad    N_BHAN
X_BHAN:

        .quad      -1
#

#  *******************
#  *   ?DISK-ERROR   *
#  *******************
#
    .align     3
N_QDSKER:   .quad      11
        .ascii      "?DISK-ERROR"
    .align     3
QDSKER:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BHAN-(CW*(C_HOFFSET))
        .quad    N_QDSKER
X_QDSKER:

        .quad      LIT, 8, QERR
        .quad      SEMIS
#
#


#  ******************
#  *   BLOCK-INIT   *
#  ******************
#
    .align     3
N_BLINI:   .quad      10
        .ascii      "BLOCK-INIT"
    .align     3
BLINI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QDSKER-(CW*(C_HOFFSET))
        .quad    N_BLINI
X_BLINI:

        .quad      BLFL, SFET
        .quad      ROT
        .quad      OFILE
        .quad      ZEQU, NEGATE  # 0 if disk problems, 1 if not.
        .quad      LWARN, FETCH, MIN # Affect WARNING only if it was 1.
        .quad      LWARN, STORE
        .quad      BHAN, STORE
        .quad      SEMIS
#

#  ******************
#  *   BLOCK-EXIT   *
#  ******************
#
    .align     3
N_BLEXI:   .quad      10
        .ascii      "BLOCK-EXIT"
    .align     3
BLEXI:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BLINI-(CW*(C_HOFFSET))
        .quad    N_BLEXI
X_BLEXI:

        .quad      FLUSH
        .quad      BHAN, FETCH
        .quad      CFILE
        .quad      ZERO, LWARN, FETCH, MIN
        .quad      LWARN, STORE            # Affect WARNING only if it was 1.
        .quad      LIT, -1, BHAN, STORE    #Regardless of close errors.
        .quad      QDSKER
        .quad      SEMIS
#

#  ************
#  *   SEEK   *
#  ************
#
    .align     3
N_SEEK:   .quad      4
        .ascii      "SEEK"
    .align     3
SEEK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BLEXI-(CW*(C_HOFFSET))
        .quad    N_SEEK
X_SEEK:

        .quad      BBUF
        .quad      USTAR
        .quad      BHAN, FETCH
        .quad      PFILE           # Disk position.
        .quad      QDSKER
        .quad      SEMIS
#

#  ***********
#  *   R\W   *
#  ***********
#
    .align     3
N_RSLW:   .quad      3
        .ascii      "R\\W"
    .align     3
RSLW:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SEEK-(CW*(C_HOFFSET))
        .quad    N_RSLW
X_RSLW:

        .quad      TOR # blk on top
        .quad      SEEK # That's done
        .quad      BBUF
        .quad      BHAN, FETCH
        .quad      FROMR
        .quad      ZBRAN
        .quad      RSLW1-.-CW
        .quad      RFILE           # Disk read 
        .quad      SWAP, DROP
        .quad      BRAN
        .quad      RSLW2-.-CW
RSLW1:  .quad      WFILE           # Disk write
RSLW2:
        .quad      QDSKER
        .quad      SEMIS
#
#

#  *************
#  *   SHELL   *
#  *************
#
    .align     3
N_SHELL:   .quad      5
        .ascii      "SHELL"
    .align     3
SHELL:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    RSLW-(CW*(C_HOFFSET))
        .quad    N_SHELL
X_SHELL:

                 .quad      7
        .ascii      "/bin/sh"
        
        .space    30254-9               # Allow for some path
#


#  **************
#  *   SYSTEM   *
#  **************
#
    .align     3
N_SYSTEM:   .quad      6
        .ascii      "SYSTEM"
    .align     3
SYSTEM:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SHELL-(CW*(C_HOFFSET))
        .quad    N_SYSTEM
X_SYSTEM:

        .quad      LIT, COMBUF, SSTOR, ZERO, LIT, COMBUF, CHAPP
        .quad      ZERO, SHELL, CHAPP, LIT, -1, SHELL, PSTORE
        .quad      X, X, X, LIT, fork, LINOS
        .quad      LDUP, QERRUR
        .quad      LDUP, ZEQU
        .quad      ZBRAN
        .quad      SYSTEM1-.-CW
        .quad      SHELL, CELLP, LIT, SYSARGS
#  Get environment vector
        .quad      ARGS, FETCH, SFET, ONEP, LCELLS, PLUS
        .quad      LIT, execve, LINOS
        .quad      LIT, -127, QERRUR, BYE
SYSTEM1:
        .quad      LDUP
        .quad      LIT, STATUS, ZERO, ZERO, X
        .quad      LIT, wait4, LINOS5
        .quad      LDUP
        .quad      LIT, EINTR, EQUAL
        .quad      BRAN
        .quad      SYSTEM2-.-CW
        .quad      DROP
        .quad      ZBRAN
        .quad      SYSTEM1-.-CW
SYSTEM2:
        .quad      QERRUR
        .quad      TDROP
        .quad      SEMIS
#
STATUS:  .quad     0
SYSARG2: .ascii    "-c\0"
COMBUF:  .space    CW+256  #One cell for high level string manipulation.
SYSARGS: .quad   (SHELL+(CW*(PH_OFFSET-C_HOFFSET)))+CW, SYSARG2, COMBUF + CW, 0
#
 #
#
#
#
#


#  ***********
#  *   [']   *
#  ***********
#
    .align     3
N_BTICK:   .quad      3
        .ascii      "[']"
    .align     3
BTICK:        .quad    DOCOL
        .quad   (TICK+(CW*(PH_OFFSET-C_HOFFSET)))
        .quad    B_IMMED
        .quad    SYSTEM-(CW*(C_HOFFSET))
        .quad    N_BTICK
X_BTICK:

#
#

#  ******************
#  *   FORGET-VOC   *
#  ******************
#
    .align     3
N_FORGV:   .quad      10
        .ascii      "FORGET-VOC"
    .align     3
FORGV:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BTICK-(CW*(C_HOFFSET))
        .quad    N_FORGV
X_FORGV:

        .quad      TDUP
        .quad      SWAP
        .quad      ULESS
        .quad      ZBRAN
        .quad      FORGV1-.-CW
#  Forget part of contents.
        .quad      SWAP
        .quad      TOR
        .quad      TWID
        .quad      LDUP
FORGV3:
        .quad      TLFA,FETCH    # Next voc
        .quad      LDUP
        .quad      RR
        .quad      ULESS
        .quad      ZBRAN
        .quad      FORGV3-.-CW
        .quad      SWAP
        .quad      TLFA
        .quad      STORE
        .quad      FROMR
        .quad      BRAN
        .quad      FORGV2-.-CW
FORGV1:
#        Vocabulary itself is also forgotten.
        .quad      TVFA
        .quad      FETCH     # Unlink by linking next vocabulary.
        .quad      VOCL
        .quad      STORE
        .quad      ONLY, FORTH
        .quad      DEFIN
FORGV2: .quad      SEMIS
#

#  **************
#  *   FORGET   *
#  **************
#
    .align     3
N_FORG:   .quad      6
        .ascii      "FORGET"
    .align     3
FORG:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FORGV-(CW*(C_HOFFSET))
        .quad    N_FORG
X_FORG:

        .quad      TICK
        .quad      LDUP
        .quad      FENCE
        .quad      FETCH
        .quad      LESS
        .quad      LIT, 21, QERR
        .quad      LIT,FORGV
        .quad      FORV
        .quad      TNFA, FETCH, LDP, STORE
        .quad      SEMIS
#

#  *************
#  *   (BACK   *
#  *************
#
    .align     3
N_PBACK:   .quad      5
        .ascii      "(BACK"
    .align     3
PBACK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FORG-(CW*(C_HOFFSET))
        .quad    N_PBACK
X_PBACK:

        .quad      HERE
        .quad      SEMIS
#

#  *************
#  *   BACK)   *
#  *************
#
    .align     3
N_BACKP:   .quad      5
        .ascii      "BACK)"
    .align     3
BACKP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PBACK-(CW*(C_HOFFSET))
        .quad    N_BACKP
X_BACKP:

        .quad      HERE
        .quad      CELLP
        .quad      LSUB
        .quad      COMMA
        .quad      SEMIS
#

#  ****************
#  *   (FORWARD   *
#  ****************
#
    .align     3
N_PFORWARD:   .quad      8
        .ascii      "(FORWARD"
    .align     3
PFORWARD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BACKP-(CW*(C_HOFFSET))
        .quad    N_PFORWARD
X_PFORWARD:

        .quad      HERE
        .quad      X
        .quad      COMMA
        .quad      SEMIS
#

#  ****************
#  *   FORWARD)   *
#  ****************
#
    .align     3
N_FORWARDP:   .quad      8
        .ascii      "FORWARD)"
    .align     3
FORWARDP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PFORWARD-(CW*(C_HOFFSET))
        .quad    N_FORWARDP
X_FORWARDP:

        .quad      HERE
        .quad      OVER
        .quad      CELLP
        .quad      LSUB
        .quad      SWAP
        .quad      STORE
        .quad      SEMIS
#

#  *************
#  *   BEGIN   *
#  *************
#
    .align     3
N_BEGIN:   .quad      5
        .ascii      "BEGIN"
    .align     3
BEGIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    FORWARDP-(CW*(C_HOFFSET))
        .quad    N_BEGIN
X_BEGIN:

        .quad      PBACK
        .quad      QCOMP, ONE
        .quad      SEMIS
#

#  ************
#  *   THEN   *
#  ************
#
    .align     3
N_THEN:   .quad      4
        .ascii      "THEN"
    .align     3
THEN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    BEGIN-(CW*(C_HOFFSET))
        .quad    N_THEN
X_THEN:

        .quad      QCOMP, TWO, QPAIR
        .quad      FORWARDP
        .quad      SEMIS
#

#  **********
#  *   DO   *
#  **********
#
    .align     3
N_DO:   .quad      2
        .ascii      "DO"
    .align     3
DO:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    THEN-(CW*(C_HOFFSET))
        .quad    N_DO
X_DO:

         .quad      LIT, XDO, COMMA, PFORWARD, PBACK
        .quad      LIT,3    # Magic number
        .quad      SEMIS
#

#  ***********
#  *   ?DO   *
#  ***********
#
    .align     3
N_QDO:   .quad      3
        .ascii      "?DO"
    .align     3
QDO:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    DO-(CW*(C_HOFFSET))
        .quad    N_QDO
X_QDO:

         .quad      LIT, XQDO, COMMA, PFORWARD, PBACK
        .quad      LIT,3    # Magic number
        .quad      SEMIS
#

#  ************
#  *   LOOP   *
#  ************
#
    .align     3
N_LLOOP:   .quad      4
        .ascii      "LOOP"
    .align     3
LLOOP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    QDO-(CW*(C_HOFFSET))
        .quad    N_LLOOP
X_LLOOP:

        .quad      LIT, 3, QPAIR
        .quad      LIT, XLOOP, COMMA, BACKP
        .quad      FORWARDP # For DO to push the leave address.
        .quad      SEMIS
#

#  *************
#  *   +LOOP   *
#  *************
#
    .align     3
N_PLOOP:   .quad      5
        .ascii      "+LOOP"
    .align     3
PLOOP:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    LLOOP-(CW*(C_HOFFSET))
        .quad    N_PLOOP
X_PLOOP:

        .quad      LIT, 3, QPAIR
        .quad      LIT, XPLOO, COMMA, BACKP
        .quad      FORWARDP # For DO to push the leave address.
        .quad      SEMIS
#

#  *************
#  *   UNTIL   *
#  *************
#
    .align     3
N_UNTIL:   .quad      5
        .ascii      "UNTIL"
    .align     3
UNTIL:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    PLOOP-(CW*(C_HOFFSET))
        .quad    N_UNTIL
X_UNTIL:

        .quad      ONE, QPAIR
        .quad      LIT, ZBRAN, COMMA, BACKP
        .quad      SEMIS
#

#  *************
#  *   AGAIN   *
#  *************
#
    .align     3
N_AGAIN:   .quad      5
        .ascii      "AGAIN"
    .align     3
AGAIN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    UNTIL-(CW*(C_HOFFSET))
        .quad    N_AGAIN
X_AGAIN:

        .quad      ONE, QPAIR
        .quad      LIT, BRAN, COMMA, BACKP
        .quad      SEMIS
#

#  **************
#  *   REPEAT   *
#  **************
#
    .align     3
N_REPEA:   .quad      6
        .ascii      "REPEAT"
    .align     3
REPEA:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    AGAIN-(CW*(C_HOFFSET))
        .quad    N_REPEA
X_REPEA:

        .quad      ONE, QPAIR   # Matches BEGIN ?
        .quad      LIT, BRAN, COMMA, BACKP
        .quad      QCOMP, LIT, 4, QPAIR # Matches WHILE ?
        .quad      FORWARDP # WHILE target. 
        .quad      SEMIS
#

#  **********
#  *   IF   *
#  **********
#
    .align     3
N_LIF:   .quad      2
        .ascii      "IF"
    .align     3
LIF:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    REPEA-(CW*(C_HOFFSET))
        .quad    N_LIF
X_LIF:

        .quad      LIT, ZBRAN, COMMA, PFORWARD
        .quad      TWO     # Magic number
        .quad      SEMIS
#

#  ************
#  *   ELSE   *
#  ************
#
    .align     3
N_LELSE:   .quad      4
        .ascii      "ELSE"
    .align     3
LELSE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    LIF-(CW*(C_HOFFSET))
        .quad    N_LELSE
X_LELSE:

        .quad      QCOMP, TWO, QPAIR
        .quad      LIT, BRAN, COMMA, PFORWARD
        .quad      SWAP
        .quad      FORWARDP
        .quad      TWO     # Magic number
        .quad      SEMIS
#

#  *************
#  *   WHILE   *
#  *************
#
    .align     3
N_LWHILE:   .quad      5
        .ascii      "WHILE"
    .align     3
LWHILE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    B_IMMED
        .quad    LELSE-(CW*(C_HOFFSET))
        .quad    N_LWHILE
X_LWHILE:

        .quad      TOR    #  Save backward target. 
        .quad      TOR
        .quad      LIT, ZBRAN, COMMA, PFORWARD
        .quad      LIT, 4 # Magic number
        .quad      FROMR
        .quad      FROMR
        .quad      SEMIS
#

#  **************
#  *   SPACES   *
#  **************
#
    .align     3
N_SPACES:   .quad      6
        .ascii      "SPACES"
    .align     3
SPACES:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LWHILE-(CW*(C_HOFFSET))
        .quad    N_SPACES
X_SPACES:

        .quad      ZERO
        .quad      MAX
        .quad      ZERO
        .quad     XQDO
        .quad      SPAX1-.-CW
SPAX2:  .quad      SPACE
        .quad     XLOOP
        .quad      SPAX2-.-CW    #LOOP
SPAX1:
        .quad      SEMIS
#

#  **********
#  *   <#   *
#  **********
#
    .align     3
N_BDIGS:   .quad      2
        .ascii      "<#"
    .align     3
BDIGS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SPACES-(CW*(C_HOFFSET))
        .quad    N_BDIGS
X_BDIGS:

        .quad      PAD
        .quad      HLD
        .quad      STORE
        .quad      SEMIS
#

#  **********
#  *   #>   *
#  **********
#
    .align     3
N_EDIGS:   .quad      2
        .ascii      "#>"
    .align     3
EDIGS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BDIGS-(CW*(C_HOFFSET))
        .quad    N_EDIGS
X_EDIGS:

        .quad      DROP
        .quad      DROP
        .quad      HLD
        .quad      FETCH
        .quad      PAD
        .quad      OVER
        .quad      LSUB
        .quad      SEMIS
#

#  ************
#  *   SIGN   *
#  ************
#
    .align     3
N_SIGN:   .quad      4
        .ascii      "SIGN"
    .align     3
SIGN:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    EDIGS-(CW*(C_HOFFSET))
        .quad    N_SIGN
X_SIGN:

        .quad      ZLESS
        .quad      ZBRAN
        .quad      SIGN1-.-CW #IF
        .quad      LIT,0x2D
        .quad      HOLD    #THEN
SIGN1:  .quad      SEMIS
#

#  *********
#  *   #   *
#  *********
#
    .align     3
N_DIG:   .quad      1
        .ascii      "#"
    .align     3
DIG:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SIGN-(CW*(C_HOFFSET))
        .quad    N_DIG
X_DIG:

        .quad      BASE
        .quad      FETCH
        .quad      MSMOD
        .quad      ROT
        .quad      LIT,9
        .quad      OVER
        .quad      LESS
        .quad      ZBRAN
        .quad      DIG1-.-CW  #IF
        .quad      LIT,7
        .quad      PLUS    #THEN
DIG1:   .quad      LIT,0x30
        .quad      PLUS
        .quad      HOLD
        .quad      SEMIS
#

#  **********
#  *   #S   *
#  **********
#
    .align     3
N_DIGS:   .quad      2
        .ascii      "#S"
    .align     3
DIGS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DIG-(CW*(C_HOFFSET))
        .quad    N_DIGS
X_DIGS:

DIGS1:  .quad      DIG     #BEGIN
        .quad      OVER
        .quad      OVER
        .quad      LOR
        .quad      ZEQU
        .quad      ZBRAN
        .quad      DIGS1-.-CW #UNTIL
        .quad      SEMIS
#

#  *************
#  *   (D.R)   *
#  *************
#
    .align     3
N_PDDOTR:   .quad      5
        .ascii      "(D.R)"
    .align     3
PDDOTR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DIGS-(CW*(C_HOFFSET))
        .quad    N_PDDOTR
X_PDDOTR:

        .quad      TOR
        .quad      SWAP
        .quad      OVER
        .quad      DABS
        .quad      BDIGS
        .quad      DIGS
        .quad      ROT
        .quad      SIGN
        .quad      EDIGS
        .quad      FROMR
        .quad      OVER
        .quad      LSUB
        .quad      SPACES
        .quad      SEMIS
#

#  ***********
#  *   D.R   *
#  ***********
#
    .align     3
N_DDOTR:   .quad      3
        .ascii      "D.R"
    .align     3
DDOTR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    PDDOTR-(CW*(C_HOFFSET))
        .quad    N_DDOTR
X_DDOTR:

        .quad      PDDOTR
        .quad      LTYPE
        .quad      SEMIS
#

#  **********
#  *   .R   *
#  **********
#
    .align     3
N_DOTR:   .quad      2
        .ascii      ".R"
    .align     3
DOTR:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DDOTR-(CW*(C_HOFFSET))
        .quad    N_DOTR
X_DOTR:

        .quad      TOR
        .quad      STOD
        .quad      FROMR
        .quad      DDOTR
        .quad      SEMIS
#

#  **********
#  *   D.   *
#  **********
#
    .align     3
N_DDOT:   .quad      2
        .ascii      "D."
    .align     3
DDOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DOTR-(CW*(C_HOFFSET))
        .quad    N_DDOT
X_DDOT:

        .quad      ZERO
        .quad      DDOTR
        .quad      SPACE
        .quad      SEMIS
#

#  *********
#  *   .   *
#  *********
#
    .align     3
N_DOT:   .quad      1
        .ascii      "."
    .align     3
DOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DDOT-(CW*(C_HOFFSET))
        .quad    N_DOT
X_DOT:

        .quad      STOD
        .quad      DDOT
        .quad      SEMIS
#

#  *********
#  *   ?   *
#  *********
#
    .align     3
N_QUES:   .quad      1
        .ascii      "?"
    .align     3
QUES:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DOT-(CW*(C_HOFFSET))
        .quad    N_QUES
X_QUES:

        .quad      FETCH
        .quad      DOT
        .quad      SEMIS
#

#  **********
#  *   U.   *
#  **********
#
    .align     3
N_UDOT:   .quad      2
        .ascii      "U."
    .align     3
UDOT:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    QUES-(CW*(C_HOFFSET))
        .quad    N_UDOT
X_UDOT:

        .quad      ZERO
        .quad      DDOT
        .quad      SEMIS
#

#  *****************
#  *   FOR-WORDS   *
#  *****************
#
    .align     3
N_FORW:   .quad      9
        .ascii      "FOR-WORDS"
    .align     3
FORW:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    UDOT-(CW*(C_HOFFSET))
        .quad    N_FORW
X_FORW:

        .quad      SWAP
        .quad      TOR
        .quad      TOR
FORW1:  .quad      FROMR
        .quad      RR
        .quad      OVER
        .quad      TLFA
        .quad      FETCH
        .quad      TOR
        .quad      EXEC
        .quad      RR
        .quad      ZEQU
        .quad      ZBRAN
        .quad      FORW1-.-CW
        .quad      RDROP
        .quad      RDROP
        .quad      SEMIS
#

#  ****************
#  *   FOR-VOCS   *
#  ****************
#
    .align     3
N_FORV:   .quad      8
        .ascii      "FOR-VOCS"
    .align     3
FORV:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FORW-(CW*(C_HOFFSET))
        .quad    N_FORV
X_FORV:

        .quad      TOR
        .quad      VOCL
        .quad      FETCH
        .quad      TOR
FORV1:  .quad      FROMR
        .quad      RR
        .quad      OVER
        .quad      TVFA
        .quad      FETCH
        .quad      TOR
        .quad      EXEC
        .quad      RR
        .quad      ZEQU
        .quad      ZBRAN
        .quad      FORV1-.-CW
        .quad      RDROP
        .quad      RDROP
        .quad      SEMIS
#

#  *************
#  *   WORDS   *
#  *************
#
    .align     3
N_WORDS:   .quad      5
        .ascii      "WORDS"
    .align     3
WORDS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    FORV-(CW*(C_HOFFSET))
        .quad    N_WORDS
X_WORDS:

        .quad      CSLL
        .quad      LOUT
        .quad      STORE
        .quad      LIT, IDDOT
        .quad      SEARCH
        .quad      FETCH
        .quad      FORW
        .quad      SEMIS
#

#  *****************
#  *   EXIT-CODE   *
#  *****************
#
    .align     3
N_XCODE:   .quad      9
        .ascii      "EXIT-CODE"
    .align     3
XCODE:        .quad    DOVAR
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    WORDS-(CW*(C_HOFFSET))
        .quad    N_XCODE
X_XCODE:

        .quad      0
#


#  ***********
#  *   BYE   *
#  ***********
#
    .align     3
N_BYE:   .quad      3
        .ascii      "BYE"
    .align     3
BYE:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    XCODE-(CW*(C_HOFFSET))
        .quad    N_BYE
X_BYE:

# Exit to linux, with okay status. 
        .quad      XCODE, FETCH, X, X, ONE, LINOS
        .quad      SEMIS   #Unnecessary, but helpful for decompilation.
#
#

#  ************
#  *   LIST   *
#  ************
#
    .align     3
N_LLIST:   .quad      4
        .ascii      "LIST"
    .align     3
LLIST:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    BYE-(CW*(C_HOFFSET))
        .quad    N_LLIST
X_LLIST:

        .quad      SCR,STORE
        .quad      SKIP
         .quad      6
SB5: .ascii      "SCR # "
       .align     3
        .quad      LIT, SB5
        .quad      LIT, 6
        .quad      LTYPE
        .quad      BASE, FETCH
        .quad      DECA
        .quad      SCR, FETCH, DOT
        .quad      BASE, STORE
        .quad      SCR, FETCH, BLOCK
        .quad      LIT,1024
LLIST1: .quad      LIT, ALF, SSPLIT
        .quad      CR, LTYPE
        .quad      OVER,ZEQU #DUP would not show a last empty line!
        .quad      ZBRAN
        .quad      LLIST1-.-CW
        .quad      TDROP
        .quad      SEMIS
#

#  *************
#  *   INDEX   *
#  *************
#
    .align     3
N_INDEX:   .quad      5
        .ascii      "INDEX"
    .align     3
INDEX:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    LLIST-(CW*(C_HOFFSET))
        .quad    N_INDEX
X_INDEX:

        .quad      LIT,AFF
        .quad      EMIT,CR
        .quad      ONEP,SWAP
        .quad     XDO
        .quad      INDE9-.-CW
INDE1:  .quad      CR,IDO
        .quad      LIT,3
        .quad      DOTR,SPACE
        .quad      ZERO,IDO
        .quad      PLINE, LTYPE, KEYQ
        .quad      ZBRAN
        .quad      INDE2-.-CW
        .quad      LLEAV
INDE2:  .quad     XLOOP
        .quad      INDE1-.-CW
INDE9:
        .quad      SEMIS
#

#  **********
#  *   .S   *
#  **********
#
    .align     3
N_DOTS:   .quad      2
        .ascii      ".S"
    .align     3
DOTS:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    INDEX-(CW*(C_HOFFSET))
        .quad    N_DOTS
X_DOTS:

        .quad      CR
        .quad      LIT, 'S', EMIT
        .quad      LIT, ASO, EMIT
        .quad      SPACE
        .quad      SPFET, SZERO, FETCH
DOC2:   .quad      OVER, OVER,  EQUAL, ZEQU
        .quad      ZBRAN
        .quad      DOC1-.-CW
        .quad      ZERO, CELLP, LSUB, LDUP, FETCH, DOT
        .quad      BRAN
        .quad      DOC2-.-CW
DOC1:    .quad DROP, DROP
        .quad      LIT, ASC, EMIT
        .quad SEMIS
#

#  ********************
#  *   ENVIRONMENT?   *
#  ********************
#
    .align     3
N_ENVQ:   .quad      12
        .ascii      "ENVIRONMENT?"
    .align     3
ENVQ:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    DOTS-(CW*(C_HOFFSET))
        .quad    N_ENVQ
X_ENVQ:

        .quad      ZERO, RESULT, STORE
        .quad      LIT, MATCHING
        .quad      LIT, ENV
        .quad      TWID, FORW, TDROP
        .quad      RESULT, FETCH
        .quad      LDUP
        .quad      ZBRAN
        .quad      ENVQ1-.-CW
        .quad      EXEC
        .quad      LIT, -1
        .quad      BRAN
        .quad      ENVQ2-.-CW
ENVQ1:  .quad      DROP, ZERO
ENVQ2:
        .quad      SEMIS
#


#  *************
#  *   TRIAD   *
#  *************
#
    .align     3
N_TRIAD:   .quad      5
        .ascii      "TRIAD"
    .align     3
TRIAD:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    ENVQ-(CW*(C_HOFFSET))
        .quad    N_TRIAD
X_TRIAD:

        .quad      LIT,AFF
        .quad      EMIT
        .quad      LIT,3
        .quad      SLASH
        .quad      LIT,3
        .quad      STAR
        .quad      LIT,3
        .quad      OVER,PLUS
        .quad      SWAP
        .quad     XDO
        .quad      TRIA9-.-CW
TRIA1:  .quad      CR,IDO
        .quad      LLIST
        .quad      KEYQ
        .quad      ZBRAN
        .quad      TRIA2-.-CW
        .quad      LLEAV   #LEAVE
TRIA2:  .quad     XLOOP
        .quad      TRIA1-.-CW    #THEN
TRIA9:
        .quad      CR
        .quad      ZERO, MESS
        .quad      SEMIS
#
#
# This word is not even fig!

#  ***************
#  *   .SIGNON   *
#  ***************
#
    .align     3
N_SIGNON:   .quad      7
        .ascii      ".SIGNON"
    .align     3
SIGNON:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    TRIAD-(CW*(C_HOFFSET))
        .quad    N_SIGNON
X_SIGNON:

# PRINT CPU TYPE (8088)
        .quad      CR
        .quad      BASE,FETCH
        .quad      LIT,36, BASE,STORE
        .quad      CPU, DDOT
        .quad      BASE,STORE
#
        .quad      LNAME, LTYPE, SPACE
        .quad      LVERSION, LTYPE, SPACE
        .quad      CR
        .quad      SEMIS
#
#
#**** LAST DICTIONARY WORD ****

#  ************
#  *   TASK   *
#  ************
#
    .align     3
N_TASK:   .quad      4
        .ascii      "TASK"
    .align     3
TASK:        .quad    DOCOL
        .quad   . + (CW*(PH_OFFSET-D_HOFFSET))
        .quad    0
        .quad    SIGNON-(CW*(C_HOFFSET))
        .quad    N_TASK
X_TASK:

        .quad      SEMIS
#
 #

.if 0

The remaining memory ( up to 'EM' ) is
used for:

        1. EXTENSION DICTIONARY
        2. PARAMETER STACK
        3. TERMINAL INPUT BUFFER
        4. RETURN STACK
        5. USER VARIABLE AREA
        6. DISK BUFFERS (UNLESS REQUIRED <1 MBYTE)


.endif


#       This is the proper way to do it.
#       No memory addresses should be arrived at through equates.
#       However now we must teach the linker to keep the
#       two sections together.

FORTHSIZE       =   . -ORG0
         .section dictionary,"awx", @nobits

INITDP:                 #  It may be that it is not consecutive with TASK.
                        #  Because of bad linking, resulting in a unusable Forth.
        BUFFERSIZE      =  (KBBUF+2*CW)*NBUF

       .space    EM - FORTHSIZE - RTS - US - BUFFERSIZE 
INITS0:                        # Growns down
STRTIB: .space    RTS            # Start return stack area
INITR0:                        # Grows down
STRUSA: .space    US             # User area
BUF1:   .space    BUFFERSIZE     # FIRST DISK BUFFER
ACTUAL_EM:  # Differs from EM if code is relocated.
#
#

 #    ENDS
        .eject
.if 0

  MISC. NOTES AND SCATTERED THOUGHTS

- Remember that all the FORTH words in this version are
  upper case letters.  Use <CAPS LOCK> when in FORTH.

- Subscribe to FORTH Dimensions.  It is a valuable source
  of system and application ideas.  Talking with fellow
  FORTH programmers is sure to stir up some exciting ideas.
  Consider joining a FIG chapter.  See the back of FORTH
  Dimensions for more info.

.endif

# Define the entry point, not valid for auto booting.
        #     ORIG

























#




